/*********************************************************************/
/*      WRAPPER TEST DRIVER FOR IMS-DC TRANSACTIONS                  */

/* ----- standard Includes ------- */
   #pragma runopts(env(ims),plist(ims))
   #include  <ims.h>
   #include  <stdio.h>
   #include  <stdlib.h>
   #include  <string.h>
   #include  <amcdef.h>
   #include  <cvgipak.h>
   #include  <cvgisys.h>
   #include  <cvgipvb.h>
   #include  <cvgifbib.h>
   #include  <stdas3.h>
   #include  <stubstd.h>

/* ----- DVG Includes ------------ */
/* #include <tranin.h>     */
/* #include <tranout.h>    */
/* #include <dvg1in.h>     */
/* #include <dvg1out.h>    */
/* #include <logkopf.h>    */
/* intended for Host Test  */

/* ------- Constant Definitions --------- */

 #define LAENGE_TRANIN_KOPF   34
 #define LAENGE_TRANIN_DATA   76
 #define LAENGE_TRANOUT_KOPF  34
 #define LAENGE_TRANOUT_DATA  76
 #define LAENGE_NAME           8
 #define LAENGE_PSB           20
 #define LAENGE_PCB           32
 #define LAENGE_API         1058
 #define MAX_MSG_LNG        1028
 #define MAX_FIELDS           20
 #define BLANK                ' '

/* ----- Global Data Structures --------- */

/*  struct of WRAPPING User Interface     */
    char    User_PSB20;
    struct 
       char    User_Trans8;
       char    anzFelder2;
       char    Bediener8;
       char    Lterm8;
       char    User_Msg_Nr4;
       char    User_Msg1028;
     USER_API;

/*  struct IMS_PSB Test_Params;           */
    typedef struct  
       unsigned long Anzahl;
       char Funktion4;
       unsigned long PCB_Adr;
       unsigned long IO_Area_Adr;
       char Format4;
     IMS_PSB;

/*  struct IMS_PCB                        */
    typedef struct  
       char DB_Name8;
       char Seg_Stufe2;
       char Status_Code2;
       char Option4;
       char Filler4;
       char Seg_Name8;
       unsigned long Key_Lng;
       unsigned long Seg_Nr;
       char Keys8;
     IMS_PCB;

/*  struct of TRANIN User Interface   */
    struct  
     struct 
        short ils;
        short ires;
        short segnr;
        short tls;
        char  tvk;
        char  tfnr;
        char  trans9;
        char  transx2;
        char  innr4;
        char  term4;
        char  tart;
        char  tkomp8;
        char  wun;
        char  steuer;
      Tranin_Kopf;
     struct 
        short dls;
        char  dvk;
        char  dfnr;
        char  Tranin_Data72;
      Tranin_Feld20;
 TRANIN;
     char** PCB_Tptr;
     char*  PCB_Test4;
     char XPCB_121 = "pcb_1";
     char XPCB_221 = "pcb_2";
     char XPCB_321 = "pcb_3";
     char XPCB_421 = "pcb_4";

/* ----- Function Prototypes ---------- */


/*  int PVB_f2exe(char *ProgName, void *pars);                     */
/*  unsigned long CWRAP (char *User_Param,char **);                */

/* ------------------  Start of Procedural Program --------------- */

    main()
    

       char User_Param1028;

 /*---------------- Local Program Data ----------------------------*/

       char ProgName8 = "CWRAP";
       char PSB20;
       char Response_Key;
       unsigned long Ret_Code = 0;
       int Field_Nr  = 0;
       int I = 0;
       int Input_Msg_Lng = 50;

 /*---------------- Program Test  Data ----------------------------*/
       IMS_PSB Test_PSB = 4,'OPEN',0,0,'DVG1';

       IMS_PCB Test_PCB =
         'GIRODB','01','  ','OPT ',0,'SEGMENT1',4,1,' ';

 /*---------------- Program Pointers & Lengths --------------------*/

       char *Param_Ptr  = (char*)&User_Param;
       char *PSB_Ptr    = (char*)&Test_PSB;
       char *PCB_Ptr    = (char*)&Test_PCB;
       char *Struct_Ptr = (char*)&TRANIN;
       char *API_Ptr    = (char*)&USER_API;
       char *Name_Ptr   = (char*)&ProgName;
       char *Out_Ptr    = (char*)&USER_API.User_Trans;
       char *psb_ptr    = (char*)User_PSB;
       char *Input_Ptr  = (char*)&USER_API.User_Msg;
       char *Output_Ptr = (char*)&USER_API.User_Msg;

       void* pars2;
       PCB_Tptr = &PCB_Test0;
       PCB_Test0 =  &XPCB_10;
       PCB_Test1 =  &XPCB_20;
       PCB_Test2 =  &XPCB_30;
       PCB_Test3 =  &XPCB_40;

 /*----------------  check DVG Data Structures --------------------*/
    puts (" ------------------------------------------------------ ");
    puts (" ----------------- Wrap Test Started------------------- ");

 /************************ Test Data Assignment ********************/

 /*----------------  Assign Values to Parameters ------------------*/

       strcpy (ProgName, "CWRAP");

 /*----------------  Assign Values to IMS_PSB ---------------------*/

       strcpy (Test_PSB.Funktion,"GU  ");
       strcpy (Test_PSB.Format,  "DVG1");
       Test_PSB.PCB_Adr = (unsigned long)PCB_Ptr;
       Test_PSB.IO_Area_Adr = (unsigned long)Input_Ptr;

 /*----------------  Assign Values to IMS_PCB ---------------------*/
       strncpy (Test_PCB.DB_Name,     "GIRODB  ", 8);
       strncpy (Test_PCB.Seg_Stufe,   "01"      , 2);
       strncpy (Test_PCB.Status_Code, "  "      , 2);
       strncpy (Test_PCB.Option,      "OPT1"    , 4);
       strncpy (Test_PCB.Filler,      "0000"    , 4);
       strncpy (Test_PCB.Seg_Name,    "SEGMENT1", 8);

 /*----------------  Assign Values to TRANIN_KOPF -----------------*/

       TRANIN.Tranin_Kopf.ils = 1;
       TRANIN.Tranin_Kopf.ires = 1;
       TRANIN.Tranin_Kopf.segnr = 1;
       TRANIN.Tranin_Kopf.tls = 1;
       TRANIN.Tranin_Kopf.tvk = 1;
       TRANIN.Tranin_Kopf.tfnr = 1;
       TRANIN.Tranin_Kopf.tart = 1;
       strncpy (TRANIN.Tranin_Kopf.trans, "TRANCODE1",9 );
       strncpy (TRANIN.Tranin_Kopf.transx,"T1",       2 );
       strncpy (TRANIN.Tranin_Kopf.innr,  "1111",     4 );
       strncpy (TRANIN.Tranin_Kopf.term,  "TERM",     4 );
       strncpy (TRANIN.Tranin_Kopf.tkomp, "KOMPONTE", 8 );

    puts (" ----------------- Test Data Assigned ----------------- ");

 /****************** End of Test Assignment ************************/

 /*-------------------- Assign User Parameters --------------------*/

       strncpy (USER_API.anzFelder, "03",2);
       strncpy (USER_API.User_Trans, "KKKE    ",8);
       strncpy (USER_API.Bediener, "22222   ",8);
       strncpy (USER_API.Lterm, "99721569",8);
       strncpy (USER_API.User_Msg_Nr, "7777", 4);
       strcpy (USER_API.User_Msg, "KTO=310*KUNR=27000*ART=2*n");
       memcpy(psb_ptr,PSB_Ptr,LAENGE_PSB);


       Input_Msg_Lng = Input_Msg_Lng;
                     + (LAENGE_TRANIN_DATA * Field_Nr);
       if (Input_Msg_Lng > MAX_MSG_LNG)
           Input_Msg_Lng = MAX_MSG_LNG;
       API_Ptr = (char*)&USER_API;

 /*-------------------- Setup Interface ---------------------------*/

       memcpy(Param_Ptr,API_Ptr,LAENGE_API);

 /*----------------  call  Wrapper with User Parameters -----------*/

       puts (" +--------------- --------------------------------+");
       puts (" ! Wrapper will be invoked:                       !");
       puts (" +------------------------------------------------+");
       puts (" User Id is:      ");
       Out_Ptr = (char*)&USER_API.User_Trans;
       for ( I = 0; I < LAENGE_NAME; I++ )
           putchar (Out_PtrI);

       puts ("                                                   ");
       puts (" User Program is: ");
       Name_Ptr = (char*)&ProgName;
       for ( I = 0; I < LAENGE_NAME; I++ )
           putchar (Name_PtrI);

       puts ("                                                   ");
       puts (" Number of Fields: ");
       Out_Ptr = (char*)&USER_API.anzFelder;
       for (I = 0; I < 2; I++)
           putchar (Out_PtrI);

       puts ("                                                   ");
       puts (" Name of Terminal: ");
       Out_Ptr = (char*)&USER_API.Lterm;
       for ( I = 0; I < LAENGE_NAME; I++ )
           putchar (Out_PtrI);

       puts ("                                                   ");
       puts (" User Input is: ");
       Input_Ptr = (char*)&USER_API.User_Msg;
       for (I = 0; I < 40; I++)
           putchar (Input_PtrI);

       puts ("                                                   ");
       puts (" +------------------------------------------------+");
       puts ("                                                   ");
       fflush(stdout);

/*---------------------------------------------------------------*/
       if (cprolog(ProgName) == NULL)  
          printf("cprolog nicht erfolgreich.n");
          return;
       ;
       puts ("                                                   ");
       puts (" -------------- Call Wrapper --------------------- ");
       puts ("                                                   ");

/*     Ret_Code = CWRAP (User_Param,PCB_Tptr);   Static Link     */
       pars0=(void*)User_Param;
       pars1=(void*)PCB_Tptr;
       Ret_Code = PVB_f2exe (ProgName,pars);

       puts ("                                                   ");
       puts (" -------------- Return from Wrapper -------------- ");
       printf ("n Return Code: %0d", Ret_Code);

       memcpy(API_Ptr,Param_Ptr,LAENGE_API);

       puts ("                                                   ");
       puts (" User Output is: ");
       API_Ptr = (char*)&USER_API;
       for (I = 0; I < 80; I++)
           putchar (API_PtrI);


/*     scanf ("%c", Response_Key);              for PC Test      */
       puts ("                                                   ");
       puts (" -------------- WrapTest Finished ---------------- ");
       fflush(stdout);

/************************ End of Source ***************************/
