         TITLE ' KV0230 - TARIFTABELLEN '                               00000100
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00000200
*      DOKUMENTATION-ANFANG:                                            00000300
*      PROGRAMMKENNDATEN:                                               00000400
*      ARBEITSGEBIET:        VERBRAUCHSREBUEHREN ABRECHNUNG             00000500
*                                                                       00000600
*      VERFAHRENS-NAME:      VGA                                        00000700
*                                                                       00000800
*      PGM-NAME:             KV0230                                     00000900
*                                                                       00001000
*      VERFAHRENS-TITEL:     VGA-ABRECHNUNG                             00001100
*                                                                       00001200
*      PGM-TITEL:            TARIFTABELLEN                              00001300
*                                                                       00001400
*      AUTOR:                KUNTER-BLAY/GR.8                           00001500
*                                                                       00001600
*      AUFTRAG:              410/834/018/0618                           00001700
*                                                                       00001800
*      PVG-WALK-THROUGH:     BLAY,GAERBER/GR.8                          00001900
*                                                                       00002000
*      ZUSTAENDIGKEIT:       KUNTER,BLAY/GR.8                           00002100
*                                                                       00002200
*      BETRIEBSSYSTEM:       IBM/0S                                     00002300
*                                                                       00002400
*      UNTERPROGRAMM-AUFRUFE: KV0202                                    00002500
*                                                                       00002600
*      VORGABE-TYP:          MODUL                                      00002700
*                                                                       00002800
*      SPRACHE:              ASSEMBLER                                  00002900
*                                                                       00003000
*      BETRIEBSART:          STAPEL                                     00003100
*                                                                       00003200
*      PGM/MODUL-ART:        NOROOT                                     00003300
*                                                                       00003400
*      PGM/MODUL-UMWELT:     V100600 (KV0203)                           00003500
*                                                                       00003600
*      KURZBESCHREIBUNG:     PRUEFUNG DER GEB-SAETZE UND EVENTL.        00003700
*                            AUFTEILUNG DER GEB-SAETZE                  00003800
*                                                                       00003900
*      DATEN:                                                           00004000
*      DATEI-ID:             T025 (V100600)                             00004100
*                                                                       00004200
*      DATEI-BEZ.:           ABN.GEB.SAETZE (T025)                      00004300
*                                                                       00004400
*      DATEI-ART:            STAMMDATEI                                 00004500
*                                                                       00004600
*      DATEI-VERWENDUNG:     INPUT (VERARBEITEN)                        00004700
*                                                                       00004800
*                                                                       00004900
*      SORT:                 GEB.ART (E G W K M S D)                    00005000
*                                                                       00005100
*      BLOCKUNG:             7000 (1.FACH)                              00005200
*                                                                       00005300
*      SPEICHERUNGSFORM:     SEQUENTIELL                                00005400
*                                                                       00005500
*      SATZ-FORM:            VAR                                        00005600
*                                                                       00005700
*      SATZART-FELD:         T025F01                                    00005800
*                                                                       00005900
*      SATZ-BEZ.:            GEB.SATZ                                   00006000
*                                                                       00006100
*      SATZ-ART:             X'25'                                      00006200
*                                                                       00006300
*      SATZ-LAENGE:          304(F)                                     00006400
*                                                                       00006500
*      SATZ-HAEUFIGKEIT:     N (JE GEB.ART)                             00006600
*                                                                       00006700
*      SATZ-AUFBAU:          DATENBASIS IM PROG.DEF.                    00006800
*                                                                       00006900
*      DRUCK-ID:             KV0202                                     00007000
*                                                                       00007100
*      DRUCK-BEZ.:           EINGABE UND PRUEFLISTE                     00007200
*                                                                       00007300
*      FEHLERTEXTE:          IM PROG.DEF.                               00007400
*                                                                       00007500
*                                                                       00007600
*      AUFGABENBESCHREIBUNG:                                            00007700
*                                                                       00007800
*      VERARBEITUNG:         SIEHE ABLAUFDIAGRAMM                       00007900
*                                                                       00008000
*      UNTERROUTINEN:                                                   00008100
*      UR-1:                 PRUEFUNG ALLER GEB-SAETZE OB AUF-          00008200
*                            TEILUNG ERFORDERLICH IST.                  00008300
*                                                                       00008400
*      UR-2:                 AUFTEILEN DER ERMITTELTEN GEB-SAETZE.      00008500
*                                                                       00008510
*      UR-3:                 BEGINNDATUM FUER GEB.SATZ ERMITTELN.       00008520
*                                                                       00008600
*      PROGRAMMAUFBAU:                                                  00008700
*      PROGRAMM-STRUKTUR:    VORLAUF,UNTERROUTINE 1,UNTERROUTINE 2,     00008800
*                            DEFINITIONEN,DESECT.                       00008900
*                                                                       00009000
*      MAKROS:               YVDS         (EXTERN)                      00009100
*                                                                       00009200
*      DSECT:                ARB,T01A,T02A,TVA                          00009300
*                                                                       00009400
*      REGISTER:             R3 = ARB                                   00009500
*                            R4 = T010                                  00009600
*                            R5 = T025                                  00009700
*                                                                       00009800
*      TEST:                                                            00009900
*      TEST-HINWEISE:        PROGR. IST IMMER IM V100600 GEBUNDEN       00010000
*                                                                       00010100
*      TEST-VERFAHREN:       MIT TEST-PROZ. V99L0020                    00010200
*                                                                       00010300
*      TEST-DATEN:           K1V.T.DAT01                                00010400
*                                                                       00010500
*      BEDIENUNG:                                                       00010600
*      PARAMETER:            R1 (ARB)                                   00010700
*                                                                       00010800
*    AUFTRAGS-NR.         DATUM         PROGRAMMIERER/AENDERUNG         00010801
*----6------------------25-------------40-----------------------------* 00010810
*    410.834.009.8213    V. 06.02.85    BLAY/TAR.TAB. NACH ABR.ZEITRAUM 00010820
*    420.834.001.8326    V. 20.03.85    BLAY/ "   " NUR BEI ABRECHNUNG  00010830
*    420.834.001.8702    V. 06.11.85    BLAY/ "   " BEI ZW.ABRECHNUNG   00010840
*    420.834.001.8750    V. 09.12.85    BLAY/2.HJ.ABRECHNUNG AUS 1.+ 2. 00010850
*                                    TARIFZEITR. FALSCH (MENGENERMITT.) 00010860
*    420.834.001.8817    V. 27.01.86    FEHLER ANZ. MONATE BEI AUFTEI=  00010870
*                                       LUNG/BLAY                       00010900
*    420 834 001 8596   V. 11.09.85    NEUE FREIMENGENREGELUNG          00010910
*                                      + ERWEITERUNG FREIM.-            00010920
*                                      BERECHNUNG/KRAMER                00010930
*    420 834 001 9111  V. 10.07.86   HOESL / UNGLEICHE VERBRAUCHSAUF-   00010931
*                                    TEILUNG W/K BEI ZEITRAUM 1/2       00010932
*    432 834 000 6666  V. 07.10.92   NEUE MAKRO WEGEN PLZ-6STELLIG      00010933
*                                    (HOES6666)                         00010934
*      436 834 000 0466 V. 23.08.94  NEUE MAKRO WEGEN MWST              00010935
*                                                                       00010940
*                                                                       00010950
*      DOKUMENTATION-ENDE:                                              00010960
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00011000
         EJECT                                                          00011100
         TITLE 'KV0230 TARIFTABELLEN - HAUPTROUTINE'                    00011200
         PRINT NOGEN                                                    00011300
KV0230   ZSTRT                                                          00011400
         SPACE                                                          00011500
*        TARIFTABELLEN - VORLAUF                                        00011600
         SPACE                                                          00011700
         L     R3,0(R1)             ARBEITSBEREICH ADRESSIEREN          00011800
         USING ARB,R3                                                   00011900
         L     R4,WT010A            BEHOERDENSTAMM ADRESSIEREN          00012000
         USING T010F01,R4                                               00012100
         L     R5,WT025A            ABNEHMERSTAMM  ADRESSIEREN          00012200
         USING T025F01,R5                                               00012300
Z301     DS    0H                                                       00012400
         CLI   T025F86,C'1'         GEBSATZ-KZ = ABSCHLAG (O.ANPASSUNG) 00012500
         BE    Z303                                                     00012600
         TM    T025F31,LOE          GEB-SATZ-STATUS = LOESCHUNG         00012700
         BO    Z303                                                     00012800
         TM    T025F31,IFVA         GEBSATZ-STATUS = FRUEHER AUSGEZOGEN 00012900
         BNO   Z30                                                      00013000
Z303     DS    0H                                                       00013100
         A     R5,WLT025            ADRESSE ERHOEEN AUF NEUEN GEB-SATZ  00013200
         C     R5,WT025                                                 00013300
         BNL   Z302                 ENDE GEB-SATZ (T025) ?              00013400
         B     Z301                                                     00013500
         SPACE                                                          00013600
*        LOESCHEN UND AUFBEREITEN HILFSFELDER                           00013700
         SPACE                                                          00013800
Z30      DS    0H                                                       00013900
         XC    T011ZNR,T011ZNR      LOESCHEN HILFSFELDER                00014000
         XC    T011ZTR,T011ZTR              I                           00014100
         XC    T025FNR,T025FNR              I                           00014200
         XC    T025F871,T025F871            I                           00014300
         XC    T025F872,T025F872            I                           00014400
         XC    T025F873,T025F873            I                           00014500
         XC    T025F874,T025F874            I                           00014600
         XC    T025F875,T025F875            I                           00014700
         XC    T025F876,T025F876            I                           00014800
         XC    T025F877,T025F877            I                           00014900
         XC    T025F878,T025F878            I                           00015000
         XC    T025F879,T025F879            I                           00015100
         MVI   A30WK1,C'0'                  I                           00015200
         MVI   A30WK2,C'0'                  V                           00015300
         SPACE                                                          00015400
*        BELEGUNG BEMESSUNGS-ZAHL 1 PRUEFEN                             00015500
         SPACE                                                          00015600
         CLI   T025F041,X'00'       BEMESS-ZAHL 1 BELEGT ?              00015700
         BE    Z3010                                                    00015800
         MVC   T011ZNR,T025F041     ZEILEN-NR AUS T025/BZ1 FUER T011    00015900
         MVI   T025FNR,X'01'        FELD-NR AUS T025,01 = 1.BEMESS-ZAHL 00016000
         BAL   R14,Z30A             UNTERROUT PRUEF U AUFTEILEN GEBSATZ 00016100
         SPACE                                                          00016200
*        BELEGUNG BEMESSUNGS-ZAHL 2 PRUEFEN                             00016300
         SPACE                                                          00016400
Z3010    DS    0H                                                       00016500
         CLI   T025F051,X'00'       BEMESS-ZAHL 2 BELEGT ?              00016600
         BE    Z3020                                                    00016700
         MVC   T011ZNR,T025F051     ZEILEN-NR AUS T025/BZ2 FUER T011    00016800
         MVI   T025FNR,X'02'        FELD-NR AUS T025,02 = 2.BEMESS-ZAHL 00016900
         BAL   R14,Z30A             UNTERROUT PRUEF U AUFTEILEN GEBSATZ 00017000
         SPACE                                                          00017100
*        BELEGUNG BEMESSUNGS-ZAHL 3 PRUEFEN                             00017200
         SPACE                                                          00017300
Z3020    DS    0H                                                       00017400
         CLI   T025F061,X'00'       BEMESS-ZAHL 3 BELEGT ?              00017500
         BE    Z3030                                                    00017600
         MVC   T011ZNR,T025F061     ZEILEN-NR AUS T025/BZ3 FUER T011    00017700
         MVI   T025FNR,X'03'        FELD-NR AUS T025,03 = 3.BEMESS-ZAHL 00017800
         BAL   R14,Z30A             UNTERROUT PRUEF U AUFTEILEN GEBSATZ 00017900
         SPACE                                                          00018000
*        BELEGUNG MESSPREIS PRUEFEN                                     00018100
         SPACE                                                          00018200
Z3030    DS    0H                                                       00018300
         CLI   T025F07,X'00'        MESSPREIS BELEGT ?                  00018400
         BE    Z3040                                                    00018500
         MVI   T025FNR,X'04'        FELD-NR AUS T025,04 = MESSPREIS     00018600
         MVC   T011ZNR,T025F07      ZEILEN-NR T025/MESSPREIS FUER T011  00018700
         BAL   R14,Z30A             UNTERROUT PRUEF U AUFTEILEN GEBSATZ 00018800
         SPACE                                                          00018900
*        BELEGUNG PREIS/EINHEIT PRUEFEN                                 00019000
         SPACE                                                          00019100
Z3040    DS    0H                                                       00019200
         CLI   T025F08,X'00'        PREIS/EINHEIT BELEGT ?              00019300
         BE    Z3080                                                    00019400
         MVI   T025FNR,X'05'        FELD-NR AUS T025,05 = PREIS/EINHEIT 00019500
         MVC   T011ZNR,T025F08      ZEILEN-NR T025/PREIS-EINH FUER T011 00019600
         BAL   R14,Z30A             UNTERROUT PRUEF U AUFTEILEN GEBSATZ 00019700
         SPACE                                                          00019800
*        PRUEFEN BEH-STAMM AUF GEK MINDESTABNAHME                       00019900
         SPACE                                                          00020000
Z3080    DS    0H                                                       00020100
         L     R4,WT010A            ANF-ADR T010                        00020200
         MVI   HDW1,X'00'           HILFSFELD AUS ARBBER 1.BYT LOESCHN  00020300
         MVC   HDW1+1(1),T025F021   GEB-ART NACH HILFSFELD (2.BYT)      00020400
         TR    HDW1+1(1),TABGA      TRANS NUM MIT GEBART-TAB AUS ARBBER 00020500
         AH    R4,HDW1              ERHOEHEN R4 UM INHALT HDW1 (HW)     00020600
         MVC   A30WK1,T010F36       SICHERN TAB-NR                      00020700
         MVC   A30WK2,T010F39       SICHERN GRUNDPREISKENNUNG           00020800
         CLI   A30WK2,C'2'          GEK MINDESTVER FUER DIESE GEB-ART   00020900
         BE    Z30120                                                   00021000
         SPACE                                                          00021100
*        BELEGUNG FESTE MINDESTABNAHME PRUEFEN                          00021200
         SPACE                                                          00021300
Z3090    DS    0H                                                       00021400
         CLI   T025F09,X'00'        FESTE MINDESTABNAHME BELEGT         00021500
         BE    Z30100                                                   00021600
         MVI   T025FNR,X'09'        FELDNR AUS T025,09=FESTE MINDESTABN 00021700
         MVC   T011ZNR,T025F09      FESTE MINDESTABNAHME FUER T011      00021800
         BAL   R14,Z30A             UNTERROUT PRUEFEN UND AUFTEILEN GEB 00021900
Z30100   DS    0H                                                       00022000
         SPACE                                                          00022100
*        ADRESSIEREN NAECHSTE GEB-ART/ENDEPRUEFUNG                      00022200
         SPACE                                                          00022300
Z30110   DS    0H                                                       00022400
         A     R5,WLT025            ADRESSIEREN NAECHSTEN GEB-SATZ      00022500
         C     R5,WT025             T025 ENDE ?                         00022600
         BNL   Z302                                                     00022700
         B     Z301                 BEREITS ABGEARBEITET                00022800
Z302     DS    0H                                                       00022900
         ZEND                                                           00023000
         SPACE                                                          00023100
*        PRUEFEN BEMESSUNGS-ZAHL 1 BEI GEK MINDESTABNAHME               00023200
         SPACE                                                          00023300
Z30120   DS    0H                                                       00023400
         CLI   T025F041,X'00'       BEMESS-ZAHL 1 BELEGT ?              00023500
         BE    Z30130                                                   00023600
         MVI   T025FNR,X'06'        FELD-NR AUS T025,06=BZ1 GEK MIND    00023700
         MVC   T011ZNR,T025F041     BEMESS-ZAHL1/GEK MIND FUER T011     00023800
         BAL   R14,Z30A             UNTERROUT PRUEF U AUFTEILEN GEBSATZ 00023900
         SPACE                                                          00024000
*        PRUEFEN BEMESSUNGS-ZAHL 2 BEI GEK MINDESTABNAHME               00024100
         SPACE                                                          00024200
Z30130   DS    0H                                                       00024300
         CLI   T025F051,X'00'       BEMESS-ZAHL 2 BELEGT ?              00024400
         BE    Z30140                                                   00024500
         MVI   T025FNR,X'07'        FELD-NR AUS T025,07=BZ2 GEK MIND    00024600
         MVC   T011ZNR,T025F051     BEMESS-ZAHL2/GEK MIND FUER T011     00024700
         BAL   R14,Z30A             UNTERROUT PRUEF U AUFTEILEN GEBSATZ 00024800
         SPACE                                                          00024900
*        PRUEFEN BEMESSUNGS-ZAHL 3 BEI GEK MINDESTABNAHME               00025000
         SPACE                                                          00025100
Z30140   DS    0H                                                       00025200
         CLI   T025F061,X'00'       BEMESS-ZAHL 3 BELEGT ?              00025300
         BE    Z3090                                                    00025400
         MVI   T025FNR,X'08'        FELD-NR AUS T025,08=BZ3 GEK MIND    00025500
         MVC   T011ZNR,T025F061     BEMESS-ZAHL3/GEK MIND FUER T011     00025600
         BAL   R14,Z30A             UNTERROUT PRUEF U AUFTEILEN GEBSATZ 00025700
         B     Z3090                                                    00025800
         TITLE 'KV0230 TARIFTABELLE - UNTERROUTINE 1 (PRUEFUNG GEB-SATZX00025900
               )'                                                       00026000
*                                                                       00026010
*  UNTERROUTINE 1                                                       00026100
*                                                                       00026200
         DS    F                                                        00026300
Z30A     ST    R14,Z30A-4           SICHERN FUER RUECKSPRUNG            00026400
         SPACE                                                          00026500
*        ERMITTELN TAB-NR UND GRUNDPREIS-KZ IM BEH-STAMM                00026600
         SPACE                                                          00026700
         L     R4,WT010A            ANF-ADR BEH-STAMM                   00026800
         MVI   HDW1,X'00'           HILFSFELD AUS ARBBER                00026900
         MVC   HDW1+1(1),T025F021   GEB-ART NACH HILFSFELD (2.BYT)      00027000
         TR    HDW1+1(1),TABGA      TRANS NUM MIT GEBART-TAB AUS ARBBER 00027100
         AH    R4,HDW1              ERHOEHEN R4 UM INHALT AUS HDW1      00027200
         MVC   A30WK1,T010F36       SICHERN PREIS-TAB-NR                00027300
         MVC   A30WK2,T010F39       SICHERN GRUNDPREIS-KZ               00027400
         SPACE                                                          00027500
*        ERMITTLE ZEILE IN PREISTAB(T011)/PRUEFEN ZEITRAUMBELEGUNG      00027600
         SPACE                                                          00027700
Z30A10   DS    0H                                                       00027800
         L     R4,WT011A            ANF-ADR BEH-STAMM                   00027900
         CLI   A30WK1,C'1'          PREIS-TAB-NR = 1                    00028000
         BE    Z30A20                                                   00028100
         A     R4,L35T011           ERHOEHEN BEI PREIS-TAB-NR = 2       00028200
Z30A20   DS    0H                                                       00028300
         LA    R2,0                 LOESCHEN REG 2                      00028400
         IC    R2,T011ZNR           ZEILEN-NR FUER T011 EINFUEGEN       00028500
         BCTR  R2,0                 FUER ADRESSIERUNG VERMINDERN (-1)   00028600
         LA    R7,3*LT1             LAENGE DER 3 ELEMENTE T011(1.TEIL)  00028700
         LA    R7,3*LT2(R7)         LAENGE DER 3 ELEMENTE T011(2.TEIL)  00028800
         LA    R6,0                 LOESCHEN                            00028900
         MR    R6,R2                LAENGE X ZEILEN-NR                  00029000
         AR    R4,R7                ADDIERE ANFANGSADRESSE              00029100
Z30A201  DS    0H                                                       00029200
         LA    R8,3                 ZAEHLER F ALLE 3 ZEITRAEUME         00029300
         ST    R4,A30R4             SICHERN ADR. T011                   00029310
         L     R4,WT010A            ADR. T010                           00029320
         CLI   T010F82,C'B'         ABRECHNUNG ?                        00029321
         BE    Z30A204              JA                                  00029322
         L     R4,A30R4             T011 ADR. ZURUECK                   00029323
         B     Z30A40                                                   00029324
Z30A204  DS    0H                                                       00029325
         PACK  REFE,T010F80(L'T010F80+1) ANFANG VERARB.ZEITRAUM         00029330
         L     R4,A30R4             T011 ADR. ZURUECK                   00029340
Z30A202  DS    0H                                                       00029350
         CLC   REFE+1(3),T011F014+3  ANF-DATUM/VERARB.= TAR.TAB.ENDE?   00029360
         BH    Z30A203              VERARB.> TAR.TAB. DATUM             00029370
         B     Z30A40               JA                                  00029380
Z30A203  DS    0H                                                       00029390
         LA    R4,LT1(R4)           ERHOEHEN AUF NEXT ZEITRAUM (1.TEIL) 00029391
         LA    R4,LT2(R4)           ERHOEHEN AUF NEXT ZEITRAUM (2.TEIL) 00029392
         BCT   R8,Z30A202                                               00029393
         B     Z30A60               ENDE                                00029394
Z30A40   DS    0H                                                       00029400
         ST    R4,A30R4             ADR.SICHERUNG T011                  00029500
         CLI   T011F013+1,X'00'     ZEITRAUM BELEGT ?                   00029600
         BE    Z30A50                                                   00029700
         MVC   T011ZTR,T011F013+1   UEBERTRAGEN ZEITRAUM-NR             00029800
         SPACE                                                          00029900
*        BEI ABSCHLAG ANPASSUNG MIT VERARBEITUNGSZEITRAUM PRUEFEN       00030000
         SPACE                                                          00030100
Z30A30   DS    0H                                                       00030200
         CLI   T025F86,C'2'         ABSCHLAG/ANPASSUNG ?                00030300
         BNE   Z30A301                                                  00030400
         L     R4,WT010A            T010                                00030500
         PACK  REFE,T010F81(L'T010F81+1)   ENDEDATUM VERARBEITUNGSZEITR 00030600
         L     R4,A30R4             T011                                00030700
         CLC   REFE+1(3),T011F014+3 VERGL ENDDAT:VERARB-ZEITR/TAR-ZEITR 00030800
         BH    Z30A50                                                   00030900
         B     Z30A170                                                  00031000
         SPACE                                                          00031100
*        PRUEFUNG DES ADRESSIERTEN GEB-SATZ AUF AUFTEILUNG              00031200
*        BEI ABRECHNUNGS-POSITIONEN.                                    00031210
         SPACE                                                          00031300
Z30A301  DS    0H                                                       00031400
         L     R6,WTVAA             ADRESSIERE TVA                      00031451
         L     R7,WLTVA             LAENGE EINES ELEMENTS               00031460
         XC    HDW1(2),HDW1         LOESCHEN 1+2 BYTE                   00031470
         MVC   HDW1+1(1),T025F021   UBERTRAGEN GEB-ART                  00031480
         TR    HDW1+1(1),TABGA      UEBERSETZEN GEB-ART                 00031490
         MH    R7,HDW1              BERECHNUNG DES ADRESSIERTEN ELEMENT 00031491
         AR    R6,R7                ADDIEREN AUF BASIS                  00031492
         USING TVAF00,R6            ADRESSIEREN DUMMY-SECT              00031493
         CLI   TVAF03,C'A'          VERARBEITUNG = ABSCHLAG ?           00031494
         BNE   Z30A302              NEIN, ZTR. ABR. BEREITS ERMITT.     00031495
         SPACE                                                          00031496
*        FUER ABSCHLAG MIT ZWISCHENABRECHNUNG BERUECKSICHTIGEN          00031497
*        ERLEDIGTEN ZEITRAUM.                                           00031498
         L     R4,WT010A            T010                                00031499
         CLC   T025F021,T010F981    GEB.ART ZWISCHENABRECHNG. ?         00031500
         BE    Z30A303              JA                                  00031501
         CLC   T025F021,T010F982    GEB.ART ZWISCHENABRECHNG. ?         00031502
         BE    Z30A303              JA                                  00031503
         CLC   T025F021,T010F983    GEB.ART ZWISCHENABRECHNG. ?         00031504
         BE    Z30A303              JA                                  00031505
         CLC   TVAF05,T025F55       VERGL ANFDAT:ABRECHNG MIT GEB.SATZ  00031506
         BNH   Z30A302              NEUZUGANG NACH ERLED.VERARB.,JA     00031507
         L     R4,A30R4             T011                                00031508
         CLC   TVAF05,T011F014+3    VERGL:ABRECHNG MIT ENDE ZEITR.      00031509
         BL    Z30A302              JA, INNERHALB DES ZEITR.            00031510
         B     Z30A50               NEIN, NAECHSTER ZEITR.              00031511
Z30A303  DS    0H                                                       00031512
         L     R7,WLTVA             LAENGE EINES ELEMENTS  TVA          00031513
         MH    R7,TGAF00            MULT X 7 (MAX. LAENGE EINER TVA)    00031514
         AR    R6,R7                ADRESSIEREN NAECHSTE TVA (ZWI-ABRE) 00031515
         L     R4,A30R4             T011                                00031516
         CLC   TVAF01,T011F014+3    VERGL:ABRECHNG MIT ENDE ZEITR.      00031517
         BL    Z30A302              JA, INNERHALB DES ZEITR.            00031518
         B     Z30A50               NEIN, NAECHSTER ZEITR.              00031519
         SPACE                                                          00031520
Z30A302  DS    0H                                                       00031521
         L     R4,A30R4             T011                                00031522
         CLC   T025F55,T011F014     VERGL ANFDAT:GEB-SATZ MIT ZEITR     00031530
         BNH   Z30A110                                                  00031600
         CLC   T025F55,T011F014+3   ANF/ENDDAT GEB-SATZ/ZEITRAUM        00031700
         BL    Z30A110                                                  00031800
Z30A50   DS    0H                                                       00031900
         LA    R4,LT1(R4)           ERHOEHE AUF NAECHSTEN ZEITRAUM(1.T) 00032000
         LA    R4,LT2(R4)           ERHOEHE AUF NAECHSTEN ZEITRAUM(2.T) 00032100
         BCT   R8,Z30A40            SCHLEIFENZAEHLER R8  -1             00032200
Z30A60   DS    0H                                                       00032300
         L     R14,Z30A-4           RUECKSPRUNG                         00032400
         BR    R14                                                      00032500
         SPACE                                                          00032600
*        VERGLEICHEN ENDDAT FUER AUFTEILUNG                             00032700
         SPACE                                                          00032800
Z30A110  DS    0H                                                       00032900
         CLI   T025F52,X'00'        ENDDAT GEB-SATZ BELEGT ?            00033000
         BE    Z30A111                                                  00033100
         CLC   T025F52,T011F014+3   VERGL ENDDAT:GEBSATZ/ZEITRAUM       00033200
         BNH   Z30A170                                                  00033300
Z30A130  DS    0H                                                       00033400
         BAL   R14,Z30B             AUFTEILEN GEBSATZ                   00033500
         B     Z30A170                                                  00033600
         SPACE                                                          00033700
*        WENN ENDDAT IM GEB-SATZ NICHT BELEGT,ADRESSIEREN RICHTIG TVA   00033800
         SPACE                                                          00033900
Z30A111  DS    0H                                                       00034000
         L     R6,WTVAA             ADRESSIERE TVA                      00034100
         L     R7,WLTVA             LAENGE EINES ELEMENTS               00034200
         XC    HDW1(2),HDW1         LOESCHEN 1+2 BYTE                   00034300
         MVC   HDW1+1(1),T025F021   UBERTRAGEN GEB-ART                  00034400
         TR    HDW1+1(1),TABGA      UEBERSETZEN GEB-ART                 00034500
         MH    R7,HDW1              BERECHNUNG DES ADRESSIERTEN ELEMENT 00034600
         AR    R6,R7                ADDIEREN AUF BASIS                  00034700
         USING TVAF00,R6            ADRESSIEREN DUMMY-SECT              00034800
         CLI   TVAF03,C'A'          VERARBEITUNG = ABSCHLAG ?           00034900
         BNE   Z30A113              NEIN                                00035000
         SPACE                                                          00035001
*        FUER ABSCHLAG MIT ZWISCHENABRECHNUNG BERUECKSICHTIGEN          00035002
*        ERLEDIGTEN ZEITRAUM.                                           00035003
         ST    R4,A30R4             T011                                00035010
         L     R4,WT010A            T010                                00035011
         CLC   T025F021,T010F981    GEB.ART ZWISCHENABRECHNG. ?         00035020
         BE    Z30A114              JA                                  00035030
         CLC   T025F021,T010F982    GEB.ART ZWISCHENABRECHNG. ?         00035040
         BE    Z30A114              JA                                  00035050
         CLC   T025F021,T010F983    GEB.ART ZWISCHENABRECHNG. ?         00035060
         BE    Z30A114              JA                                  00035070
         L     R4,A30R4             T011                                00035071
         CLC   TVAF06,T011F014+3    VERGL ENDDAT:TVA/ZEITRAUM           00035080
         BNH   Z30A170                                                  00035090
         B     Z30A130                                                  00035310
Z30A114  DS    0H                                                       00035400
         L     R4,A30R4             T011                                00035401
         L     R7,WLTVA             LAENGE EINES ELEMENTS  TVA          00035402
         MH    R7,TGAF00            MULT X 7 (MAX. LAENGE EINER TVA)    00035403
         AR    R6,R7                ADRESSIEREN NAECHSTE TVA (ZWI-ABRE) 00035404
         SPACE                                                          00035405
Z30A113  DS    0H                                                       00035410
         CLC   TVAF02,T011F014+3    VERGL ENDDAT:TVA/ZEITRAUM           00035500
         BNH   Z30A170                                                  00035600
         B     Z30A130                                                  00035700
         SPACE                                                          00035800
*        UEBERTRAGE NACH T025 UEBER T025FNR DIE ZEITRAUM-NR             00035900
         SPACE                                                          00036000
Z30A170  DS    0H                                                       00036100
         LA    R2,0                 LOESCHEN REG 2                      00036200
         IC    R2,T025FNR           UEBERTRAGEN FELDNR AUS GEB-SATZ     00036300
         BCTR  R2,0                 -1                                  00036400
         LA    R14,T025F871         ADRESSIEREN 1.FELD FUER ZEITRAUM    00036500
         LA    R7,L'T025F871        LAENGE EINES FELDES                 00036600
         LA    R6,0                 LOESCHEN                            00036700
         MR    R6,R2                LAENGE X FELDNR = RELATIVE ADRESSE  00036800
         AR    R14,R7               + BASIS = ZEITR FELD IM GEB-SATZ    00036900
         MVC   0(1,R14),T011ZTR     UEBERTRAGE ZEITR-NR NACH ZEITR-FELD 00037000
         B     Z30A60               (GEB.SATZ)                          00037100
         TITLE 'KV0230 TARIFTABELLE - UNTERROUTINE 2 (AUFTEILEN GEB-SATX00037200
               Z)'                                                      00037300
*                                                                       00037310
*  UNTERROUTINE 2                                                       00037400
*                                                                       00037500
         SPACE                                                          00037600
*        ANLEGEN EINES FOLGESATZES                                      00037700
         SPACE                                                          00037800
         DS    F                                                        00037900
Z30B     ST    R14,Z30B-4                                               00038000
         CLC   WT025,WT025Z         ? T025 VOLL                         00038100
         BL    Z30B10               NEIN                                00038200
         MVC   FEHLTEXT(L'K30FT1),K30FT1                                00038300
         ZCALL KV0202,/ARB                                              00038800
         B     Z30B150                                                  00038900
Z30B10   DS    0H                                                       00039000
         L     R6,WT025                                                 00039100
         LR    R7,R6                                                    00039200
         A     R7,WLT025                                                00039300
         ST    R7,WT025             ADR NAECHSTE FREIE TAB IN T025      00039400
         LR    R7,R6                                                    00039500
         S     R6,WLT025                                                00039600
Z30B20   DS    0H                                                       00039700
         ZMVCL R7,/WLT025,R6        VERSCHIEBEN 1 TABELLE IN T025       00039800
         CR    R6,R5                ? ALLE TABELLEN VERSCHOBEN          00039900
         BNH   Z30B30                   JA                              00040000
         LR    R7,R6                                                    00040100
         S     R6,WLT025                                                00040200
         B     Z30B20                                                   00040300
         SPACE                                                          00040400
*        R5 ENTHAELT ADR. DES FOLGESATZES (ALTER SATZ)                  00040500
         SPACE                                                          00040600
Z30B30   DS    0H                                                       00040700
         NI    T025F32,X'FD'        LOESCHEN ZAEHLERAUSW.               00040800
         OI    T025F32,FOLGES       AENDERUNGSKG. ='FOLGESATZ'          00040810
         MVC   T025F52,T011F014+3   ENDDATUM-ZEITRAUM                   00040900
         LA    R14,T011F014         ANFANGSDATUM-ZEITRAUM               00041000
         LA    R14,LT1(R14)         NAECHSTER-ZEITRAUM(1.TEIL)          00041100
         LA    R14,LT2(R14)         NAECHSTER-ZEITRAUM(2.TEIL)          00041200
         LA    R15,T025F55          ANFANGSDATUM-GEB.SATZ               00041300
         A     R15,WLT025           NAECHSTER GEB.SATZ (NEUER)          00041400
*        BEREINIGUNG ANFANGSDATUM NEUER SATZ                            00041500
         MVC   0(L'T025F55,R15),0(R14)  GEB.SATZ < ZEITRAUM ANFANGSDAT. 00041600
         SPACE                                                          00041700
*        LOESCHEN KORREKTURWERTE                                        00041800
         SPACE                                                          00041900
         ZAP   T025F41,KP0                                              00042000
         MVI   T025F42,X'00'                                            00042100
         ZAP   T025F43,KP0                                              00042200
         MVI   T025F44,X'00'                                            00042300
         ZAP   T025F45,KP0                                              00042400
         MVI   T025F46,X'00'                                            00042500
*        LOESCHEN ZWISCHENSPEICHER FUER NEUEN GEB.SATZ                  00042501
         ZAP   BT025F80,KP0                                             00042510
         ZAP   BT025F14,KP0                                             00042520
         ZAP   BT025F25,KP0                                             00042530
         ZAP   BT025F21,KP0                                             00042540
         ZAP   BT025F37,KP0                                             00042550
         SPACE                                                          00042600
*        AUFTEILEN ANZAHL BERECHNUNGSMONATE                             00042700
         SPACE                                                          00042800
         CP    T025F80,KP0          ANZ.MON.= 0                         00042900
         BNE   Z30B305                                                  00043000
         ZAP   BT025F80,KP0         ANZ.BER.MON.FOLGE.                  00043100
         ZAP   REFE,KP0             FAKTOR UMRECHNUNG                   00043200
         B     Z30B41                                                   00043300
Z30B305  DS    0H                                                       00043400
         BAL   R14,Z30B200           BEGINNDATUM ERMITTELN              00043450
         MVI   H1+1,X'0C'                                               00043500
         MVI   HDW1+1,X'0C'                                             00043510
         CLC   HDW(3),T011F014       ANF.DAT : ABR.ZEITR = TAB.ZEITR    00043520
         BNH   Z30B307                                                  00043530
         CLC   T025F55,HDW           ANF.DAT : GEB.SATZ = ABR.ZEITR     00043540
         BL    Z30B306                                                  00043550
         B     Z30B308                                                  00043560
Z30B306  DS    0H                                                       00043570
         MVO   H1,HDW(1)             ANF.DAT. AUS ABR.ZEITR.(JAHR)      00043580
         B     Z30B302                                                  00043590
Z30B307  DS    0H                                                       00043600
         CLC   T025F55,T011F014     ANF.DAT. GEB.SATZ-ZEITRAUM          00043610
         BL    Z30B301                                                  00043620
Z30B308  DS    0H                                                       00043700
         MVO   H1,T025F55(1)        ANF.DAT. AUS GEB.SATZ               00043800
         B     Z30B302                                                  00043900
Z30B301  DS    0H                                                       00044000
         MVO   H1,T011F014(1)       ANF.DAT. AUS ZEITRAUM (JAHR)        00044100
Z30B302  DS    0H                                                       00044200
         MVI   F1+3,X'0C'                                               00044300
         MVO   F1,T011F014+3(1)     ENDDATUM AUS ZEITRAUM  (JAHR)       00044400
         SP    F1,H1                DIFFERENZ IN JAHREN                 00044500
         MVI   H2+1,X'0C'                                               00044600
         MVO   H2,T011F014+4(1)     ENDDATUM (MONAT)                    00044700
         CLC   HDW(3),T011F014       ANF.DAT : ABR.ZEITR = TAB.ZEITR    00044710
         BNH   Z30B310                                                  00044720
         CLC   T025F55,HDW           ANF.DAT : GEB.SATZ = ABR.ZEITR     00044730
         BL    Z30B309                                                  00044740
         B     Z30B311                                                  00044750
Z30B309  DS    0H                                                       00044760
         MVO   H1,HDW+1(1)           ANF.DAT. AUS ABR.ZEITR.(MONAT)     00044770
         MVO   HDW1(2),HDW+2(1)      ANF.DAT. AUS ABR.ZEITR.(TAG)       00044780
         B     Z30B304                                                  00044790
Z30B310  DS    0H                                                       00044800
         CLC   T025F55,T011F014     ANF.DAT. GEB.SATZ-ZEITRAUM          00044810
         BL    Z30B303                                                  00044900
Z30B311  DS    0H                                                       00044910
         MVO   H1,T025F55+1(1)      ANF.DAT. AUS GEB.SATZ(MONAT)        00045000
         MVO   HDW1(2),T025F55+2(1)  ANF.DATUM (TAG)                    00045010
         B     Z30B304                                                  00045100
Z30B303  DS    0H                                                       00045200
         MVO   H1,T011F014+1(1)     ANFDATUM (MONAT)                    00045300
         MVO   HDW1(2),T011F014+2(1)  ANF.DATUM (TAG)                   00045310
Z30B304  DS    0H                                                       00045400
         SP    H2,H1                DIFFERENZ DER MONATE                00045500
         BNM   Z30B40               VERZW. BEI NICHT NEGATIV            00045600
         SP    F1,KP1               ANZ.JAHRE - 1                       00045700
         AP    H2,KP12              ANZ.MONATE + 12                     00045800
Z30B40   DS    0H                                                       00045900
         MP    F1,KP12                                                  00046000
         CP    HDW1(2),KP15         > 15 TAGE                           00046010
         BH    Z30B42               JA,KEIN VOLLER MONAT                00046020
         AP    F1,KP1               DIFFERENZ IN MONATEN                00046100
Z30B42   DS    0H                                                       00046110
         AP    F1,H2                ANZ.MON. (+12)                      00046200
         SP    T025F80,F1                                               00046300
         ZAP   H1,T025F80           ANZ. BERECHNUNGSMONATE              00046400
         ZAP   BT025F80,T025F80     ANZ.BER.MON.FOLGE                   00046500
         ZAP   T025F80,F1           ANZ.BER.MON.AKTUELL                 00046600
         ZAP   REFE,F1                                                  00046700
         AP    H1,F1                                                    00046800
         ZAP   A12RF1,REFE                                              00046900
         MP    A12RF1,KP1000        3. DEZ. STELLE                      00047000
         MP    A12RF1,KP1000        6. DEZ. STELLE                      00047100
         MP    A12RF1,KP10          7. DEZ. STELLE                      00047200
         DP    A12RF1,H1                                                00047300
         AP    A12RF1(L'A12RF1-L'H1),KP5                                00047400
         MVO   REFE,A12RF1(L'A12RF1-L'H1-1) ,6 FAKTOR FUER ANT.IM FOLGS 00047500
         SPACE                                                          00047600
*        AUFTEILEN ABLESESTAND                                          00047700
         SPACE                                                          00047800
Z30B41   DS    0H                                                       00047900
         TM    T025F32,ZAEHLST      ABLESESTAND VORHANDEN?              00048000
         BNO   Z30B90               NEIN ,KEINE ANTEILBER.              00048100
         SPACE                                                          00048200
         PACK  HDW,T025F13          STELLENZAHL                         00048300
         CVB   R2,HDW               STELLENZAHL DES ZAEHLERS BINAER     00048400
         OI    T025F81+8,X'F0'      VORZEICHEN                          00048500
         PACK  A12RF1,T025F81       PACKEN ABLESESTAND                  00048600
         SP    A12RF1,T025F14       DIFFERENZ ABLESEST. - MONTAGEST.    00048700
         BNM   Z30B60               VERZW. BEI NICHT NEGATIV            00048800
*                                   ZAEHLERUEBERLAUF                    00048900
         ZAP   A12RF2,KP1                                               00049000
Z30B50   DS    0H                                                       00049100
         MP    A12RF2,KP10                                              00049200
         BCT   R2,Z30B50                                                00049300
         AP    A12RF1,A12RF2                                            00049400
Z30B60   DS    0H                                                       00049500
         MP    A12RF1,REFE          ,3 ZST.DIFFERENZ MAL FAKTOR (ANT.)  00049700
         MVO   A12RF1,A12RF1(L'A12RF1-3)                                00049800
         AP    A12RF1,KP5           RUNDEN                              00049900
         MVO   A12RF1,A12RF1(L'A12RF1-1) ANT.VERBRAUCH IM FOLGESATZ     00050000
         AP    A12RF1,T025F14       PLUS MONTAGEST. = ABL.ST. (AKT.)    00050200
         UNPK  T025F81,A12RF1                                           00050300
         CVB   R2,HDW               STELLENZAHL DES ZAEHLERS            00050400
         LA    R6,0+L'T025F81                                           00050500
         SR    R6,R2                ANZAHL ZU LOESCHENDE STELLEN        00050600
         BZ    Z30B80                                                   00050700
         LA    R2,T025F81                                               00050800
Z30B70   DS    0H                                                       00050900
         MVI   0(R2),C' '           VORDERE STELLEN LOESCHEN            00051000
         LA    R2,1(R2)             ERHOEHEN ADR IN T025F81             00051100
         BCT   R6,Z30B70                                                00051200
Z30B80   DS    0H                                                       00051300
         OI    T025F81+L'T025F81-1,240                                  00051400
         PACK  BT025F14,T025F81     FUER NEUEN GEB.SATZ                 00051500
         SPACE                                                          00051600
*        AUFTEILEN BISHER BEZAHLTER ABSCHLAG                            00051700
         SPACE                                                          00051800
Z30B90   DS    0H                                                       00051900
         ZAP   BT025F25,KP0                                             00052000
         CP    T025F25,KP0                                              00052100
         BNH   Z30B100                                                  00052200
         ZAP   RF1,T025F25          BISH.BEZ.ABSCHL.                    00052300
         MP    RF1,REFE             MAL ANT. FAKTOR (FOLGESATZ)         00052400
         ZAP   A12RF1,RF1           ZURUECK IN'S RECHENFELD             00052500
         MVO   A12RF1,A12RF1(L'A12RF1-3)                                00052600
         AP    A12RF1,KP5           RUNDEN                              00052700
         MVO   A12RF1,A12RF1(L'A12RF1-1) ANT.VERBRAUCH IM FOLGESATZ     00052800
         ZAP   BT025F25,T025F25                                         00052900
         SP    BT025F25,A12RF1      ANT. BISH.BEZ.ABSCHL. (AKT.SATZ)    00053000
         ZAP   T025F25,BT025F25     ANT. BIS. BEZ. ABSCHLAG(SA-ALT)     00053100
         ZAP   BT025F25,A12RF1      ANT. BIS. BEZ. ABSCHLAG(SA-NEU)     00053200
Z30B100  DS    0H                                                       00053300
         ZAP   BT025F21,KP0                                             00053400
         CP    T025F21,KP0                                              00053500
         BNH   Z30B110                                                  00053600
         SPACE                                                          00053700
*        AUFTEILEN JAHRESVERBRAUCH                                      00053800
         SPACE                                                          00053900
         ZAP   A12RF1,T025F21       JAHRESVERBRAUCH                     00054000
         ZAP   T025F21,A12RF1       ANT. JAHRESVERBR. (FOLGESATZ)       00054100
         SPACE                                                          00054200
*        AUFTEILEN ABZUSETZENDER UZ-VERBRAUCH                           00054300
         SPACE                                                          00054400
Z30B110  DS    0H                                                       00054500
         ZAP   BT025F37,KP0                                             00054600
         CP    T025F37,KP0                                              00054700
         BNH   Z30B120                                                  00054800
         ZAP   A12RF1,T025F37       UZ-VERBRAUCH                        00054900
         MP    A12RF1,REFE          MAL ANT. FAKTOR                     00055000
         MVO   A12RF1,A12RF1(L'A12RF1-3)                                00055100
         AP    A12RF1,KP5           RUNDEN                              00055200
         MVO   A12RF1,A12RF1(L'A12RF1-1)                                00055300
         SP    T025F37,A12RF1       ANT. VERBRAUCH (SA-ALT)             00055400
         ZAP   BT025F37,A12RF1      ANT. VERBRAUCH (SA-NEU)             00055500
Z30B120  DS    0H                                                       00055600
         A     R5,WLT025            ADR. NEU ANGELEGTEN SATZ            00055700
         ZAP   T025F80,BT025F80     UEB NEUE FELDINHALTE                00055800
         ZAP   T025F14,BT025F14                                         00055900
         ZAP   T025F25,BT025F25                                         00056000
         ZAP   T025F21,BT025F21                                         00056100
         ZAP   T025F37,BT025F37                                         00056200
Z30B130  DS    0H                                                       00056300
         TM    T025F32,ZWABRE       ZWISCHENABRECHNUNG                  00056400
         BZ    Z30B140                                                  00056500
         CLI   T025F13,240          STELLENZAHL ZAEHLER = 0             00056600
         BNH   Z30B140                                                  00056700
         LR    R15,R5                                                   00056800
         A     R15,WLT025                                               00056900
         DROP  R5                                                       00057000
         USING T025F01,R15                                              00057100
         CLI   T025F13,240                                              00057200
         BNH   Z30B140                                                  00057300
         TM    T025F32,ZWABRE                                           00057400
         BO    Z30B140                                                  00057500
         DROP  R15                                                      00057600
         USING T025F01,R5                                               00057700
         LA    R15,T025F14                                              00057800
         A     R15,WLT025                                               00057900
         PACK  0(L'T025F14,R15),T025F81                                 00058000
         SPACE                                                          00058100
*        HOCHSCHAUFELN MONTAGESTAND                                     00058200
         SPACE                                                          00058300
Z30B140  DS    0H                                                       00058400
         S     R5,WLT025            ZURUECKSTELLEN AUF ALTEN SATZ       00058500
Z30B150  DS    0H                                                       00058510
         L     R14,Z30B-4                                               00058600
         BR    R14                                                      00058700
         EJECT                                                          00058800
         TITLE 'KV0230 TARIFTABELLEN - UNTERROUTINE 3 (BEGINNDATUM DES X00058900
                GEB.SATZES EMITTELN).'                                  00059000
         DS    F                                                        00059100
Z30B200  ST    R14,Z30B200-4                                            00059200
         ST    R4,A30R4             T011 SICHERN                        00059300
         L     R4,WT010A            ADRESSE T010                        00059400
         L     R6,WTVAA             ADRESSE TVA                         00059500
         USING TVA,R6                                                   00059600
         XC    HDW1(2),HDW1                                             00059700
         MVC   HDW1+1(1),T025F021   GAB.ART                             00059800
         TR    HDW1+1(1),TABGA      NUMERISCH                           00059900
         L     R7,WLTVA             LAENGE EINES ELEMENTES              00060000
         MH    R7,HDW1              * GEB.ART                           00060100
         AR    R6,R7                + BASIS = TVA FUER GA               00060200
         CLI   TVAF03,C'B'          BERECHNUNG ?                        00060300
         BE    Z30B210              JA                                  00060400
         SPACE                                                          00060500
*        BEI ABSCHLAG MIT ZWISCHENABRECHNUNG ERLEDIGTEN                 00060600
*        ZEITRAUM BERUECKSICHTIGEN                                      00060700
         CLC   T025F021,T010F981    GEB.ART ZWISCHENABRECHNUNG ?        00060800
         BE    Z30B220              JA                                  00060900
         CLC   T025F021,T010F982    GEB.ART ZWISCHENABRECHNUNG ?        00061000
         BE    Z30B220              JA                                  00061100
         CLC   T025F021,T010F983    GEB.ART ZWISCHENABRECHNUNG ?        00061200
         BE    Z30B220              JA                                  00061300
         MVC   HDW(3),TVAF05         BEGINNDATUM AUS TVA   JJMMTT       00061400
         B     Z30B230                                                  00061500
Z30B220  DS    0H                                                       00061600
         L     R7,WLTVA             LAENGE EINES ELEMENTES              00061700
         MH    R7,TGAF00            * 7 = LAENGE EINER TVA              00061800
         AR    R6,R7                +BASIS=TVA FUER ABSCHL.(ZWI.ABRE)   00061900
         SPACE                                                          00062000
Z30B210  DS    0H                                                       00062100
         MVC   HDW(3),TVAF01         BEGINNDATUM AUS TVA   JJMMTT       00062200
Z30B230  DS    0H                                                       00062300
         L     R4,A30R4             ADRESSE T011                        00062400
         L     R14,Z30B200-4                                            00062500
         BR    R14                                                      00062600
         TITLE 'KV0230 DEFINITIONEN UND KONSTANTEN'                     00062700
*  SAVE-FELDER                                                          00062800
BT025F14 DC    PL5'0'               MONTAGESTAND                        00062900
BT025F21 DC    PL6'0'               AUFGEL. JAHRESVERBRAUCH             00063000
BT025F25 DC    PL5'0'               BISHER BEZ. ABSCHLAG                00063100
BT025F37 DC    PL5'0'               ABZUSETZENDER VERBRAUCH             00063200
BT025F80 DC    PL5'0'               ANZAHL BERECHNUNGSMONATE            00063300
K30FT1   DC    C'> 40 GEB.SAETZE,ENDE AUFTEILUNG(KV0230)'               00063400
*                                                                       00063500
T011ZTR  DS    XL1          ZEITRAUM NR. IN T011 (01-03 MOEGL.)         00063600
T011ZNR  DS    XL1          ZEILEN-NR. AUS T025 FUER T011               00063700
T025FNR  DS    XL1          FELD NR. AUS T025 DES ZU PRUEFENDEN FELDES  00063800
*                           (Z.B. BEM.ZAHL 1 = 01)                      00063900
A30R4    DS    F            SICHERUNG ADRESSE T011                      00064000
A30WK1   DC    CL1'0'       PREISTAB.NR.                                00064100
A30WK2   DC    CL1'0'       GRUNDPREISBERECHNUNGS-KZ.                   00064200
*                                                                       00064300
KP15     DC    PL2'15'      ANZAHL TAGE                                 00064400
*                                                                       00064500
         PRINT GEN                                                      00064600
         YVDS  DSECT,ARB,ARB                                            00064700
         YVDS  DSECT,T01A,T01                                           00064800
         YVDS  DSECT,T02A,T02                                           00064900
         YVDS  DSECT,TVA,TVA                                            00065000
         PRINT NOGEN                                                    00065100
LOE      EQU   X'40'        LOESCHUNG                                   00065200
IFVA     EQU   X'80'        FRUEHER AUSGEZOGEN                          00065300
ZWABRE   EQU   X'40'        AENDERUNGSKENNUNG BEI ZWISCHENABRECHNUNG    00065400
FOLGES   EQU   X'01'        FOLGESATZ                                   00065500
ZAEHLST  EQU   X'10'                                                    00065600
LT1      EQU   L'T011F01+L'T011F012+L'T011F02+L'T011F03+L'T011F04+L'T01-00065700
               1F05+L'T011F06+L'T011F07+L'T011F08+L'T011F20+L'T011F21+L-00065800
               'T011F22+L'T011F23+L'T011F24+L'T011F25+L'T011F26         00065900
LT2      EQU   L'T011F27                                                00066000
         END   KV0230                                                   00066100
