         TITLE ' KV0231 - GEWICHTUNG DER ZU BERECHNENDEN MENGEN '       00000100
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00000200
*      DOKUMENTATION-ANFANG:                                            00000300
*      PROGRAMMKENNDATEN:                                               00000400
*      ARBEITSGEBIET:        VERBRAUCHSREBUEHREN ABRECHNUNG             00000500
*                                                                       00000600
*      VERFAHRENS-NAME:      VGA                                        00000700
*                                                                       00000800
*      PGM-NAME:             KV0231                                     00000900
*                                                                       00001000
*      VERFAHRENS-TITEL:     VGA-ABRECHNUNG                             00001100
*                                                                       00001200
*      PGM-TITEL:            GEWICHTUNG                                 00001300
*                                                                       00001400
*      AUTOR:                BLAY/GR.8                                  00001500
*                                                                       00001600
*      AUFTRAG:              410/834/018/0657                           00001700
*                                                                       00001800
*      PVG-WALK-THROUGH:     BLAY,GAERBER/GR.31                         00001900
*                                                                       00002000
*      ZUSTAENDIGKEIT:       BLAY/GR.8                                  00002100
*                                                                       00002200
*      BETRIEBSSYSTEM:       IBM/0S                                     00002300
*                                                                       00002400
*      UNTERPROGRAMM-AUFRUFE: KV0202                                    00002500
*                                                                       00002600
*      VORGABE-TYP:          MODUL                                      00002700
*                                                                       00002800
*      SPRACHE:              ASSEMBLER                                  00002900
*                                                                       00003000
*      BETRIEBSART:          STAPEL                                     00003100
*                                                                       00003200
*      PGM/MODUL-ART:        NOROOT                                     00003300
*                                                                       00003400
*      PGM/MODUL-UMWELT:     V100600 (KV0203)                           00003500
*                                                                       00003600
*      BESONDERHEITEN:       OPEN UND CLOSE FUER GEWICHTUNGS- UND       00003700
*                            TARIFSCHLUESSELTAB. ERFOLGT IM V100600     00003800
*                            (SYS031 SYS032).                           00003900
*                                                                       00004000
*      KURZBESCHREIBUNG:     VERBRAUCHS-GEWICHTUNG ALLER GLEICHEN       00004100
*                            GEBUEHREN-SAETZE.                          00004200
*                                                                       00004300
*      DATEN:                                                           00004400
*      DATEI-ID:             T025 (V100600)                             00004500
*                                                                       00004600
*      DATEI-BEZ.:           ABN.GEB.SAETZE (T025)                      00004700
*                                                                       00004800
*      DATEI-ART:            STAMMDATEI                                 00004900
*                                                                       00005000
*      DATEI-VERWENDUNG:     INPUT (VERARBEITEN)                        00005100
*                                                                       00005200
*                                                                       00005300
*      SORT:                 GEB.ART (E G W K M S D)                    00005400
*                                                                       00005500
*      BLOCKUNG:             7000 (1.FACH)                              00005600
*                                                                       00005700
*      SPEICHERUNGSFORM:     SEQUENTIELL                                00005800
*                                                                       00005900
*      SATZ-FORM:            VAR                                        00006000
*                                                                       00006100
*      SATZART-FELD:         T025F01                                    00006200
*                                                                       00006300
*      SATZ-BEZ.:            GEB.SATZ                                   00006400
*                                                                       00006500
*      SATZ-ART:             X'25'                                      00006600
*                                                                       00006700
*      SATZ-LAENGE:          304(F)                                     00006800
*                                                                       00006900
*      SATZ-HAEUFIGKEIT:     N (JE GEB.ART)                             00007000
*                                                                       00007100
*      SATZ-AUFBAU:          DATENBASIS IM PROG.DEF.                    00007200
*                                                                       00007300
*      DATEN:                                                           00007400
*      DATEI-ID:             K1V.A20.TARIFDAT (SYS032)                  00007500
*                                                                       00007600
*      DATEI-BEZ.:           TARIF-SCHLUESSEL-DATEI                     00007700
*                                                                       00007800
*      DATEI-ART:            TABELLE                                    00007900
*                                                                       00008000
*      DATEI-VERWENDUNG:     INPUT (LESEN)                              00008100
*                                                                       00008200
*                                                                       00008300
*      SORT:                 KUNDENNR     (3,10)                        00008400
*                            GEB.ART      (11,1)                        00008500
*                            TARIFSCHL.   (14,3)                        00008600
*                            TARIFUNTERGR.(18,2)                        00008700
*                                                                       00008800
*      SPEICHERUNGSFORM:     VSAM                                       00008900
*                                                                       00009000
*      SATZ-FORM:            FIX                                        00009100
*                                                                       00009200
*      SATZART-FELD:         VS03F01                                    00009300
*                                                                       00009400
*      SATZ-BEZ.:            TARIF-SCHLUESSEL                           00009500
*                                                                       00009600
*      SATZ-ART:             03                                         00009700
*                                                                       00009800
*      SATZ-LAENGE:          21(F)                                      00009900
*                                                                       00010000
*      SATZ-HAEUFIGKEIT:     N (JE SORTANGABEN)                         00010100
*                                                                       00010200
*      SATZ-AUFBAU:          DATENBASIS IM PROG.DEF.                    00010300
*                                                                       00010400
*                                                                       00010500
*      DATEN:                                                           00010600
*      DATEI-ID:             K1V.A20.GEWIDAT (SYS031)                   00010700
*                                                                       00010800
*      DATEI-BEZ.:           GEWICHTUNGS-DATEI                          00010900
*                                                                       00011000
*      DATEI-ART:            TABELLE                                    00011100
*                                                                       00011200
*      DATEI-VERWENDUNG:     INPUT (LESEN)                              00011300
*                                                                       00011400
*                                                                       00011500
*      SORT:                 KUNDENNR     (3,10)                        00011600
*                            TAB.NR.      (11,2)                        00011700
*                                                                       00011800
*      SPEICHERUNGSFORM:     VSAM                                       00011900
*                                                                       00012000
*      SATZ-FORM:            FIX                                        00012100
*                                                                       00012200
*      SATZART-FELD:         VS02F01                                    00012300
*                                                                       00012400
*      SATZ-BEZ.:            GEWICHTUNGS-PROZENTE                       00012500
*                                                                       00012600
*      SATZ-ART:             02                                         00012700
*                                                                       00012800
*      SATZ-LAENGE:          39(F)                                      00012900
*                                                                       00013000
*      SATZ-HAEUFIGKEIT:     N (JE SORTANGABEN)                         00013100
*                                                                       00013200
*      SATZ-AUFBAU:          DATENBASIS IM PROG.DEF.                    00013300
*                                                                       00013400
*                                                                       00013500
*      DRUCK-ID:             KV0202                                     00013600
*                                                                       00013700
*      DRUCK-BEZ.:           EINGABE UND PRUEFLISTE                     00013800
*                                                                       00013900
*      FEHLERTEXTE:          IM PROG.DEF.                               00014000
*                                                                       00014100
*                                                                       00014200
*      AUFGABENBESCHREIBUNG:                                            00014300
*                                                                       00014400
*      VERARBEITUNG:         SIEHE ABLAUFDIAGRAMM (DOKUMENTATIONSAKT)   00014500
*                                                                       00014600
*      HAUPTROUTINE:         ERMITTELN ZEITRAUM/MENGE                   00014700
*      HR-1:                 ERMITTELN GESAMT-MENGE UND GESAMT-ANZAHL   00014800
*                            GLEICHER GEB.SAETZE                        00014900
*                                                                       00015000
*      HR-2:                 ERMITTELN GESAMT-PROZENTSAETZE ALLER       00015100
*                            GLEICHEN GEB.SAETZE                        00015200
*                                                                       00015300
*      HR-3:                 ERMITTELN MENGE PRO GEB.SATZ NACH PROZEN-  00015400
*                            TEN DER GEWICHTUNGSTAB.                    00015500
*                                                                       00015600
*      UNTERROUTINEN:                                                   00015700
*      UR-1:                 EINLESEN TARIFSCHLUESSEL- UND GEWICHTUNGS- 00015800
*                            DATEI PRO BEHOERDE.                        00015900
*                                                                       00016000
*      UR-2:                 BEGINN- UND ENMDDATUM PRO GEB.SAETZ        00016100
*                            ERMITTELN.                                 00016200
*                                                                       00016300
*      UR-3:                 ANZAHL TAGE PRO MONAT NACH DATUMS-TAB.     00016400
*                            ERMITTELN.                                 00016500
*                                                                       00016600
*      UR-4:                 GEWICHTUNG UNTERZAEHLER MENGE AUS UZ-      00016700
*                            TEBELLE NACH MENGE HAUPTZAEHLER.           00016800
*                                                                       00016900
*      UR-5:                 GEWICHTUNG KANAL-MENGE AUS KANAL-TAB NACH  00017000
*                            GEWICHTUNGS-TAB.                           00017100
*                                                                       00017200
*      PROGRAMMAUFBAU:                                                  00017300
*      PROGRAMM-STRUKTUR:    VORLAUF,HAUPTROUTINEN,UNTERROUTINEN,       00017400
*                            DEFINITIONEN,DESECT.                       00017500
*                                                                       00017600
*      MAKROS:               YVDS         (EXTERN)                      00017700
*                            ZSTRT        (AKDB)                        00017800
*                            ZEND         (AKDB)                        00017900
*                            ZCALL        (AKDB)                        00018000
*                            ZGKY         (AKDB)                        00018100
*                            ZGTX         (AKDB)                        00018200
*                                                                       00018300
*      DSECT:                ARB,T01A,T02A,TVA                          00018400
*                                                                       00018500
*      REGISTER:             R3 = ARB      ARBEITSBEREICH               00018600
*                            R4 = T010     BEHOERDENSTAMM               00018700
*                            R5 = T025     GEB.SAETZE                   00018800
*                            R6 = TAB2     GEWICHTUNGS-TAB              00018900
*                            R7 = TAB3     TARIF-SCHL.TAB               00019000
*                                                                       00019100
*      TEST:                                                            00019200
*      TEST-HINWEISE:        PROGR. IST IMMER IM V100600 GEBUNDEN       00019300
*                                                                       00019400
*      TEST-VERFAHREN:       MIT TEST-PROZ. V99L0020                    00019500
*                                                                       00019600
*      TEST-DATEN:           K1V.T.DAT01                                00019700
*                                                                       00019800
*      BEDIENUNG:                                                       00019900
*      PARAMETER:            R1 (ARB)                                   00020000
*                                                                       00020100
*    AUFTRAGS-NR.         DATUM         PROGRAMMIERER/AENDERUNG         00020110
*----6------------------25-------------40-----------------------------* 00020111
*    420.834.001.8254    V. 22.02.85    BLAY/FEHLER BEI MEHREREN L7     00020120
*    420.834.001.8711    V. 12.11.85    BLAY/FEHLER BEI UEBERJAEHRIGEM  00020130
*                                       GEB.SATZ.                       00020140
*    420 834 001 8596   V. 11.09.85    NEUE FREIMENGENREGELUNG          00020150
*                                      + ERWEITERUNG FREIM.-            00020160
*                                      BERECHNUNG/KRAMER                00020170
*    436 834 001 0091   V. 21.02.91    FEHLER DIVISION DURCH NULL       00020910
*                                      IN BAYREUTH / HSL               00020920
*      436 834 000 0466 V. 23.08.94  NEUE MAKRO WEGEN MWST
*      DOKUMENTATION-ENDE:                                              00020200
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00020300
         EJECT                                                          00020400
         TITLE 'KV0231 GEWICHTUNG - HAUPTROUTINE'                       00020500
         PRINT NOGEN                                                    00020600
KV0231   ZSTRT BASIS=R11,REGS=2                                         00020700
         SPACE                                                          00020800
*        GEWICHTUNG - VORLAUF                                           00020900
         SPACE                                                          00021000
         L     R3,0(R1)             ARBEITSBEREICH ADRESSIEREN          00021100
         USING ARB,R3                                                   00021200
         L     R4,WT010A            BEHOERDENSTAMM ADRESSIEREN          00021300
         USING T010F01,R4                                               00021400
         L     R5,WT025A            ABNEHMERSTAMM  ADRESSIEREN          00021500
         USING T025F01,R5                                               00021600
         LA    R6,TAB2              TABELLE GEWICHTUNG ADRESSIEREN      00021700
         USING DTAB2,R6                                                 00021800
         LA    R7,TAB3              TABELLE TARIF-SCHL. ADRESSIEREN     00021900
         USING DTAB3,R7                                                 00022000
         CP    WACC4,KP1            VERBRAUCH AUS UZ-TAB GEWICHTEN ?    00022100
         BNE   Z31                  NEIN                                00022200
         BAL   R14,Z314U            VERBRAUCH AUS UZ-TAB GEWICHTEN      00022300
         B     Z313                 ENDE PGM                            00022400
Z31      DS    0H                                                       00022500
         CP    WACC4,KP2            VERBRAUCH AUS KANAL-TAB GEWICHTEN ? 00022600
         BNE   Z311                 NEIN                                00022700
         BAL   R14,Z315U            VERBRAUCH AUS KANAL-TAB GEWICHTEN   00022800
         B     Z313                 ENDE PGM                            00022900
Z311     DS    0H                                                       00023000
         CLC   T010F01,SBEH         BEHOERDENWECHSEL                    00023100
         BE    Z32                  NEIN                                00023200
         MVC   SBEH,T010F01         JA, NEUE BEHOERDE                   00023300
         BAL   R14,Z311U            EINLESEN TARIF + GEWICHTUNGSTAB.    00023400
         CLI   T010F996,C'1'        KZ = REWICHTUNG ?                   00023500
         BE    Z32                  JA                                  00023600
Z312     DS    0H                                                       00023700
         XC    GT025,GT025          LOESCHEN VERGLEICHSFELD             00023800
         XC    GT025N,GT025N        LOESCHEN VERGLEICHSFELD             00023900
Z313     DS    0H                                                       00024000
         ZEND                                                           00024100
         LTORG                                                          00024200
         EJECT                                                          00024300
         TITLE 'KV0231-ERMITTELN GES.MENGE + GES.ANZ. ALLER GLEICHEN GEX00024400
               B.SAETZE (1.ROUTINE).'                                   00024500
Z32      DS    0H                                                       00024600
         MVC   GT025(1),T025F021    SICHERN GA                          00024700
         MVC   GT025+1(3),T025F03   SICHERN TAR.SCHL.                   00024800
         MVC   GT025+4(2),T025F40   SICHERN TAR.UNTERGR.                00024900
         MVC   GT025+6(3),T025F02   SICHERN GA                          00025000
         LA    R7,TAB3              TAR.SCHL.TAB.                       00025100
Z321     DS    0H                                                       00025200
         CLI   DTAB31,X'00'         ENDE TAR.SCHL.TAB. ?                00025300
         BNE   Z3212                JA                                  00025400
         SPACE                                                          00025500
*        UEBERLESEN GLEICHEN GEB.SATZ                                   00025600
         SPACE                                                          00025700
Z3211    DS    0H                                                       00025800
         A     R5,WLT025            ADRESSIEREN NAECHSTEN GEB-SATZ      00025900
         C     R5,WT025             T025 ENDE ?                         00026000
         BNL   Z312                 JA,ENDE PGM                         00026100
         LR    R15,R5               AKTUELLER GEB.SATZ                  00026200
         BAL   R14,Z316U            UEBERTRAGEN IN VERGLEICHSFELD       00026300
         CLC   GT025,GT025N         ALT = AKTUELL ?                     00026400
         BNE   Z32                  NEIN                                00026500
         B     Z3211                                                    00026600
Z3212    DS    0H                                                       00026700
         CLC   GT0251,DTAB30         GEB.SATZ = TAB ?                   00026800
         BE    Z322                 JA                                  00026900
         LA    R7,L'DTAB30(R7)      NEXT ELEMENT                        00027000
         B     Z321                                                     00027100
Z322     DS    0H                                                       00027200
         SPACE                                                          00027300
*        LOESCHEN HILFSFELDER                                           00027400
         SPACE                                                          00027500
         ZAP   VMENG1,KP0           GES.MENGE ALLER GLEICHEN GEB.SAETZE 00027600
         ZAP   VMENG2,KP0           MENGE EINES GEB.SATZES              00027700
         ZAP   VMENG3,KP0           MENGE EINES MONATS ODER TAGE        00027800
         ZAP   GPROZ,KP0            GES.PROZ.SATZ ALLER GLEI. G.SAETZE  00027900
         ZAP   GANZ,KP0             GES. ANZ. GL. GEB.SAETZE            00028000
         ZAP   GMONT,KP0            MONTAGESTAND NEU                    00028100
Z3221    DS    0H                                                       00028200
         CLI   T025F13,C'1'         ZAEHLER ?                           00028300
         BL    Z3234                NEIN                                00028400
         TM    T025F31,LOE          LOESCHUNG GEB.SATZ ?                00028500
         BO    Z3234                JA                                  00028600
         TM    T025F31,IFVA         FRUEHER AUSGEZOGEN ?                00028700
         BO    Z3234                JA                                  00028800
         CLI   T025F86,C'3'         ABRECHNUNG ?                        00028900
         BNE   Z3234                NEIN                                00029000
         CLI   T025F30,C'1'         KEINE GEWICHTUNG ?                  00029100
         BE    Z3234                JA                                  00029200
         PACK  RF2,T025F81          ABLESESTAND                         00029300
         CP    RF2,T025F14          ABLESESTAND > MONTAGESTAND ?        00029400
         BNL   Z3231                JA                                  00029500
         SPACE                                                          00029600
*        ERMITTELN MENGE BEI ZAEHLERUEBERLAUF                           00029700
         SPACE                                                          00029800
         ZAP   RF1,KP1                                                  00029900
         LA    R15,240               R15 = X'F0'                        00030000
         SR    R14,R14                                                  00030100
         IC    R14,T025F13           STELLENZAHL ZAEHLER                00030200
         SR    R14,R15                                                  00030300
Z323     DS    0H                                                       00030400
         MP    RF1,KP10               MAX.ZAEHLERGROESSE                00030500
         BCT   R14,Z323                                                 00030600
         SP    RF1,T025F14            - MONTAGESTAND                    00030700
         AP    RF1,RF2                + ABLESESTAND                     00030800
         AP    VMENG1,RF1             = GES.MENGE GLEICHER GEB.SATZE    00030900
         B     Z3232                                                    00031000
         SPACE                                                          00031100
Z3231    DS    0H                                                       00031200
         ZAP   RF1,RF2                ZAEHLERSTANDS-                    00031300
         SP    RF1,T025F14            DIFFERENZ                         00031400
         AP    VMENG1,RF1             = GES.MENGE GLEICHER GEB.SAETZE   00031500
Z3232    DS    0H                                                       00031600
         AP    GANZ,KP1               ADD ANZ. GEB.SAETZE               00031700
         CP    GANZ,KP1               ANZ.GEB.SAETZE = 1                00031800
         BNE   Z3233                  NEIN                              00031900
         ST    R5,A31R5               SICHERN ADR. GEB.SATZ             00032000
         MVC   GT025(1),T025F021      GEB.ART                           00032100
         MVC   GT025+1(3),T025F03     TAR.SCHL.                         00032200
         MVC   GT025+4(2),T025F40     TAR.UNTZERGR.                     00032300
         MVC   GT025+6(3),T025F02     GEB.ART                           00032400
Z3233    DS    0H                                                       00032500
         TM    T025F32,ZAEHAUS        ZAEHLERAUSWECHSL. ?               00032600
         BNO   Z3234                  NEIN                              00032700
         CP    GANZ,KP1             ANZ. GEB.SAETZE = 1 ?               00033200
         BH    Z331                 NEIN >                              00033300
Z3235    DS    0H                                                       00033310
         A     R5,WLT025            ADRESSIEREN NAECHSTEN GEB-SATZ      00033400
         C     R5,WT025             T025 ENDE ?                         00033500
         BNL   Z312                 JA                                  00033600
         B     Z32                  NEIN                                00033700
Z3234    DS    0H                                                       00033800
         A     R5,WLT025            ADRESSIEREN NAECHSTEN GEB-SATZ      00033900
         C     R5,WT025             T025 ENDE ?                         00034000
         BNL   Z33                  JA                                  00034100
         LR    R15,R5               AKTUELLER GEB.SATZ                  00034200
         BAL   R14,Z316U            UEBERTRAGEN IN VERGLEICHSFELD       00034300
         CLC   GT025,GT025N         ALT = AKTUELL ?                     00034400
         BNE   Z33                  NEIN                                00034500
         B     Z3221                                                    00034600
         LTORG                                                          00034700
         EJECT                                                          00034800
         TITLE 'KV0231-ERMITTELN GES.PROZ.SAETZ ALLER GLEICHEN GEB.SAETX00034900
               ZE (2.ROUTINE).'                                         00035000
Z33      DS    0H                                                       00035100
         CP    GANZ,KP1             ANZ. GEB.SAETZE = 1 ?               00035200
         BH    Z331                 NEIN >                              00035300
         C     R5,WT025             T025 ENDE ?                         00035400
         BNL   Z312                 JA                                  00035500
         B     Z32                  NEIN                                00035600
Z331     DS    0H                                                       00035700
         L     R5,A31R5             1.GUELTIGER GEB.SATZ                00035800
         SPACE                                                          00035900
*        ADRESSIEREN GEWICHTUNGSTAB. NACH TARIFSCHL.TAB.                00036000
         SPACE                                                          00036100
         LA    R6,TAB2              ANFANG GEWICHTUNGSTAB.              00036200
         PACK  HDW1,DTAB34          ZEILENNR. AUS TAR.SCHL.TAB.         00036300
         CVB   R15,HDW1              BINAER                             00036400
         BCTR  R15,0                 - 1                                00036500
         LA    R2,L'DTAB20          LAENGE ELEMENT                      00036600
         MR    R14,R2               TAB.NR. * LAENGE                    00036700
         AR    R6,R15               ADRESSE ELEMENT                     00036800
         CLI   0(R6),X'00'          GEWICHTUNGS-TAB BELEGT ?            00036900
         BNE   Z3311                JA                                  00037000
         MVC   FEHLTEXT(L'Z31FEHL3),Z31FEHL3                            00037100
         MVC   FEHLTEXT+20(L'T025F02),T025F02  GEB-ART                  00037200
         ZCALL KV0202,/ARB                                              00037300
         B     Z3211                 UEBERLESEN ALLE GLEICHEN           00037400
Z3311    DS    0H                                                       00037500
         ST    R6,A31R6              ADRESSE ELEMENT GESICHERT          00037600
Z332     DS    0H                                                       00037700
         BAL   R14,Z312U             ERM. BEGINN + ENDDAT. GEB.SATZ     00037800
Z333     DS    0H                                                       00037900
         LR    R15,R5               AKTUELLER GEB.SATZ                  00038000
         A     R15,WLT025           NEXT GEB.SATZ                       00038100
         C     R15,WT025            ENDE T025 ?                         00038200
         BNL   Z334                 JA                                  00038300
         CLI   T025F86-T025F01(R15),C'3'    ABRECHNUNG ?                00038310
         BNE   Z334                         NEIN                        00038320
         BAL   R14,Z316U            FUELLEN VERGLEICHFELD               00038400
         CLC   GT025,GT025N         AKTUELL = NEXT GEB.SATZ ?           00038500
         BNE   Z334                 NEIN                                00038600
         CLC   HDW+1(1),159(R15)    BEGINNDATUM GLEICH                  00038700
         BE    Z337                 JA                                  00038800
Z334     DS    0H                                                       00038900
         AP    GPROZ,0(2,R6)        GES.PROZ.<- PROZ.MONAT              00039000
         OI    HDW1+L'HDW1-1,X'0C'                                      00039100
         MVO   HDW1,HDW+5(1)        ENDMONAT GEB.SATZ                   00039200
         CP    ZAEHLER1,HDW1        ENDMONAT = ZAEHLER ?                00039300
         BE    Z338                 JA                                  00039400
         CP    ZAEHLER1,KP12        = 12 (LETZTER MONAT)                00039500
         BNE   Z335                 NEIN                                00039600
         L     R6,A31R6             ADRESSIEREN ANFANG                  00039700
         LA    R6,DTAB22            ADRESSIERE 1. MONAT                 00039800
         ZAP   ZAEHLER1,KP1         = 1                                 00039900
         B     Z333                                                     00040000
Z335     DS    0H                                                       00040100
         ZAP   REFE,ZAEHLER1        ZAEHLER                             00040200
         AP    REFE,KP1             + 1                                 00040300
         MP    REFE,KP10            = ENDMONAT                          00040400
         CLC   HDW+5(1),REFE+L'REFE-2  GEB.SATZ ?                       00040500
         BNE   Z336                 NEIN                                00040600
         LR    R15,R5               AKTUELLER GEB.SATZ                  00040700
         A     R15,WLT025           NEXT GEB.SATZ                       00040800
         C     R15,WT025            ENDE T025                           00040900
         BNL   Z336                 JA                                  00041000
         CLI   T025F86-T025F01(R15),C'3'    ABRECHNUNG ?                00041010
         BNE   Z336                         NEIN                        00041020
         BAL   R14,Z316U            FUELLEN VERGLEICHSFELD              00041100
         CLC   GT025,GT025N         AKTUELL = NEXT GEB.SATZ ?           00041200
         BNE   Z336                 NEIN                                00041300
         CLC   T025F52+1(1),159(R15) ENDDATUM = BEGINNDAT.NEXT GEB.S.   00041400
         BNE   Z336                 NEIN                                00041500
         LA    R6,L'DTAB21(R6)      NEXT PROZ.SATZ EVTL. ZAEHAUS        00041600
         B     Z337                 NEIN                                00041700
Z336     DS    0H                                                       00041800
         AP    ZAEHLER1,KP1                                             00041900
         LA    R6,L'DTAB21(R6)      NEXT PROZ.SATZ                      00042000
         B     Z334                                                     00042100
Z337     DS    0H                                                       00042200
         TM    T025F32,ZAEHAUS      ZAEHLERAUSW. ?                      00042300
         BNO   Z338                 NEIN                                00042400
         AP    GPROZ,0(2,R6)        + MONATSPROZ.SATZ                   00042900
         B     Z34                                                      00043000
Z338     DS    0H                                                       00043100
         A     R5,WLT025            NEXT GEB.SATZ                       00043200
         C     R5,WT025             ENDE T025                           00043300
         BNL   Z34                  JA                                  00043400
         CLC   GT025+6(3),T025F02   GEB.ART GLEICH ?                    00043500
         BNE   Z34                  NEIN                                00043600
         CLC   GT025+1(3),T025F03   TAR.SCHL. GLEICH ?                  00043700
         BNE   Z34                  NEIN                                00043800
         CLC   GT025+4(2),T025F40   TAR.UNTERGR. GLEICH ?               00043900
         BNE   Z34                  NEIN                                00044000
         CLI   T025F13,C'1'         ZAEHLER ?                           00044100
         BL    Z338                 NEIN                                00044200
         TM    T025F31,LOE          LOESCHUNG GEB.SATZ ?                00044300
         BO    Z338                 JA                                  00044400
         TM    T025F31,IFVA         FRUEHER AUSGEZOGEN ?                00044500
         BO    Z338                 JA                                  00044600
         CLI   T025F86,C'3'         ABRECHNUNG ?                        00044700
         BNE   Z338                 NEIN                                00044800
         CLI   T025F30,C'1'         KEINE GEWICHTUNG ?                  00044900
         BE    Z338                 JA                                  00045000
         B     Z332                                                     00045100
         LTORG                                                          00045200
         EJECT                                                          00045300
         TITLE 'KV0231-ERMITTELN MENGE NACH % MONAT (GEWICHTUNGSTAB) PRX00045400
               O GEB.SATZ (3.ROUTINE)'                                  00045500
Z34      DS    0H                                                       00045600
         L     R5,A31R5             1.GUELTIGER GEB.SATZ                00045700
         MVC   GT025(1),T025F021      GEB.ART                           00045800
         MVC   GT025+1(3),T025F03     TAR.SCHL.                         00045900
         MVC   GT025+4(2),T025F40     TAR.UNTZERGR.                     00046000
         MVC   GT025+6(3),T025F02     GEB.ART                           00046100
         MP    VMENG1,KP1000          MIT 3 DEZ.ST                      00046200
         ZAP   VMENG2,KP0             MENGE EINES GEB.SATZES            00046300
         BAL   R14,Z312U              ERMITTEL BEGINN + ENDDATUM        00046400
Z342     DS    0H                                                       00046500
         SP    VMENG1,VMENG3          GES.MENGE - MONATS/TAGESMENGE     00046600
Z341     DS    0H                                                       00046700
         ZAP   RF1,0(2,R6)            MONAT PROZ.                       00046800
         MP    RF1,KP1000                                               00046900
         MP    RF1,KP1000                                               00047000
         CP    GPROZ,KP0              ABFRAGE OB NULL  (HSL0091)       00047600
         BE    Z3411                  KEINE DIVISION   (HSL0091)       00047601
         DP    RF1,GPROZ              MONAT : GES.PROZ.= FAKTOR         00047100
Z3411    DS    0H                     KEINE DIVISION   (HSL0091)       00047620
         AP    RF1(L'RF1-L'GPROZ),KP5                                   00047200
         MVO   RF1,RF1(L'RF1-L'GPROZ-1) 3 DEZ.ST.                       00047300
         ZAP   RF2,VMENG1             GES.MENGE                         00047400
         MP    RF2,RF1+11(5)          * FAKTOR                          00047500
         MVO   RF2,RF2(L'RF2-3)       RUNDEN                            00047600
         BAL   R14,Z313U              ERMITTEL ANZ. TAGE                00047700
         CP    RF1,REFE               ANZ.TAGE = MONAT                  00047800
         BE    Z343                   JA                                00047900
         MP    RF2,KP10               4 DEZ. ST.                        00048000
         DP    RF2,RF1+L'RF1-2(2)     MONATS-MENGE : ANZ.MONATSTAGE     00048100
         MVO   RF2,RF2(L'RF2-3)       TAGESMENGE MIT 3 DEZ.ST.          00048200
         MP    RF2,REFE               * ANZ.TAGE                        00048300
Z343     DS    0H                                                       00048400
*        CLC   T025F03,=C'W81'  TESTTESTTESTTESTTESTETSTEST             00048410
*        BNE   XYZ              TESTTESTTESTTESTTEST                    00048420
*        CP    T025F02,KP0  TESTTESTTESTTESTTESTTESTESTESTESTES         00048430
XYZ      DS    0H           TESTTESTTESTTESTTESTTEST                    00048440
         ZAP   RF1,ZAEHLER1                                             00048500
         MP    RF1,KP10                                                 00048600
         CLC   HDW+5(1),RF1+L'RF1-2   ZAEHLER = ENDMONAT GEB.SATZ ?     00048700
         BNE   Z344                   NEIN                              00048800
         LR    R15,R5               AKTUELLER GEB.SATZ                  00048900
         A     R15,WLT025           NEXT GEB.SATZ                       00049000
         C     R15,WT025            ENDE T025                           00049100
         BNL   Z345                 JA                                  00049200
         CLI   T025F86-T025F01(R15),C'3'    ABRECHNUNG ?                00049210
         BNE   Z344                         NEIN                        00049220
         BAL   R14,Z316U            FUELLEN VERGLEICHSFELD              00049300
         CLC   GT025,GT025N         AKTUELL = NEXT GEB.SATZ ?           00049400
         BNE   Z345                 NEIN                                00049500
         CLC   HDW+5(1),152(R15)    ENDMONATE GLEICH ?                  00049600
         BE    Z345                 JA                                  00049700
         CLC   HDW+5(1),159(R15)    ENDMONATE = BEGINNMONAT ?           00049800
         BE    Z345                 JA                                  00049900
Z344     DS    0H                                                       00050000
         SP    GPROZ,0(2,R6)        GES.PROZ - MONATS-PROZ.             00050100
Z345     DS    0H                                                       00050200
         AP    VMENG2,RF2           MONATSMENGE NACH GEB.SATZ MENGE     00050300
         ZAP   VMENG3,RF2           MONATSMENGE                         00050400
         AP    ZAEHLER1,KP1                                             00050500
         ZAP   RF1,ZAEHLER1                                             00050600
         MP    RF1,KP10                                                 00050700
         CLC   RF1+L'RF1-2(1),HDW+5   ZAEHLER > ENDMONAT GEB.SATZ ?     00050800
         BNH   Z346                   NEIN                              00050900
         CP    ZAEHLER2,KP1           WAR JAHRESWECHSEL ?               00051000
         BNE   Z3461                  NEIN                              00051100
         ZAP   ZAEHLER2,KP0           LOESCHEN                          00051200
         B     Z347                                                     00051300
Z3461    DS    0H                                                       00051400
         CLC   HDW+1(2),HDW+5         BEGINNDATUM > ENDEDATUM MMTT      00051500
         BNH   Z347                   NEIN                              00051600
         CP    ZAEHLER1,KP12          = 12 (LETZTER MONAT)              00051610
         BNH   Z346                   NEIN                              00051620
         L     R6,A31R6               BEGINN GEWICHTUNGSTAB.            00051700
         LA    R6,DTAB22              1. MONAT                          00051800
         ZAP   ZAEHLER1,KP1           BEGINN ZAEHLER                    00051900
         ZAP   ZAEHLER2,KP1           JAHRESRWECHSEL                    00052000
         B     Z342                                                     00052100
Z346     DS    0H                                                       00052200
         LA    R6,L'DTAB21(R6)        NEXT PROZ.SATZ (MONAT)            00052300
         B     Z342                                                     00052400
Z347     DS    0H                                                       00052500
         LR    R15,R5               AKTUELLER GEB.SATZ                  00052600
         A     R15,WLT025           NEXT GEB.SATZ                       00052700
         C     R15,WT025            ENDE T025                           00052800
         BNL   Z312                 JA                                  00052900
         CLI   T025F86-T025F01(R15),C'3'    ABRECHNUNG ?                00052910
         BNE   Z354                         NEIN                        00052920
         BAL   R14,Z316U            FUELLEN VERGLEICHSFELD              00053000
         CLC   GT025,GT025N         AKTUELL = NEXT GEB.SATZ ?           00053100
         BNE   Z354                 NEIN                                00053200
         SPACE                                                          00053300
*        PRUEFEN AUF ZAEHLERUEBERLAUF                                   00053400
         SPACE                                                          00053500
         PACK  HDW1,T025F13         ST.Z.ZAEHLER                        00053600
         CVB   R2,HDW1                                                  00053700
         ZAP   RF1,KP1              = 1                                 00053800
Z348     DS    0H                                                       00053900
         MP    RF1,KP10             * 10                                00054000
         BCT   R2,Z348              * ST.Z.ZAEHLER = MAX.ZAEHLERSTAND   00054100
         SP    RF1,T025F14          - MONTAGESTAND                      00054200
         AP    VMENG2,KP500         RUNDEN GEB.SATZ MENGE               00054300
         MVO   VMENG2,VMENG2(L'VMENG2-2) OHNE DEZ.ST.                   00054400
         CP    RF1,VMENG2           REST = > GEB.SATZ MENGE ?           00054500
         BH    Z349                                                     00054600
         SP    VMENG2,RF1           VMENG2 = ABLESESTAND                00054700
         B     Z35                                                      00054800
Z349     DS    0H                                                       00054900
         AP    VMENG2,T025F14       VMENG2 = ABLESESTAND                00055000
Z35      DS    0H                                                       00055100
         UNPK  T025F81,VMENG2       ABLESESTAND                         00055200
         OI    T025F81+L'T025F81-1,X'F0'                                00055300
         LA    R15,8                LAENGE T025F81-1                    00055400
         LA    R14,T025F81          ADRESSE                             00055500
Z351     DS    0H                                                       00055600
         CLI   0(R14),C'0'          NULL ?                              00055700
         BNE   Z3511                NEIN,ENDE                           00055800
         MVI   0(R14),C' '          JA,LOESCHEN                         00055900
         LA    R14,1(R14)                                               00056000
         BCT   R15,Z351                                                 00056100
Z3511    DS    0H                                                       00056200
         ZAP   GMONT,VMENG2         SICHERN FUER MONTAGESTAND           00056300
Z352     DS    0H                                                       00056400
         A     R5,WLT025            NEXT GEB.SATZ                       00056500
         C     R5,WT025             ENDE T025                           00056600
         BNL   Z312                 JA,ENDE PGM                         00056700
         TM    T025F32,ZAEHAUS      ZAEHLERAUSWECHS.                    00056800
         BNO   Z353                 NEIN                                00056900
Z3521    DS    0H                                                       00057700
         ZAP   T025F14,GMONT        UEBERTRAGEN MONTAGESTAND            00057800
         B     Z354                                                     00057900
Z353     DS    0H                                                       00058000
         CLI   T025F13,C'1'         ZAEHLER ?                           00058100
         BL    Z352                 NEIN                                00058200
         TM    T025F31,LOE          LOESCHUNG GEB.SATZ ?                00058300
         BO    Z352                 JA                                  00058400
         TM    T025F31,IFVA         FRUEHER AUSGEZOGEN ?                00058500
         BO    Z352                 JA                                  00058600
         CLI   T025F86,C'3'         ABRECHNUNG ?                        00058700
         BNE   Z352                 NEIN                                00058800
         CLI   T025F30,C'1'         KEINE GEWICHTUNG ?                  00058900
         BE    Z352                 JA                                  00059000
         ZAP   T025F14,GMONT        UEBERTRAGEN MONTAGESTAND            00059100
         LR    R15,R5               AKTUELLER GEB.SATZ                  00059200
         A     R15,WLT025           NEXT GEB.SATZ                       00059300
         C     R15,WT025            ENDE T025                           00059400
         BNL   Z312                 JA,ENDE PGM                         00059500
         BAL   R14,Z316U            FUELLEN VERGLEICHSFELD              00059600
         CLC   GT025,GT025N         AKTUELL = NEXT GEB.SATZ ?           00059700
         BNE   Z344                 NEIN                                00059800
         SP    VMENG1,VMENG3        GES.MENGE - MONATS/TAGESGMENGE      00059900
         AP    VMENG1,KP500         RUNDEN FUER FOLGENDEN GEB.SATZ      00060000
         MVO   VMENG1,VMENG1(L'VMENG1-2)   LOESCHEN DEZ. ST.            00060100
         MP    VMENG1,KP1000        NEUE DEZ. ST.                       00060200
         ZAP   VMENG2,KP0           MENGE EINES GEB.SATZES              00060300
         BAL   R14,Z312U            EREMITTELN BEGINN + ENDDAT.         00060400
         B     Z341                                                     00060500
Z354     DS    0H                                                       00060600
         A     R5,WLT025            NEXT GEB.SATZ                       00060700
         C     R5,WT025             ENDE T025 ?                         00060800
         BNL   Z312                 JA,ENDE PGM                         00060900
         B     Z32                                                      00061000
         LTORG                                                          00061100
         EJECT                                                          00061200
         TITLE 'KV0231-EINLESEN TARIF-SCHLUESSEL + GEWICHTUNGSDATEI (UNX00061300
               TERROUTINE 1)'                                           00061400
         DS    F                                                        00061500
Z311U    ST    R14,Z311U-4                                              00061600
         SPACE                                                          00061700
*        LOESCHEN GEWICHTUNGS-TABELLE                                   00061800
         SPACE                                                          00061900
         MVC   DTAB21,KC00         LOESCHEN TABELLEN-NR.                00062000
         LA    R14,DTAB22          ADRESSE %SATZ                        00062100
         LA    R15,12              LOESCHRN                             00062200
Z311U0   DS    0H                  PROZENTSATZ                          00062300
         ZAP   0(L'DTAB22,R14),KP0 ANGABE                               00062400
         LA    R14,L'DTAB22(R14)   NEXT %SATZ                           00062500
         BCT   R15,Z311U0                                               00062600
         SPACE                                                          00062700
         LA    R15,49              ANZ.REST ELEMENT                     00062800
Z311U00  DS    0H                  PROZENTSATZ                          00062900
         MVC   0(L'DTAB20,R14),DTAB20  LOESCHEN NEXT ELEMENT            00063000
         BCT   R15,Z311U00                                              00063100
         MVC   SKEY11,T010F01      BEH.NR.                              00063200
         MVC   SKEY12,K1           KLEINSTE TABELLEN-NR.                00063300
         MVC   SKEY21,T010F01      BEH.NR.                              00063400
         MVC   SKEY22,KC99         GROESSTE TABELLEN-NR.                00063500
         ZGKY  SYS031,GQU,WRA1,SKEY1,SKEY2                              00063600
         CLI   GQU,C'0'            SATZ GEFUNDEN ?                      00063700
         BE    Z311U1              JA                                   00063800
         MVC   FEHLTEXT(L'Z31FEHL1),Z31FEHL1                            00063900
         ZCALL KV0202,/ARB                                              00064000
         B     Z311U15             ENDE UR1                             00064100
Z311U1   DS    0H                                                       00064200
         LA    R6,TAB2             GEWICHTUNGSTAB                       00064300
         L     R10,WRA1            EINGABE-SATZ                         00064400
         USING VS02,R10            D-SECTION                            00064500
         PACK  HDW1,VS02F03        TAB.NR.                              00064600
         CVB   R15,HDW1            BINAER                               00064700
         BCTR  R15,0               - 1                                  00064800
         LA    R2,L'DTAB20         LAENGE ELEMENT                       00064900
         MR    R14,R2              TAB.NR. * LAENGE ELEMENT             00065000
         AR    R6,R15              ADRESSE ELEMENT                      00065100
         MVC   DTAB21,VS02F03      TAB.NR.                              00065200
         MVC   DTAB22(L'DTAB20-2),VS02F05  %SAETZE                      00065300
         ZGTX  SYS031,GQU1,WRA1                                         00065400
         CLC   GQU1(2),K10          ENDE BEH.                           00065500
         BNE   Z311U1               NEIN                                00065600
         DROP  R10                                                      00065700
         SPACE                                                          00065800
*        LOESCHEN TARIF-SCHLUESSEL TABELLE                              00065900
         SPACE                                                          00066000
         LA    R14,DTAB3            ADRESSE TABELLE                     00066100
         LA    R15,500              ANZ. MAX.                           00066200
Z311U11  DS    0H                                                       00066300
         XC    DTAB30(L'DTAB30+2),DTAB30                                00066400
         LA    R14,L'DTAB30+2(R14)   LOESCHEN                           00066500
         BCT   R15,Z311U11           NEXT                               00066600
         SPACE                                                          00066700
         MVC   SKEY30,T010F01      BEH.NR.                              00066800
         XC    SKEY31(6),SKEY31    KLEINSTE TABELLEN-NR.                00066900
         MVC   SKEY40,T010F01      BEH.NR.                              00067000
         MVI   SKEY41,X'FF'        GROESSTE TABELLEN-NR.                00067100
         MVC   SKEY42(5),SKEY41    GROESSTE TABELLEN-NR.                00067200
         MVC   SKEY42+1(4),SKEY42                                       00067300
         ZGKY  SYS032,GQU,WRA1,SKEY3,SKEY4                              00067400
         CLI   GQU,C'0'            SATZ GEFUNDEN ?                      00067500
         BE    Z311U12             JA                                   00067600
         MVC   FEHLTEXT(L'Z31FEHL2),Z31FEHL2                            00067700
         ZCALL KV0202,/ARB                                              00067800
Z311U15  DS    0H                                                       00067900
         MVI   T010F996,C'0'       KEINE GEWICHTUNG                     00068000
         B     Z311U14             ENDE UR1                             00068100
Z311U12  DS    0H                                                       00068200
         L     R10,WRA1            EINGABE-SATZ                         00068300
         USING VS03,R10            D-SECTION                            00068400
         MVC   DTAB30(6),VS03F03      SPEICHERN TAR.SCHL.DATEI          00068500
         MVC   DTAB34,VS03F07                                           00068600
         LA    R7,L'DTAB30(R7)                                          00068700
         ZGTX  SYS032,GQU1,WRA1                                         00068800
         CLC   GQU1(2),K10          ENDE BEH.                           00068900
         BNE   Z311U12              NEIN                                00069000
Z311U14  DS    0H                                                       00069100
         L     R14,Z311U-4                                              00069200
         BR    R14                                                      00069300
         DROP  R10                                                      00069400
         LTORG                                                          00069500
         EJECT                                                          00069600
         TITLE 'KV0231-BEGINN- UND ENDDATUM DES GEB.SATZES EMITTELN (UNX00069700
               TERROUTINE 2)'                                           00069800
         DS    F                                                        00069900
Z312U    ST    R14,Z312U-4                                              00070000
         L     R10,WTVAA            ADRESSE TVA                         00070100
         USING TVA,R10                                                  00070200
         XC    HDW1(2),HDW1                                             00070300
         MVC   HDW1+1(1),T025F021   GAB.ART                             00070400
         TR    HDW1+1(1),TABGA      NUMERISCH                           00070500
         L     R2,WLTVA             LAENGE EINES ELEMENTES              00070600
         MH    R2,HDW1              * GEB.ART                           00070700
         AR    R10,R2               + BASIS = TVA FUER GA               00070800
         CLI   TVAF03,C'B'          BERECHNUNG ?                        00070900
         BE    Z312U1               JA                                  00071000
         SPACE                                                          00071010
*        BEI ABSCHLAG MIT ZWISCHENABRECHNUNG ERLEDIGTEN                 00071020
*        ZEITRAUM BERUECKSICHTIGEN                                      00071030
         CLC   T025F021,T010F981    GEB.ART ZWISCHENABRECHNUNG ?        00071040
         BE    Z312U11              JA                                  00071050
         CLC   T025F021,T010F982    GEB.ART ZWISCHENABRECHNUNG ?        00071060
         BE    Z312U11              JA                                  00071070
         CLC   T025F021,T010F983    GEB.ART ZWISCHENABRECHNUNG ?        00071080
         BE    Z312U11              JA                                  00071090
         CLI   T025F52+L'T025F52-1,X'00' ENDDATUM BELEGT ?              00071091
         BE    Z312U12                   NEIN                           00071092
         MVC   HDW+4(3),T025F52      ENDDATUM AUS GEB.SATZ JJMMTT       00071093
         B     Z312U13                                                  00071094
Z312U12  DS    0H                                                       00071095
         MVC   HDW+4(3),TVAF06       ENDDATUM AUS TVA   JJMMTT          00071096
Z312U13  DS    0H                                                       00071097
         MVC   HDW(3),TVAF05         BEGINNDATUM AUS TVA   JJMMTT       00071098
         B     Z312U31                                                  00071099
Z312U11  DS    0H                                                       00071100
         L     R2,WLTVA             LAENGE EINES ELEMENTES              00071110
         MH    R2,TGAF00            * 7 = LAENGE EINER TVA              00071200
         AR    R10,R2               +BASIS=TVA FUER ABSCHL.(ZWI.ABRE)   00071300
         SPACE                                                          00071310
Z312U1   DS    0H                                                       00071400
         CLI   T025F52+L'T025F52-1,X'00' ENDDATUM BELEGT ?              00071500
         BE    Z312U2                    NEIN                           00071600
         MVC   HDW+4(3),T025F52      ENDDATUM AUS GEB.SATZ JJMMTT       00071700
         B     Z312U3                                                   00071800
Z312U2   DS    0H                                                       00071900
         MVC   HDW+4(3),TVAF02       ENDDATUM AUS TVA   JJMMTT          00072000
Z312U3   DS    0H                                                       00072100
         MVC   HDW(3),TVAF01         BEGINNDATUM AUS TVA   JJMMTT       00072200
Z312U31  DS    0H                                                       00072210
         CLC   T025F55,HDW           BEGINNDATUM AUS T025 > ?           00072300
         BNH   Z312U4                NEIN                               00072400
         MVC   HDW(3),T025F55        BEGINNDATUM AUS T025  JJMMTT       00072500
Z312U4   DS    0H                                                       00072600
         ZAP   ZAEHLER1,KP0                                             00072700
         MVO   ZAEHLER1,HDW+1(1)     MONATSBEGINN                       00072800
         SPACE                                                          00072900
*        ADRESSIEREN MONAT IN GEWICHTUNGS-TAB.                          00073000
         SPACE                                                          00073100
         L     R6,A31R6              ADRESSE ELEMENT GEWI.TAB.          00073200
         LA    R2,L'DTAB22           LAENGE EINES FELDES                00073300
         ZAP   HDW1,ZAEHLER1                                            00073400
         CVB   R15,HDW1               BINAER                            00073500
         BCTR  R15,0                  - 1                               00073600
         MR    R14,R2                * MONATSZAHL                       00073700
         LA    R6,DTAB22             ADRESSE MONAT 01                   00073800
         AR    R6,R15                ADR.BEGINNMONAT GEB.SATZ           00073900
         L     R14,Z312U-4                                              00074000
         BR    R14                                                      00074100
         DROP  R10                                                      00074200
         LTORG                                                          00074300
         EJECT                                                          00074400
         TITLE 'KV0231-ERMITTEL ANZAHL TAGE PRO MONAT NACH DATUMS-TAB AX00074500
               AUS ARB.(UNTERROUTINE 3)'                                00074600
         DS    F                                                        00074700
Z313U    ST    R14,Z313U-4                                              00074800
         ZAP   RF1,ZAEHLER1         AKTUELLER MONAT                     00074900
         MP    RF1,KP10                                                 00075000
         CLC   RF1+L'RF1-2(1),HDW+1 BEGINN MONAT                        00075100
         BE    Z313U11              JA, ANTEIL TAGE MOEGLICH            00075200
         CLC   RF1+L'RF1-2(1),HDW+5 ENDE   MONAT                        00075300
         BE    Z313U11              JA, ANTEIL TAGE MOEGLICH            00075400
         ZAP   REFE,KP0             KEIN TAGESANTEIL                    00075500
         ZAP   RF1,KP0              KEIN TAGESANTEIL                    00075600
         B     Z313U5               ENDE                                00075700
Z313U11  DS    0H                                                       00075800
         TM    HDW+4,X'03'          JAHR = SCHALTJAHR                   00075900
         BZ    Z313U1               JA                                  00076000
         LA    R8,TDAT              ADR.'KEIN SCHALTJAHR'               00076100
         B     Z313U2                                                   00076200
Z313U1   DS    0H                                                       00076300
         LA    R8,TDATS             ADR. 'SCHALTJAHR'                   00076400
Z313U2   DS    0H                                                       00076500
         ZAP   HDW1,ZAEHLER1        AKTUELLER MONAT                     00076600
         CVB   R15,HDW1             BINAER                              00076700
         LA    R2,L'TDAT            LAENGE EINES ELEMENTES              00076800
         MR    R14,R2               * MONAT                             00076900
         AR    R8,R15               + BASIS                             00077000
         ZAP   RF1,0(2,R8)          = MONAT                             00077100
         LA    R2,L'TDAT            LAENGE EINES ELEMENTES              00077200
         SR    R8,R2                - VORMONAT                          00077300
         SP    RF1,0(2,R8)          = ANZ.TAGE LT. TAB                  00077400
         CLC   HDW+1(1),HDW+5       BEGINN- = ENDMONAT ?                00077500
         BNE   Z313U3               NEIN                                00077600
         ZAP   REFE,KP0                                                 00077700
         MVO   REFE,HDW+6(1)        ENDTAG                              00077800
Z313U4   DS    0H                                                       00077900
         ZAP   REFE1,KP0                                                00078000
         MVO   REFE1,HDW+2(1)       BEGINNTAG                           00078100
         SP    REFE,REFE1           DIFFERENZ ANZ.TAGE                  00078200
         AP    REFE,KP1             + 1 =ANZ.TAGE GEB.SATZ              00078300
         B     Z313U5               ENDE UNTERROUTINE                   00078400
Z313U3   DS    0H                                                       00078500
         ZAP   REFE,RF1             ENDTAG LT.DATUM-TAB                 00078600
         ZAP   REFE1,ZAEHLER1       AKTUELLER MONAT                     00078700
         MP    REFE1,KP10                                               00078800
         CLC   REFE1+L'REFE1-2(1),HDW+1 BEGINN MONAT                    00078900
         BNE   Z313U31              NEIN, ENDE MONAT                    00079000
         ZAP   REFE1,KP0                                                00079100
         MVO   REFE1,HDW+2(1)       BEGINNTAG                           00079200
         SP    REFE,REFE1           DIFFERENZ ANZ.TAGE                  00079300
         AP    REFE,KP1             + 1 =ANZ.TAGE GEB.SATZ              00079400
         B     Z313U5               JA, ANTEIL TAGE MOEGLICH            00079500
Z313U31  DS    0H                                                       00079600
         ZAP   REFE,KP0                                                 00079700
         MVO   REFE,HDW+6(1)       ENDETAG                              00079800
Z313U5   DS    0H                                                       00079900
         L     R14,Z313U-4                                              00080000
         BR    R14                                                      00080100
         LTORG                                                          00080200
         EJECT                                                          00080300
         TITLE 'KV0231-GEWICHTUNG UNTERZAEHLER ANTEILIG NACH MENGE HAUPX00080400
               ZAEHLER AUS UZ-TABELLE (UNTERROUTINE 4)'                 00080500
         SPACE                                                          00080600
*  PRUEFEN OB UZ-MENGE GEWICHTET WIRD                                   00080700
         SPACE                                                          00080800
         DS    F                                                        00080900
Z314U    ST    R14,Z314U-4                                              00081000
         L     R5,F1                AKTUELLER SATZ                      00081100
         ZAP   VMENG1,KP0           GES.MENGE ALLER GLEICHEN GEB.SAETZE 00081200
         CLC   GT025+6(3),T025F02   GEB.ART GLEICH ?                    00081300
         BNE   Z314U1               NEIN                                00081400
         CLC   GT025+1(3),T025F03   TAR.SCHL. GLEICH ?                  00081500
         BNE   Z314U1               NEIN                                00081600
         CLC   GT025+4(2),T025F40   TAR.UNTERGR. GLEICH ?               00081700
         BNE   Z314U1               NEIN                                00081800
         B     Z314U5               JA                                  00081900
Z314U1   DS    0H                                                       00082000
         ZAP   UMENG1,RF1           UNTERZAEHLER-MENGE                  00082100
         ZAP   UMENG2,RF1           INTERNE UZ-MENGE (MENGE1)           00082200
         LR    R15,R5               AKTUELLER GEB.SATZ                  00082300
         BAL   R14,Z316U            FUELLEN VERGLEICHSFELD              00082400
         LA    R7,TAB3              BEGINN TAR.SCHL.TAB.                00082500
Z314U2   DS    0H                                                       00082600
         CLI   DTAB31,X'00'         ENDE TAB ?                          00082700
         BE    Z314U3               JA, ENDE PGM,KEIN TAR.SCHL.         00082800
         CLC   GT0252,DTAB30        GEB.SATZ = TAB. ?                   00082900
         BE    Z314U5               JA                                  00083000
         LA    R7,L'DTAB30(R7)      NEXT TAB.-ELEMENT                   00083100
         B     Z314U2                                                   00083200
Z314U3   DS    0H                                                       00083300
         ZAP   REFE,KP0             KEINE GEWICHTUNG                    00083400
Z314U4   DS    0H                                                       00083500
         L     R14,Z314U-4                                              00083600
         BR    R14                                                      00083700
         SPACE                                                          00083800
*  ERMITTEL GESAMTE HZ-MENGE ALLER GLEICHEN GEB.SAETZE                  00083900
         SPACE                                                          00084000
Z314U5   DS    0H                                                       00084100
         LR    R15,R5               AKTUELLER GEB.SATZ                  00084200
         A     R15,WLT025           NEXT GEB.SATZ                       00084300
         C     R15,WT025            ENDE T025 ?                         00084400
         BNL   Z314U6               JA                                  00084500
         BAL   R14,Z316U            FUELLEN VERGLEICHFELD               00084600
         CLC   GT025N+6(3),T025F02  GEB.ART GLEICH ?                    00084700
         BNE   Z314U6               NEIN                                00084800
         CLC   GT025N+1(3),T025F03  TAR.SCHL. GLEICH ?                  00084900
         BNE   Z314U6               NEIN                                00085000
         CLC   GT025N+4(2),T025F40  TAR.UNTERGR. GLEICH ?               00085100
         BE    Z314U7               JA                                  00085200
Z314U6   DS    0H                                                       00085300
         ZAP   REFE,UMENG2          RESTMENGE                           00085400
         ZAP   UMENG2,KP0                                               00085500
         XC    GT025,GT025          LOESCHEN VERGLEICHSFELD             00085600
         XC    GT025N,GT025N        LOESCHEN VERGLEICHSFELD             00085700
         B     Z314U4                                                   00085800
Z314U7   DS    0H                                                       00085900
         MVC   GT025,GT025N         VERGLEICHSFELD AKT. GEB.SATZ        00086000
         L     R5,WT025A            BEGINN T025                         00086100
Z314U8   DS    0H                                                       00086200
         TM    T025F31,LOE          LOESCHUNG GEB.SATZ ?                00086300
         BO    Z314U12              JA                                  00086400
         TM    T025F31,IFVA         FRUEHER AUSGEZOGEN ?                00086500
         BO    Z314U12              JA                                  00086600
         CLI   T025F86,C'3'         ABRECHNUNG ?                        00086700
         BNE   Z314U12              NEIN                                00086800
         CLI   T025F30,C'1'         KEINE GEWICHTUNG ?                  00086900
         BE    Z314U12              JA                                  00087000
         LR    R15,R5               AKTUELLER GEB.SATZ                  00087100
         BAL   R14,Z316U            FUELLEN VERGLEICHFELD               00087200
         CLC   GT025,GT025N         GLEICH ?                            00087300
         BNE   Z314U12              NEIN                                00087400
         PACK  RF2,T025F81          ABLESESTAND                         00087500
         CP    RF2,T025F14          ABLESESTAND > MONTAGESTAND ?        00087600
         BNL   Z314U10              JA                                  00087700
         SPACE                                                          00087800
*        ERMITTELN MENGE BEI ZAEHLERUEBERLAUF                           00087900
         SPACE                                                          00088000
         ZAP   RF1,KP1                                                  00088100
         LA    R15,240              'F0'                                00088200
         SR    R14,R14                                                  00088300
         IC    R14,T025F13          ST.Z.ZAEHLER                        00088400
         SR    R14,R15                                                  00088500
Z314U9   DS    0H                                                       00088600
         MP    RF1,KP10             * 10                                00088700
         BCT   R14,Z314U9           MAX.ZAEHLERGROESSE                  00088800
         SP    RF1,T025F14          MAX.ZAEHL.STAND - MONTAGESTAND      00088900
         AP    RF1,RF2              + ABLESESTAND                       00089000
         B     Z314U11                                                  00089100
         SPACE                                                          00089200
Z314U10  DS    0H                                                       00089300
         ZAP   RF1,RF2              ABLESESTAND                         00089400
         SP    RF1,T025F14          - MONTAGESTAND                      00089500
Z314U11  DS    0H                                                       00089600
         AP    VMENG1,RF1           MENGE GESAMT                        00089700
         AP    GANZ,KP1             ANZ.GEB.SAETZE                      00089800
Z314U12  DS    0H                                                       00089900
         A     R5,WLT025            ADRESSIEREN NAECHSTEN GEB-SATZ      00090000
         C     R5,WT025             T025 ENDE ?                         00090100
         BNL   Z314U13              JA                                  00090200
         B     Z314U8               NEIN                                00090300
         SPACE                                                          00090400
*  ERMITTEL MENGE PRO HZ-GEB.SATZ                                       00090500
         SPACE                                                          00090600
Z314U13  DS    0H                                                       00090700
         CP    GANZ,KP1            ANZ. > 1 ?                           00090800
         BNH   Z314U3              NEIN ENDE                            00090900
         L     R5,F1               AKTUELLER GEB.SATZ                   00091000
*        ERMITTELN MENGE GEB.SATZ                                       00091100
         PACK  RF2,T025F81          ABLESESTAND                         00091200
         CP    RF2,T025F14          ABLESESTAND > MONTAGESTAND ?        00091300
         BNL   Z314U15              JA                                  00091400
         SPACE                                                          00091500
*        ERMITTELN MENGE BEI ZAEHLERUEBERLAUF                           00091600
         SPACE                                                          00091700
         ZAP   RF1,KP1                                                  00091800
         LA    R15,240              'F0'                                00091900
         SR    R14,R14                                                  00092000
         IC    R14,T025F13          ST.Z.ZAEHLER                        00092100
         SR    R14,R15                                                  00092200
Z314U14  DS    0H                                                       00092300
         MP    RF1,KP10             * 10                                00092400
         BCT   R14,Z314U14          MAX.ZAEHLERGROESSE                  00092500
         SP    RF1,T025F14          MAX.ZAEHL.STAND - MONTAGESTAND      00092600
         AP    RF1,RF2              + ABLESESTAND                       00092700
         B     Z314U16                                                  00092800
         SPACE                                                          00092900
Z314U15  DS    0H                                                       00093000
         ZAP   RF1,RF2              ABLESESTAND                         00093100
         SP    RF1,T025F14          - MONTAGESTAND                      00093200
         SPACE                                                          00093300
*  ERMITTEL UZ-MENGE UEBER HZ-MENGE                                     00093400
         SPACE                                                          00093500
Z314U16  DS    0H                                                       00093600
         MP    RF1,KP1000                                               00093700
         MP    RF1,KP100                                                00093800
         DP    RF1,VMENG1          GEB.SATZ MENGE : GES.MENGE           00093900
         AP    RF1(L'RF1-L'VMENG1),KP5  = PROZ.SATZ                     00094000
         MVO   RF1,RF1(L'RF1-L'VMENG1-1)                                00094100
         ZAP   RF2,UMENG1          UNTERZ. MENGEAUS TAB.                00094200
         MP    RF2,RF1+11(5)       UZ-MENGE * PROZ.SATZ                 00094300
         MVO   RF2,RF2(L'RF2-2)                                         00094400
         AP    RF2,KP5                                                  00094500
         MVO   RF2,RF2(L'RF2-1)                                         00094600
         SP    UMENG2,RF2          RESTMENGE UZ-VERBRAUCH               00094700
         ZAP   REFE,RF2            UZ-MENGE FUER HZ                     00094800
         B     Z314U4                                                   00094900
         EJECT                                                          00095000
         TITLE 'KV0231-GEWICHTUNG KANAL-MENGEN AUS KANAL-TAB NACH GEWICX00095100
               HZUNGS-TAB. (UNTERROUTINE 5)'                            00095200
*        ERMITTEL ANZAHL GLEICHER GEB.SAETZE (1.ROUTINE).               00095300
         SPACE                                                          00095400
         DS    F                                                        00095500
Z315U    ST    R14,Z315U-4                                              00095600
         L     R5,F1                AKTUELLER SATZ                      00095700
         ZAP   VMENG2,KP0           GEB.SATZ-MENGE                      00095800
         CLC   GT025+6(3),T025F02   GEB.ART GLEICH ?                    00095900
         BNE   Z315U1               NEIN                                00096000
         CLC   GT025+1(3),T025F03   TAR.SCHL. GLEICH ?                  00096100
         BNE   Z315U1               NEIN                                00096200
         CLC   GT025+4(2),T025F40   TAR.UNTERGR. GLEICH ?               00096300
         BNE   Z315U1               NEIN                                00096400
         B     Z315U20              JA                                  00096500
Z315U1   DS    0H                                                       00096600
         ZAP   GANZ,KP0             ANZAHL ALLER GLEICHEN GEB.SAETZE    00096700
         ZAP   GPROZ,KP0            GES.PROZENTSATZ ALLER GLEICHEN      00096800
         ZAP   VMENG3,KP0           MONATS-MENGE                        00096900
         ZAP   KMENG1,RF1           KANAL-MENGE                         00097000
         MP    KMENG1,KP1000        MI 3 DEZ. STELLEN                   00097100
         ZAP   KMENG2,RF1           INTERNE KANAL-MENGE (MENGE1)        00097200
         LR    R15,R5               AKTUELLER GEB.SATZ                  00097300
         BAL   R14,Z316U            FUELLEN VERGLEICHSFELD              00097400
         LA    R7,TAB3              BEGINN TAR.SCHL.TAB.                00097500
Z315U2   DS    0H                                                       00097600
         CLI   DTAB31,X'00'         ENDE TAB ?                          00097700
         BE    Z315U3               JA, ENDE PGM,KEIN TAR.SCHL.         00097800
         CLC   GT0252,DTAB30        GEB.SATZ = TAB. ?                   00097900
         BE    Z315U5               JA                                  00098000
         LA    R7,L'DTAB30(R7)      NEXT TAB.-ELEMENT                   00098100
         B     Z315U2                                                   00098200
Z315U3   DS    0H                                                       00098300
         ZAP   REFE,KP0             KEINE GEWICHTUNG                    00098400
Z315U4   DS    0H                                                       00098500
         L     R14,Z315U-4                                              00098600
         BR    R14                                                      00098700
         SPACE 4                                                        00098800
Z315U5   DS    0H                                                       00098900
         LR    R15,R5               AKTUELLER GEB.SATZ                  00099000
         A     R15,WLT025           NEXT GEB.SATZ                       00099100
         C     R15,WT025            ENDE T025 ?                         00099200
         BNL   Z315U6               JA                                  00099300
         BAL   R14,Z316U            FUELLEN VERGLEICHFELD               00099400
         CLC   GT025N+6(3),T025F02  GEB.ART GLEICH ?                    00099500
         BNE   Z315U6               NEIN                                00099600
         CLC   GT025N+1(3),T025F03  TAR.SCHL. GLEICH ?                  00099700
         BNE   Z315U6               NEIN                                00099800
         CLC   GT025N+4(2),T025F40  TAR.UNTERGR. GLEICH ?               00099900
         BE    Z315U7               JA                                  00100000
Z315U6   DS    0H                                                       00100100
         ZAP   REFE,KMENG2          RESTMENGE                           00100200
         ZAP   KMENG2,KP0                                               00100300
         XC    GT025,GT025          LOESCHEN VERGLEICHSFELD             00100400
         XC    GT025N,GT025N        LOESCHEN VERGLEICHSFELD             00100500
         B     Z315U4               JA                                  00100600
Z315U7   DS    0H                                                       00100700
         MVC   GT025,GT025N         VERGLEICHSFELD AKT. GEB.SATZ        00100800
         L     R5,WT025A            BEGINN T025                         00100900
Z315U8   DS    0H                                                       00101000
         TM    T025F31,LOE          LOESCHUNG GEB.SATZ ?                00101100
         BO    Z315U12              JA                                  00101200
         TM    T025F31,IFVA         FRUEHER AUSGEZOGEN ?                00101300
         BO    Z315U12              JA                                  00101400
         CLI   T025F86,C'3'         ABRECHNUNG ?                        00101500
         BNE   Z315U12              NEIN                                00101600
         CLI   T025F30,C'1'         KEINE GEWICHTUNG ?                  00101700
         BE    Z315U12              JA                                  00101800
         LR    R15,R5               AKTUELLER GEB.SATZ                  00101900
         BAL   R14,Z316U            FUELLEN VERGLEICHFELD               00102000
         CLC   GT025,GT025N         GLEICH ?                            00102100
         BNE   Z315U12              NEIN                                00102200
         AP    GANZ,KP1                                                 00102300
Z315U12  DS    0H                                                       00102400
         A     R5,WLT025            ADRESSIEREN NAECHSTEN GEB-SATZ      00102500
         C     R5,WT025             T025 ENDE ?                         00102600
         BNL   Z315U13              JA                                  00102700
         B     Z315U8               NEIN                                00102800
         LTORG                                                          00102900
         EJECT                                                          00103000
* ERMITTELN GES.% SATZ ALLER GLEICHEN GEB.SAETZE (2.ROUTINE)            00103100
         SPACE 2                                                        00103200
Z315U13  DS    0H                                                       00103300
         CP    GANZ,KP1             ANZ. GEB.SAETZE = 1 ?               00103400
         BNH   Z315U4               NEIN,ENDE UP                        00103500
         L     R5,F1                1.GUELTIGER GEB.SATZ                00103600
         SPACE                                                          00103700
*        ADRESSIEREN GEWICHTUNGSTAB. NACH TARIFSCHL.TAB.                00103800
         SPACE                                                          00103900
         LA    R6,TAB2              ANFANG GEWICHTUNGSTAB.              00104000
         PACK  HDW1,DTAB34          ZEILENNR. AUS TAR.SCHL.TAB.         00104100
         CVB   R15,HDW1             BINAER                              00104200
         BCTR  R15,0                - 1                                 00104300
         LA    R2,L'DTAB20          LAENGE ELEMENT                      00104400
         MR    R14,R2               TAB.NR. * LAENGE                    00104500
         AR    R6,R15               ADRESSE ELEMENT                     00104600
         CLI   0(R6),X'00'          GEWICHTUNGS-TAB BELEGT ?            00104700
         BNE   Z315U131             JA                                  00104800
         MVC   FEHLTEXT(L'Z31FEHL3),Z31FEHL3                            00104900
         MVC   FEHLTEXT+20(L'T025F02),T025F02  GEB-ART                  00105000
         ZCALL KV0202,/ARB                                              00105100
         XC    GT025,GT025          LOESCHEN VERGLEICHSFELD             00105200
         XC    GT025N,GT025N        LOESCHEN VERGLEICHSFELD             00105300
         B     Z315U3               ENDE,KEINE GEWICHTUNG               00105400
Z315U131 DS    0H                                                       00105500
         ST    R6,A31R6             ADRESSE ELEMENT SICHERN             00105600
Z315U14  DS    0H                                                       00105700
         BAL   R14,Z312U            ERM. BEGINN + ENDDAT. GEB.SATZ      00105800
Z315U15  DS    0H                                                       00105900
         LR    R15,R5               AKTUELLER GEB.SATZ                  00106000
         A     R15,WLT025           NEXT GEB.SATZ                       00106100
         C     R15,WT025            ENDE T025 ?                         00106200
         BNL   Z315U16              JA                                  00106300
         CLI   T025F86-T025F01(R15),C'3'    ABRECHNUNG ?                00106310
         BNE   Z315U16                      NEIN                        00106320
         BAL   R14,Z316U            FUELLEN VERGLEICHFELD               00106400
         CLC   GT025,GT025N         AKTUELL = NEXT GEB.SATZ ?           00106500
         BNE   Z315U16              NEIN                                00106600
         CLC   HDW+1(1),159(R15)    BEGINNDATUM GLEICH (MONAT)          00106700
         BE    Z315U19              JA                                  00106800
Z315U16  DS    0H                                                       00106900
         AP    GPROZ,0(2,R6)        GES.PROZ.<- PROZ.MONAT              00107000
         OI    HDW1+L'HDW1-1,X'0C'                                      00107100
         MVO   HDW1,HDW+5(1)        ENDMONAT GEB.SATZ                   00107200
         CP    ZAEHLER1,HDW1        ENDMONAT = ZAEHLER ?                00107300
         BE    Z315U19              JA                                  00107400
         CP    ZAEHLER1,KP12        = 12 (LETZTER MONAT)                00107500
         BNE   Z315U17              NEIN                                00107600
         L     R6,A31R6             ADRESSIEREN ANFANG                  00107700
         LA    R6,DTAB22            ADRESSIERE 1. MONAT                 00107800
         ZAP   ZAEHLER1,KP1         = 1                                 00107900
         B     Z315U15                                                  00108000
Z315U17  DS    0H                                                       00108100
         ZAP   REFE,ZAEHLER1        ZAEHLER                             00108200
         AP    REFE,KP1             + 1                                 00108300
         MP    REFE,KP10            = ENDMONAT                          00108400
         CLC   HDW+5(1),REFE+L'REFE-2  GEB.SATZ ?                       00108500
         BNE   Z315U18              NEIN                                00108600
         LR    R15,R5               AKTUELLER GEB.SATZ                  00108700
         A     R15,WLT025           NEXT GEB.SATZ                       00108800
         C     R15,WT025            ENDE T025                           00108900
         BNL   Z315U18              JA                                  00109000
         CLI   T025F86-T025F01(R15),C'3'    ABRECHNUNG ?                00109010
         BNE   Z315U18                      NEIN                        00109020
         BAL   R14,Z316U            FUELLEN VERGLEICHSFELD              00109100
         CLC   GT025,GT025N         AKTUELL = NEXT GEB.SATZ ?           00109200
         BNE   Z315U18              NEIN                                00109300
         CLC   T025F52+1(1),159(15) ENDDATUM = BEGINNDATUM NEXT GEB.S.  00109400
         BE    Z315U19              JA                                  00109500
Z315U18  DS    0H                                                       00109600
         AP    ZAEHLER1,KP1                                             00109700
         LA    R6,L'DTAB21(R6)      NEXT PROZ.SATZ                      00109800
         B     Z315U16                                                  00109900
Z315U19  DS    0H                                                       00110000
         A     R5,WLT025            NEXT GEB.SATZ                       00110100
         C     R5,WT025             ENDE T025                           00110200
         BNL   Z315U20              JA                                  00110300
         CLC   GT025+6(3),T025F02   GEB.ART GLEICH ?                    00110400
         BNE   Z315U20              NEIN                                00110500
         CLC   GT025+1(3),T025F03   TAR.SCHL. GLEICH ?                  00110600
         BNE   Z315U20              NEIN                                00110700
         CLC   GT025+4(2),T025F40   TAR.UNTERGR. GLEICH ?               00110800
         BNE   Z315U20              NEIN                                00110900
         TM    T025F31,LOE          LOESCHUNG GEB.SATZ ?                00111000
         BO    Z315U19              JA                                  00111100
         TM    T025F31,IFVA         FRUEHER AUSGEZOGEN ?                00111200
         BO    Z315U19              JA                                  00111300
         CLI   T025F86,C'3'         ABRECHNUNG ?                        00111400
         BNE   Z315U19              NEIN                                00111500
         CLI   T025F30,C'1'         KEINE GEWICHTUNG ?                  00111600
         BE    Z315U19              JA                                  00111700
         B     Z315U14                                                  00111800
         LTORG                                                          00111900
         EJECT                                                          00112000
* ERMITTELN MENGE PRO GEB.SATZ (3.ROUTINE)                              00112100
         SPACE 2                                                        00112200
Z315U20  DS    0H                                                       00112300
         L     R15,F1               AKTUELLER GEB.SATZ                  00112400
         A     R15,WLT025           NEXT GEB.SATZ                       00112500
         C     R15,WT025            ENDE T025                           00112600
         BNL   Z315U6               JA                                  00112700
         L     R5,F1                AKTUELLER GEB.SATZ                  00112800
         MVC   GT025(1),T025F021      GEB.ART                           00112900
         MVC   GT025+1(3),T025F03     TAR.SCHL.                         00113000
         MVC   GT025+4(2),T025F40     TAR.UNTZERGR.                     00113100
         MVC   GT025+6(3),T025F02     GEB.ART                           00113200
         BAL   R14,Z312U              ERMITTEL BEGINN + ENDDATUM        00113300
Z315U21  DS    0H                                                       00113400
         SP    KMENG1,VMENG3          GES.MENGE - MONATS/TAGESMENGE     00113500
         ZAP   RF1,0(2,R6)            MONAT PROZ.                       00113600
         MP    RF1,KP1000                                               00113700
         MP    RF1,KP1000                                               00113800
         DP    RF1,GPROZ              MONAT : GES.PROZ.= FAKTOR         00113900
         AP    RF1(L'RF1-L'GPROZ),KP5                                   00114000
         MVO   RF1,RF1(L'RF1-L'GPROZ-1) 3 DEZ.ST.                       00114100
         ZAP   RF2,KMENG1             GES.MENGE                         00114200
         MP    RF2,RF1+11(5)          * FAKTOR                          00114300
         MVO   RF2,RF2(L'RF2-3)       RUNDEN                            00114400
         BAL   R14,Z313U              ERMITTEL ANZ. TAGE                00114500
         CP    RF1,REFE               ANZ.TAGE = MONAT                  00114600
         BE    Z315U22                JA                                00114700
         MP    RF2,KP10               4 DEZ.ST.                         00114800
         DP    RF2,RF1+L'RF1-2(2)     MONATS-MENGE : ANZ.MONATSTAGE     00114900
         MVO   RF2,RF2(L'RF2-3)       TAGESMENGE MIT 3 DEZ.ST.          00115000
         MP    RF2,REFE               * ANZ.TAGE                        00115100
Z315U22  DS    0H                                                       00115200
         ZAP   RF1,ZAEHLER1                                             00115300
         MP    RF1,KP10                                                 00115400
         CLC   HDW+5(1),RF1+L'RF1-2   ZAEHLER = ENDMONAT GEB.SATZ ?     00115500
         BNE   Z315U23                NEIN                              00115600
         LR    R15,R5               AKTUELLER GEB.SATZ                  00115700
         A     R15,WLT025           NEXT GEB.SATZ                       00115800
         C     R15,WT025            ENDE T025                           00115900
         BNL   Z315U24              JA                                  00116000
         CLI   T025F86-T025F01(R15),C'3'    ABRECHNUNG ?                00116010
         BNE   Z315U23                      NEIN                        00116020
         BAL   R14,Z316U            FUELLEN VERGLEICHSFELD              00116100
         CLC   GT025,GT025N         AKTUELL = NEXT GEB.SATZ ?           00116200
         BNE   Z315U24              NEIN                                00116300
         CLC   HDW+5(1),152(R15)    ENDMONATE GLEICH ?                  00116400
         BE    Z315U24              JA                                  00116500
         CLC   HDW+5(1),159(R15)    ENDMONATE = BEGINNMONAT ?           00116600
         BE    Z315U24              JA                                  00116700
Z315U23  DS    0H                                                       00116800
         SP    GPROZ,0(2,R6)        GES.PROZ - MONATS-PROZ.             00116900
Z315U24  DS    0H                                                       00117000
         AP    VMENG2,RF2           MONATSMENGE NACH GEB.SATZ MENGE     00117100
         ZAP   VMENG3,RF2           MONATSMENGE                         00117200
         AP    ZAEHLER1,KP1                                             00117300
         ZAP   RF1,ZAEHLER1                                             00117400
         MP    RF1,KP10                                                 00117500
         CLC   RF1+L'RF1-2(1),HDW+5   ZAEHLER > ENDMONAT GEB.SATZ ?     00117600
         BNH   Z315U25                NEIN                              00117700
         CP    ZAEHLER2,KP1           WAR JAHRESWECHSEL ?               00117800
         BNE   Z315U27                NEIN                              00117900
         ZAP   ZAEHLER2,KP0           LOESCHEN                          00118000
         B     Z315U26                                                  00118100
Z315U27  DS    0H                                                       00118200
         CLC   HDW+1(2),HDW+5         BEGINNDATUM > ENDEDATUM MMTT      00118300
         BNH   Z315U26                NEIN                              00118400
         CP    ZAEHLER1,KP12          = 12 (LETZTER MONAT)              00118410
         BNH   Z315U25                NEIN                              00118420
         L     R6,A31R6               BEGINN GEWICHTUNGSTAB.            00118500
         LA    R6,DTAB22              1. MONAT                          00118600
         ZAP   ZAEHLER1,KP1           BEGINN ZAEHLER                    00118700
         ZAP   ZAEHLER2,KP1           JAHRESRWECHSEL                    00118800
         B     Z315U21                                                  00118900
Z315U25  DS    0H                                                       00119000
         LA    R6,L'DTAB21(R6)        NEXT PROZ.SATZ (MONAT)            00119100
         B     Z315U21                                                  00119200
Z315U26  DS    0H                                                       00119300
         AP    VMENG2,KP500           RUNDEN                            00119400
         MVO   VMENG2,VMENG2(L'VMENG2-2)                                00119500
         SP    KMENG2,VMENG2                                            00119600
         ZAP   REFE,VMENG2            FUER T040                         00119700
         B     Z315U4                 ENDE UR5                          00119800
         LTORG                                                          00119900
         EJECT                                                          00120000
         TITLE 'KV0231-FUELLEN VERGLEICHSFELD MIT GEB.SATZ-DATEN (UNTERX00120100
               ROUTINE 6)'                                              00120200
         DS    F                                                        00120300
Z316U    ST    R14,Z316U-4                                              00120400
         MVC   GT025N(1),1(R15)     GEB.ART                             00120500
         MVC   GT025N+1(3),4(R15)   TAR.SCHL.                           00120600
         MVC   GT025N+4(2),120(R15) TAR.UNTERGR.                        00120700
         MVC   GT025N+6(3),1(R15)   GEB.ART                             00120800
         L     R14,Z316U-4                                              00120900
         BR    R14                                                      00121000
         EJECT                                                          00121100
         TITLE 'KV0231-DEFINITIONEN UND KONSTANTEN'                     00121200
*                                                                       00121300
VMENG1   DC    PL8'0'               GES.MENGE ALLER GLEICHEN GEB.SAETZE 00121400
VMENG2   DC    PL8'0'               MENGE EINES GEB.SATZES/ABLESESTAND  00121500
VMENG3   DC    PL8'0'               MENGE MONAT ODER TAGE               00121600
UMENG1   DC    PL8'0'               UNTERZAEHLER-MENGE                  00121700
UMENG2   DC    PL8'0'               INTERNE UZ-MENGE (MENGE1)           00121800
KMENG1   DC    PL8'0'               KANAL-MENGE                         00121900
KMENG2   DC    PL8'0'               INTERNE KANAL-MENGE (MENGE1)        00122000
GPROZ    DC    PL3'0'               GES.PROZ.SATZ ALLER GLEICHEN GEB.S. 00122100
GANZ     DC    PL5'0'               ANZ.ALLER GLEICHEN GEB.SAETZE       00122200
GMONT    DC    PL5'0'               ERMITTELTER MONTAGESTAND            00122300
ZAEHLER1 DC    PL3'0'               FUER VERGLEICH DATUM                00122400
ZAEHLER2 DC    PL1'0'               FUER JAHRESWECHSEL                  00122500
*                                                                       00122600
Z31FEHL1 DC    C'KEINE GEWICHTUNGS-TAB. VORH. (SA 02)'                  00122700
Z31FEHL2 DC    C'KEINE TARIF-SCHL.-TAB. VORH. (SA 03)'                  00122800
Z31FEHL3 DC    C'KEINE GEWITAB. FUER XXX VORH. (SA 02)'                 00122900
*                                                                       00123000
SBEH     DC    CL10'0000000000'    FUER BEHOERDENWECHSEL                00123100
*                                                                       00123200
GT025    DS    0CL9         GEWICHTUNGS-TARIF IN T025 (GRUPPENWECHSEL)  00123300
GT0251   DS    0CL6         FUER SUCHEN IN TARIF-TAB                    00123400
         DS    CL1          GEB.ART                                     00123500
         DS    CL3          TARIF-SCHLUESSEL                            00123600
         DS    CL2          TARIF-UNTERGR.                              00123700
         DS    CL3          GEB.ART                                     00123800
         SPACE                                                          00123900
GT025N   DS    0CL9         GEWICHTUNGS-TARIF IN T025 Z.B.NEXT SATZ     00124000
GT0252   DS    0CL6         FUER SUCHEN IN TARIF-TAB                    00124100
         DS    CL1          GEB.ART                                     00124200
         DS    CL3          TARIF-SCHLUESSEL                            00124300
         DS    CL2          TARIF-UNTERGR.                              00124400
         DS    CL3          GEB.ART                                     00124500
*                                                                       00124600
GQU      DS    CL4          QUITTUNG LESEN DIREKT                       00124700
         DC    C'DIRNUP'    NUR LESEN                                   00124800
         DS    CL10         REST                                        00124900
GQU1     DS    CL4          QUITTUNG LESEN SEQUENTIELL                  00125000
         DC    C'SEQNUP'    NUR LESEN                                   00125100
         DS    CL10         REST                                        00125200
*                                                                       00125300
SKEY1    DS    0CL12        SUCHSCHLUESSEL SYS031 GEWICHTUNGS-TAB (VON) 00125400
SKEY11   DS    CL10         BEHOERDEN-NR.                               00125500
SKEY12   DS    CL2          < TABELLEN-NR.                              00125600
         SPACE                                                          00125700
SKEY2    DS    0CL12        SUCHSCHLUESSEL SYS031 GEWICHTUNGS-TAB (BIS) 00125800
SKEY21   DS    CL10         BEHOERDEN-NR.                               00125900
SKEY22   DS    CL2          > TABELLEN-NR.                              00126000
*                                                                       00126100
SKEY3    DS    0CL16        SUCHSCHLUESSEL SYS032 TARIF-SCHL.-TAB (VON) 00126200
SKEY30   DS    CL10         BEHOERDEN-NR.                               00126300
SKEY31   DS    CL1          GAB.ART                                     00126400
SKEY32   DS    CL3          TARIF-SCHL.                                 00126500
SKEY33   DS    CL2          TARIF-UNTERGR.                              00126600
         SPACE                                                          00126700
SKEY4    DS    0CL16        SUCHSCHLUESSEL SYS032 TARIF-SCHL.-TAB (BIS) 00126800
SKEY40   DS    CL10         BEHOERDEN-NR.                               00126900
SKEY41   DS    CL1          GAB.ART                                     00127000
SKEY42   DS    CL3          TARIF-SCHL.                                 00127100
SKEY43   DS    CL2          TARIF-UNTERGR.                              00127200
*                                                                       00127300
WRA1     DS    F            ADRESSE EINGABEBEREICH                      00127400
A31R5    DS    F            SICHERN R5 = AKT.GEB.SATZ                   00127500
A31R6    DS    F            SICHERN R6 = AKT.GEWI.TAB.ELEMENT           00127600
*                                                                       00127700
KC99     DC    CL2'99'      HOEHSTE GEWICHTUNGS-TABELLEN NR.            00127800
KC00     DC    CL2'00'                                                  00127900
*                                                                       00128000
TAB2     DS    1300C        GEWICHTUNGS-TAB.                            00128100
         DC    C'00'        ENDE                                        00128200
TAB3     DS    4000C        TARIF-SCHL.-TAB.                            00128300
         DC    X'00'        ENDE                                        00128400
*                                                                       00128500
VS02     DSECT              FUER GEWICHTUNGS-EINGABESATZ                00128600
VS02F01  DS    CL2          SA                                          00128700
VS02F02  DS    CL10         KUNDENNR.                                   00128800
VS02F03  DS    CL2          TAB.NR.                                     00128900
VS02F04  DS    CL1          VORGANG                                     00129000
VS02F05  DS    PL2          %SATZ                                       00129100
* VS02F05 IST 12 X VORHANDEN (JAN - DEZ)                                00129200
         SPACE                                                          00129300
VS03     DSECT              FUER TARIF-SCHL.EINGABESATZ                 00129400
VS03F01  DS    CL2          SA (03)                                     00129500
VS03F02  DS    CL10         KUNDENNR.                                   00129600
VS03F03  DS    CL1          GEB.ART                                     00129700
VS03F04  DS    CL3          TAR.SCHL.                                   00129800
VS03F05  DS    CL2          TAR.UNTERGR.                                00129900
VS03F06  DS    CL1          VORGANG                                     00130000
VS03F07  DS    CL2          TAB.NR.GEWICHTUNGS-TAB.                     00130100
*                                                                       00130200
*                                                                       00130300
DTAB2    DSECT              FUER GEWICHTUNGS-TAB.                       00130400
DTAB20   DS    0CL26                                                    00130500
DTAB21   DS    CL2          TAB.NR.                                     00130600
DTAB22   DS    PL2          %SATZ                                       00130700
* DTAB22 IST 12 X VORHANDEN (JAN - DEZ)                                 00130800
         SPACE                                                          00130900
DTAB3    DSECT              FUER TARIF-SCHL.-TAB.                       00131000
DTAB30   DS    0CL8                                                     00131100
DTAB31   DS    CL1          GEB.ART                                     00131200
DTAB32   DS    CL3          TAR.SCHL.                                   00131300
DTAB33   DS    CL2          TAR.UNTERGR.                                00131400
DTAB34   DS    CL2          TAB.NR. GEWICHTUNGS-TAB.                    00131500
*                                                                       00131600
         PRINT GEN                                                      00131700
         YVDS  DSECT,ARB,ARB                                            00131800
         YVDS  DSECT,T01A,T01                                           00131900
         YVDS  DSECT,T02A,T02                                           00132000
         YVDS  DSECT,TVA,TVA                                            00132100
         PRINT NOGEN                                                    00132200
LOE      EQU   X'40'        LOESCHUNG                                   00132300
IFVA     EQU   X'80'        FRUEHER AUSGEZOGEN                          00132400
ZAEHAUS  EQU   X'02'        AENDERUNGSKENNUNG BEI ZWISCHENABRECHNUNG    00132500
         LTORG                                                          00132600
         END   KV0231                                                   00132700
