/*  Projekt redoc
	 SES GmbH
	 Copyright  1999 Alle Rechte vorbehalten.

	 SYSTEM:       redoc.exe Application
	 DATEI:        adddirs.cpp
	 AUTOR:        Helmuth C. Bahr


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von redocAboutDlg (TDialog).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "adddirs.h"
#include "plwrpapp.h"
#include <windows.h>
#include <dir.h>
#include <stdio.h>
DEFINE_RESPONSE_TABLE1(TAdddirs, TDialog)
  EV_COMMAND (IDOK, HandleOk),
END_RESPONSE_TABLE;

//{{TOpenDir Implementation}}
TAdddirs::TAdddirs (TWindow* parent, TResId resId, TModule* module):
			 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
}


TAdddirs::~TAdddirs ()
{
	 Destroy();

	 // INSERT>> Your destructor code here.
}

void TAdddirs::HandleOk ()
{
 char mtext[MAX_PATH+MAX_PATH];

 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);

 GetDlgItemText (IDC_COPY_1, xcopy1, MAX_PATH);
 GetDlgItemText (IDC_COPY_2, xcopy2, MAX_PATH);
 GetDlgItemText (IDC_COPY_3, xcopy3, MAX_PATH);
 GetDlgItemText (IDC_COPY_4, xcopy4, MAX_PATH);
 GetDlgItemText (IDC_COPY_5, xcopy5, MAX_PATH);

 if (!CheckPath(xcopy1))
  {
	sprintf(mtext,"Directory is not available!\n%s",xcopy1);
	MessageBox(mtext,"Redoc Error Message", MB_ICONSTOP);
	return;
  }
 if (!CheckPath(xcopy2))
  {
	sprintf(mtext,"Directory is not available!\n%s",xcopy2);
	MessageBox(mtext,"Redoc Error Message", MB_ICONSTOP);
	return;
  }
 if (!CheckPath(xcopy3))
  {
	sprintf(mtext,"Directory is not available!\n%s",xcopy3);
	MessageBox(mtext,"Redoc Error Message", MB_ICONSTOP);
	return;
  }
 if (!CheckPath(xcopy4))
  {
	sprintf(mtext,"Directory is not available!\n%s",xcopy4);
	MessageBox(mtext,"Redoc Error Message", MB_ICONSTOP);
	return;
  }
 if (!CheckPath(xcopy5))
  {
	sprintf(mtext,"Directory is not available!\n%s",xcopy5);
	MessageBox(mtext,"Redoc Error Message", MB_ICONSTOP);
	return;
  }

 strcpy(theApp->tcopy1,xcopy1);
 strcpy(theApp->tcopy2,xcopy2);
 strcpy(theApp->tcopy3,xcopy3);
 strcpy(theApp->tcopy4,xcopy4);
 strcpy(theApp->tcopy5,xcopy5);
 theApp->select=1;
 CloseWindow ();
}


void TAdddirs::SetupWindow ()
{
 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);

 SetDlgItemText (IDC_COPY_1, theApp->tcopy1);
 SetDlgItemText (IDC_COPY_2, theApp->tcopy2);
 SetDlgItemText (IDC_COPY_3, theApp->tcopy3);
 SetDlgItemText (IDC_COPY_4, theApp->tcopy4);
 SetDlgItemText (IDC_COPY_5, theApp->tcopy5);
}

int TAdddirs::CheckPath (char *path)
{
 int disk;

 if (!strlen(path)) return 1;
 disk = (int) *path;
 if (disk >= 'a') {disk = disk - 'a';}
  else {disk = disk - 'A';};
 setdisk(disk);
 if (disk != getdisk()) return 0;
 if (chdir(path)) return 0;
 return 1;
}
