/*  Projekt pliwrap
	 SES GmbH
	 Copyright  1999 Alle Rechte vorbehalten.

	 SYSTEM:       pliwrap.exe Application
	 DATEI:        dirs.cpp
	 AUTOR:        Helmuth C. Bahr


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von redocAboutDlg (TDialog).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "dirs.h"
#include "opendir.h"
#include "plwrpapp.h"
#include <windows.h>
#include <dir.h>
DEFINE_RESPONSE_TABLE1(TDirs, TDialog)
  EV_COMMAND (IDC_BITMAP_INPUT, HandleIn),
  EV_COMMAND (IDC_BITMAP_WORK, HandleWork),
  EV_COMMAND (IDC_BITMAP_OUTPUT, HandleOut),
  EV_COMMAND (IDOK, HandleOk),
END_RESPONSE_TABLE;

//{{TOpenDir Implementation}}
TDirs::TDirs (TWindow* parent, LPSTR TIn, LPSTR TOut,
				  LPSTR TWork, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
	 strcpy (in, TIn);
	 strcpy (work, TWork);
	 strcpy (out, TOut);
	 ptrTIn   = TIn;
	 ptrTWork = TWork;
	 ptrTOut  = TOut;
}


TDirs::~TDirs ()
{
	 Destroy();

	 // INSERT>> Your destructor code here.
}

void TDirs::HandleOk ()
{
 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);
 theApp->select=1;

 GetDlgItemText (IDC_EDIT_INPUT, in, MAX_PATH);
 GetDlgItemText (IDC_EDIT_WORK, work, MAX_PATH);
 GetDlgItemText (IDC_EDIT_OUTPUT, out, MAX_PATH);
 strcpy (ptrTIn, in);
 strcpy (ptrTWork, work);
 strcpy (ptrTOut, out);

 CloseWindow ();
}


void TDirs::SetupWindow ()
{
 SetDlgItemText (IDC_EDIT_INPUT, in);
 SetDlgItemText (IDC_EDIT_WORK, work);
 SetDlgItemText (IDC_EDIT_OUTPUT, out);
}

void TDirs::HandleIn ()
{
 char inputdir[MAX_PATH];

 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);

 strcpy (theApp->title,"Open Document Directory");
 theApp->select=0;

 if (SetPath(in))
  {strcpy(inputdir, in);}
 else
  {strcpy (inputdir,"\0");}

 TOpenDir(GetWindowPtr(HWindow),inputdir).Execute();

 if (!theApp->select) return;
 if (!strlen(inputdir)) return;

 strcpy (in, inputdir);
 SetDlgItemText (IDC_EDIT_INPUT, in);
}

void TDirs::HandleWork ()
{
 char inputdir[MAX_PATH];

 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);

 theApp->select=0;
 strcpy (theApp->title,"Open Work Directory");

 if (SetPath(work))
  {strcpy(inputdir, work);}
 else
  {strcpy (inputdir,"\0");}

 TOpenDir(GetWindowPtr(HWindow),inputdir).Execute();

 if (!theApp->select) return;
 if (!strlen(inputdir)) return;

 strcpy (work, inputdir);
 SetDlgItemText (IDC_EDIT_WORK, work);
}

void TDirs::HandleOut ()
{
 char inputdir[MAX_PATH];

 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);

 theApp->select=0;
 strcpy (theApp->title,"Open Output Directory");

 if (SetPath(out))
  {strcpy(inputdir, out);}
 else
  {strcpy (inputdir,"\0");}

 TOpenDir(GetWindowPtr(HWindow),inputdir).Execute();

 if (!theApp->select) return;
 if (!strlen(inputdir)) return;

 strcpy (out, inputdir);
 SetDlgItemText (IDC_EDIT_OUTPUT, out);
}

int TDirs::SetPath (LPSTR path)
{
 int disk;

 disk = (int) path[0];
 if (disk >= 'a') {disk = disk - 'a';}
  else {disk = disk - 'A';};
 setdisk(disk);
 if (disk != getdisk()) return 0;
 if (chdir(path)) return 0;
 return 1;
}
