/*  Projekt redoc
	 SES GmbH
	 Copyright  1995 Alle Rechte vorbehalten.

    SYSTEM:       redoc.exe Application
	 DATEI:        linerout.cpp
	 AUTOR:        Helmuth C. Bahr


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von redocWindow (TWindow).
*/

#pragma hdrstop

#include <stdio.h>
#include "linerout.h"

//###########################################################
// TLineRoutine
TLineRoutine::TLineRoutine () {}
//
TLineRoutine::~TLineRoutine () {}
/**************************************************************************
 FUNCTION: get next word in line after line pointer
 NEEDS:    char *lptr   (line pointer)
		char *lendptr
		char *wptr
		char *wendptr
 RETURNS:  *lptr (new position)
		*wptr = word found
**************************************************************************/
char * TLineRoutine::search_line_word (char *lptr, char *lendptr, char *wptr, char *wendptr)
 {
	/* definition */
	int word_found=0;
	char *lptr_first;
	char cform;
	char c;

	space (wptr, MAX_WORD_LN);

	/* function */
	while (lptr != lendptr  && !word_found && *lptr != '\0')
	 {
	  while (lptr != lendptr  && *lptr == ' ' && *lptr != '\0')
		{
		 lptr++;
		}
	  if (lptr != lendptr  && *lptr != '\0')
		{

		/* get form of character in line */
		cform = getcform (*lptr);

		if (cform == 'x')
		 {
		  /* save lptr in lptr_first */
		  lptr_first = lptr;
		  c = *lptr;
		  *wptr = *lptr;
		  wptr++;
		  lptr++;
		  /* move characters to wptr (word) until point or c */
		  while (lptr != lendptr  && *lptr != c
			 && wptr != wendptr && *lptr != '\0')
			{
			 *wptr = *lptr;
			 wptr++;
			 lptr++;
			}
		  if (*lptr == c)
			{
			 *wptr = *lptr;
			 wptr++;
          lptr++;
			}
		  *wptr = '\0';
		  word_found = 1;
		 }
		else
		 {
		  /* save lptr in lptr_first */
		  lptr_first = lptr;
		  /* move characters to wptr (word) until point or space */
		  while (lptr != lendptr  && *lptr != ' '
			 && wptr != wendptr && *lptr != '\0' && *lptr != '.')
			{
			 *wptr = *lptr;
			 wptr++;
			 lptr++;
			}
		  *wptr = '\0';
		  word_found = 1;
		 }
		}
	 }
	if (word_found)
	/* if word found then put lptr to begin of word in line */
	 {
		lptr=lptr_first;
	 }
	else
	/* if word not found an not point then put lptr NULL (= eof line)*/
	 {
	  lptr=NULL;
	 }

	return (lptr);
 }

/**************************************************************************
 FUNCTION: get next word in line after line pointer
 NEEDS:    char *lptr   (line pointer)
		char *lendptr
		char *wptr
		char *wendptr
 RETURNS:  *lptr (new position)
		*wptr = word found
**************************************************************************/
char * TLineRoutine::search_line_word_c (char *lptr, char *lendptr, char *wptr, char *wendptr)
 {
	/* definition */
	int word_found=0;
	char *lptr_first;
	char cform;
	char c;

	space (wptr, MAX_WORD_LN);

	/* function */
	while (lptr != lendptr  && !word_found && *lptr != '\0')
	 {
	  while (lptr != lendptr  && *lptr == ' ' && *lptr != '\0')
		{
		 lptr++;
		}
	  if (lptr != lendptr  && *lptr != '\0')
		{

		/* get form of character in line */
		cform = getcform (*lptr);

		if (cform == 'x')
		 {
		  /* save lptr in lptr_first */
		  lptr_first = lptr;
		  c = *lptr;
		  *wptr = *lptr;
		  wptr++;
		  lptr++;
		  /* move characters to wptr (word) until point or c */
		  while (lptr != lendptr  && *lptr != c
			 && wptr != wendptr && *lptr != '\0')
			{
			 *wptr = *lptr;
			 wptr++;
			 lptr++;
			}
		  if (*lptr == c)
			{
			 *wptr = *lptr;
			 wptr++;
			 lptr++;
			}
		  *wptr = '\0';
		  word_found = 1;
		 }
		else
		 {
		  /* save lptr in lptr_first */
		  lptr_first = lptr;
		  *wptr = *lptr;
		  wptr++;
		  lptr++;
		  /* move characters to wptr (word) until point or space */
		  while (lptr != lendptr  && *lptr != ' '
			 && wptr != wendptr && *lptr != '\0' && *lptr !=';')
			{
			 *wptr = *lptr;
			 wptr++;
			 lptr++;
			}
		  *wptr = '\0';
		  word_found = 1;
		 }
		}
	 }
	if (word_found)
	/* if word found then put lptr to begin of word in line */
	 {
		lptr=lptr_first;
	 }
	else
	/* if word not found an not point then put lptr NULL (= eof line)*/
	 {
	  lptr=NULL;
	 }

	return (lptr);
 }

/**************************************************************************
 FUNCTION: get next word in line after line pointer (without *,,@)
 NEEDS:    char *lptr   (line pointer)
		char *lendptr
		char *wptr
		char *wendptr
 RETURNS:  *lptr (new position)
		*wptr = word found
**************************************************************************/
char * TLineRoutine::search_line_word_data (char *lptr, char *lendptr, char *wptr, char *wendptr)
 {
	/* definition */
	int word_found=0;
	char *lptr_first;
	char cform;
	char c;

	space (wptr, MAX_WORD_LN);

	/* function */
	while (lptr != lendptr  && !word_found && *lptr != '\0')
	 {
	  while (lptr != lendptr  && *lptr == ' ' && *lptr != '\0')
		{
		 lptr++;
		}
	  if (lptr != lendptr  && *lptr != '\0')
		{

		/* get form of character in line */
		cform = getcform (*lptr);

		if (cform == 'x')
		 {
		  /* save lptr in lptr_first */
		  lptr_first = lptr;
		  c = *lptr;
		  *wptr = *lptr;
		  wptr++;
		  lptr++;
		  /* move characters to wptr (word) until point or c */
		  while (lptr != lendptr  && *lptr != c
			 && wptr != wendptr && *lptr != '\0')
			{
			 *wptr = *lptr;
			 wptr++;
			 lptr++;
			}
		  if (*lptr == c)
			{
			 *wptr = *lptr;
			 wptr++;
          lptr++;
			}
		  *wptr = '\0';
		  word_found = 1;
		 }
		else
		 {
		  /* save lptr in lptr_first */
		  lptr_first = lptr;
		  /* move characters to wptr (word) until point or space */
		  while (lptr != lendptr && (*lptr == '*' || *lptr == '' || *lptr == '@'))
			{
			 lptr++;
			}
		  while (lptr != lendptr  && *lptr != ' '
			 && wptr != wendptr && *lptr != '\0')
			{
			 *wptr = *lptr;
			 wptr++;
			 lptr++;
			}
		  *wptr = '\0';
		  word_found = 1;
		 }
		}
	 }
	if (word_found)
	/* if word found then put lptr to begin of word in line */
	 {
		lptr=lptr_first;
	 }
	else
	/* if word not found an not point then put lptr NULL (= eof line)*/
	 {
	  lptr=NULL;
	 }

	return (lptr);
 }


/**************************************************************************
 FUNCTION: get form of character
 NEEDS:    char c (character)
 RETURNS:  char cform
		'n' = numeric
		'a' = alphabetical
		'x' = ' or "
		' ' = undefined
**************************************************************************/
char TLineRoutine::getcform (char c)
 {
	char cform;

	if (isalpha (c))
	 {
	  cform = 'a';
	 }
	else
	 {
	  if (isdigit (c))
		{
		 cform = 'n';
		}
	  else
		{
		 if (c=='"' || c==39)
		  {
			cform = 'x';
		  }
		 else
		  {
			if (c== '(')
			{
			 cform = 'b';
			}
			else
			{
			 cform = ' ';
			}
		  }
		}
	}
	return (cform);
}

void TLineRoutine::word_toupper (char *word)
{
 int xz=0;

 while (*word !='\0' && xz < MAX_WORD_LN)
  {
	*word=toupper(*word);
	xz++;
	word++;
  }
}


/**************************************************************************
 FUNCTION: move space to word
 NEEDS:    char *word (word)
		int n (number of character to be spaced)
 RETURNS:  NOTHING
**************************************************************************/
void TLineRoutine::space (char *word, int n)
 {
  int xz=0;

  while (xz < n)
	{
	 *word = ' ';
	 word++;
	 xz++;
	}
 }


/**************************************************************************
 FUNCTION: get next word in line after line pointer
 NEEDS:    char *lptr   (line pointer)
		char *lendptr
		char *wptr
	   char *wendptr
 RETURNS:  *lptr (new position)
	   *wptr = word found
**************************************************************************/
char * TLineRoutine::search_line_word_b (char *lptr, char *lendptr, char *wptr, char *wendptr)
 {
	/* definition */
	int word_found;
	char cform;
	char *lptr_first;

	/* init */
	word_found=0;
	/* function */

	while (lptr != lendptr && !word_found && *lptr != '\0')
	 {
	  while (lptr != lendptr && *lptr == ' ' && *lptr != '\0')
		{
		 lptr++;
		}

	  if (lptr != lendptr && *lptr != '\0')
		{

		/* get form of character in line */
		cform = getcform (*lptr);

		switch (cform)
		 {
		  case 'b':
		  /* if bracket character */
		  /* save lptr in lptr_first */
		  lptr_first = lptr;
		  /* move characters to wptr (word) until point or bracket */
		  while (lptr != lendptr && wptr != wendptr
			 && *lptr != '\0' && *lptr != ')')
			{
			 *wptr = *lptr;
			 wptr++;
			 lptr++;
			}
		  if (*lptr == ')')
			{
			 *wptr = *lptr;
			 wptr++;
			 lptr++;
			}

		  *wptr = '\0';
		  word_found = 1;
		  break;

		  default:
		  /* if alphabetical character */
		  /* save lptr in lptr_first */
		  lptr_first = lptr;
		  /* move characters to wptr (word) until point, space
			  or bracket */
		  if (*lptr == ',')
			{
			 *wptr = *lptr;
			 wptr++;
			 lptr++;
			 *wptr = '\0';
			}
		  else
			{
			 while (lptr != lendptr && *lptr != ' '
			  && wptr != wendptr && *lptr != '\0' && *lptr != '('
			  && *lptr != ',')
			  {
				*wptr = *lptr;
				wptr++;
				lptr++;
			  }
			 *wptr = '\0';
			}
		  word_found = 1;
		  break;
		 }
		}
	 }

	if (word_found)
	/* if word found then put lptr to begin of word in line */
	 {
		lptr=lptr_first;
	 }
	else
	/* if word not found an not point then put lptr NULL (= eof line)*/
	 {
		lptr=NULL;
	 }

	return (lptr);
 }


char * TLineRoutine::fgetl (char *buf, int max, FILE *fp)
 {
  char *eof;
  int stern;
  int i;

  stern = 1;

  eof = fgets(buf,max,fp);

  while (eof && stern)
	{
	 if (eof)
	  {
		if (*buf=='*' || *buf==12 || *buf==13)
		 {
		  stern = 1;
		  eof = fgets(buf,max,fp);
		 }
		else
		 {
		  for (i=0; i<MAX_BUF && *buf != '\n';i++)
			{
			 if (*buf == '\0') *buf = ' ';
			 buf++;
			}
		  *buf = '\0';
		  if (i)
			{
			 stern = NULL;
			}
		  else
			{
			 stern = 1;
			 eof = fgets(buf,max,fp);
			}
		 }
	  }
	}
  return eof;
 }

