/*  Projekt redoc
	 SES GmbH
	 Copyright  1999 Alle Rechte vorbehalten.

	 SYSTEM:       redoc.exe Application
	 DATEI:        selectf.cpp
	 AUTOR:        Helmuth C. Bahr


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von redocAboutDlg (TDialog).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "selectf.h"
#include "plwrpapp.h"
#include "io.h"
#include "stdio.h"
#include <owl/inputdia.h>
#include <windows.h>

DEFINE_RESPONSE_TABLE1(TSelectFiles, TDialog)
  EV_LBN_SELCHANGE(IDC_LISTBOX1, HandleListBox),
  EV_COMMAND (IDOK, HandleOk),
  EV_COMMAND (L_SELECT, HandleCopy),
END_RESPONSE_TABLE;

//{{TSelect Implementation}}
TSelectFiles::TSelectFiles (TWindow* parent, LPSTR TPathext, LPSTR TPathext2,
				 LPSTR inputdir,
				 TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
	 strcpy (pathext, TPathext);
	 ptrTPathext = TPathext;
	 strcpy (pathext2, TPathext2);
	 ptrTPathext2 = TPathext2;
	 strcpy(input,inputdir);
	 ptrinput = inputdir;
}


TSelectFiles::~TSelectFiles()
{
	 Destroy();

	 // INSERT>> Your destructor code here.

}

void TSelectFiles::HandleOk ()
{
 FILE *fpout;

 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);

 maxItems = SendDlgItemMessage(L_LIST_S, LB_GETCOUNT,0,0);
 if (maxItems)
  {
	fpout  = fopen(theApp->execini, "w");
	if (fpout)
	 {
	  for (dwIndex=0;dwIndex < maxItems;dwIndex++)
		{
		 wParam = (WPARAM) dwIndex;
		 SendDlgItemMessage(L_LIST_S,
								 LB_GETTEXT, wParam, (LPARAM) ((LPSTR) szFile));
		 word_toupper(szFile,12);
		 sprintf(outline,"%s\n", szFile);
		 fputs(outline,fpout);
		}
	  fputs("EOF\n", fpout);
	  fclose(fpout);
	 }
	else
	 {
	  MessageBox("Error Open Ini","Error Redoc",MB_ICONSTOP);
	  maxItems=0;
	 }
  }
 else
  {
	MessageBox("No File selected","Error Redoc",MB_ICONSTOP);
  }

 if (maxItems)
  {
	theApp->select=1;
  }
 CloseWindow ();
}


void TSelectFiles::HandleListBox ()
{
}

void TSelectFiles::SetupWindow ()
{
 int i;
 int len;
 char xpath[MAX_PATH];
 char xfilter[MAX_PATH];
 char filter[MAX_PATH];
 char xbuf[MAX_PATH];
 int k,l,m;
 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);
 SetCaption (theApp->title);
 maxItems = 0;

 if (strcmp(pathext,"pli")!=NULL && strcmp(pathext,"filter")!=NULL)
  {
	SendDlgItemMessage(L_LIST, LB_DIR, DDL_READWRITE,(LPARAM) pathext);
	SendDlgItemMessage(L_LIST, LB_DIR, DDL_READWRITE,(LPARAM) pathext2);
  }
 else
  {
	m=0;
	strcpy(filter,"*");
	if (strcmp(pathext,"filter")==NULL)
	 {
	  strcpy(xbuf,"");
	  TInputDialog getfilter(this, "Filter for program names", "Input:", xbuf, MAX_PATH - 1,
		 0, 0);

	  if (getfilter.Execute() == IDOK)
		{
		 strcpy(xfilter,xbuf);
		}
	  else
		{
		 strcpy(xfilter,"");
		}

	  m = strlen(xfilter);
	  if (m)
		{
		 k=0;
		 while (k < m)
		  {
			strcpy(filter,"");
			l=0;
			while (k < m && xfilter[k] != ';')
			 {
			  filter[l]=xfilter[k];
			  l++;k++;
			 }
			if (xfilter[k]=';')
			 {
			  filter[l]='\0';
			  k++;
			  sprintf(xpath,"%s\\%s",input,filter);
			  SendDlgItemMessage(L_LIST, LB_DIR, DDL_READWRITE,(LPARAM) xpath);
			 }
		  }
		}
	 }

	if (!m)
	 {
	  if (theApp->max_extensions > 0)
		{
		 i=0;
		 while (i < theApp->max_extensions)
		  {
			sprintf(xpath,"%s\\%s.%s",input,filter,theApp->extensions[i]);
			SendDlgItemMessage(L_LIST, LB_DIR, DDL_READWRITE,(LPARAM) xpath);
			i++;
		  }
		 sprintf(xpath,"%s\\%s.",input,filter);
		 SendDlgItemMessage(L_LIST, LB_DIR, DDL_READWRITE,(LPARAM) xpath);
		}
	  else
		{
		 sprintf(xpath,"%s\\%s.*",input,filter);
		 SendDlgItemMessage(L_LIST, LB_DIR, DDL_READWRITE,(LPARAM) xpath);
		}
	 }
  }
}

void TSelectFiles::HandleCopy ()
{
  DWORD items;
  DWORD index;

  items = SendDlgItemMessage(L_LIST, LB_GETCOUNT, 0, 0);

  if (items)
	{
	 err=0;
	 for (index=0;index<items && !err;index++)
	  {
		wParam = (WPARAM) index;
		if (SendDlgItemMessage(L_LIST, LB_GETSEL, index, 0))
		 {
		  wParam = (WPARAM) index;
		  SendDlgItemMessage(L_LIST,
								LB_GETTEXT, wParam, (LPARAM) ((LPSTR) szFile));
		  dwIndex_S = SendDlgItemMessage(L_LIST_S, LB_ADDSTRING, 0,
											  (LPARAM) ((LPSTR) szFile));
		  switch (dwIndex_S)
			{
			 case LB_ERR:
					MessageBox("Error ADDSTRING LIST","Error Message Redoc",MB_ICONSTOP);
					err=1;
					break;
			 case LB_ERRSPACE:
					MessageBox("List box cannot allocate enough memory","Error Message Redoc",MB_ICONSTOP);
					err=1;
					break;
			 default:
					break;
			}
		 }
	  }
	}
}

/**************************************************************************
 FUNCTION: word in capitalization
 NEEDS:    char *word (word to be searched)
 RETURNS:  NOTHING
**************************************************************************/
void TSelectFiles::word_toupper (char *word, int max)
 {
  int xz;

  /* init. */
  xz=0;

  while (*word != '\0' && xz < max)
	{
	 *word = toupper (*word);
	 xz++;
	 word++;
	}
 }


