/*  Projekt pliwrap
	 SES GmbH
	 Copyright  1999 Alle Rechte vorbehalten.

	 SYSTEM:       pliwrap.exe Application
	 DATEI:        sellab.cpp
	 AUTOR:        Helmuth C. Bahr


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von pliwrapAboutDlg (TDialog).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "sellab.h"
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <stdio.h>
#include "plwrpapp.h"
#include <windows.h>
#include <string.h>
#include "fparse.h"

DEFINE_RESPONSE_TABLE1(TSelectLab, TDialog)
  EV_COMMAND (IDOK, HandleOk),
  EV_COMMAND (IDCANCEL, HandleCC),
//  EV_CHILD_NOTIFY (IDC_LISTBOX1, LBN_SETFOCUS, HandleListBox),
END_RESPONSE_TABLE;


//{{TSelectLab Implementation}}
TSelectLab::TSelectLab (TWindow* parent, LPSTR inputDir, LPSTR fileName, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
  strcpy (inputdir, inputDir);
  strcpy (filename, fileName);
}

TSelectLab::~TSelectLab()
{
	 Destroy();
	 // INSERT>> Your destructor code here.
}

void TSelectLab::HandleOk ()
{
 WPARAM wParam;
 LPARAM lParam;

 char fname[MAX_PATH];
 char buf[MAX_BUF+1];
 char fbuf[MAX_BUF+1];

 DWORD items;
 DWORD index;
 FILE *fp;

 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);

 strcpy (objname, theApp->objname);
 items = SendDlgItemMessage(IDC_LISTBOX1, LB_GETCOUNT, 0, 0);
 if (items)
  {
	sprintf(fname,"%s\\%s.lab",inputdir,objname);

	if ((fp = fopen(fname,  "w+")) == NULL) return;

	for (index=0;index<items;index++)
	 {
	  wParam = (WPARAM) index;
	  if (SendDlgItemMessage(IDC_LISTBOX1, LB_GETSEL, index, 0))
		{
		 wParam = (WPARAM) index;
		 SendDlgItemMessage(IDC_LISTBOX1,LB_GETTEXT, wParam, (LPARAM) ((LPSTR) buf));
		 sprintf(fbuf,"%s\n",buf);
		 fputs(fbuf, fp);
		}
	 }
	fclose (fp);
	theApp->select=1;
  }
 CloseWindow ();
}


void TSelectLab::HandleCC ()
{
 CloseWindow ();
}

void TSelectLab::SetupWindow ()
{
// parse data attributes
  int xtype;
  int wtype;
  int ltype;
  int comm;
  int stop;
  char *c;
  FileParse *fparse;
  char xlastword[MAX_WORD+MAX_ZUSATZ];
  char xlastlastword[MAX_WORD+MAX_ZUSATZ];

 // Fill List with DataDivison of Pliol Source

  DWORD dwIndex;

  int i,j;
  struct dostime_t t;
  char init[8];
  char buf[MAX_BUF+1];

  char *sz;
  char title[MAX_BUF];
  sz = strrchr (filename, 92);
  sz++;
  sprintf(title,"Procedure Selection [%s]", sz);
  SetCaption (title);

  TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);


  fparse = new FileParse(filename);

  xtype=W_OTHER;


  while (xtype!=W_EOF)
	{
	 xtype = fparse->get_next_word();

	 switch (xtype)
	  {
		case W_WORD:
           if (strcmp(fparse->word,"PROC") == NULL ||
               strcmp(fparse->word,"PROCEDURE") == NULL)
            {
             if (strcmp(fparse->lastword,":") == NULL)
              {
                strcpy(buf,fparse->lastlastword);

                dwIndex = SendDlgItemMessage(IDC_LISTBOX1,
					       LB_ADDSTRING, 0, (LPARAM) ((LPSTR) buf));
			       switch (dwIndex)
			        {
			         case LB_ERR:
					     MessageBox("Error in Listbox","Error PliWrap",MB_ICONSTOP);
					     break;
			         case LB_ERRSPACE:
					     MessageBox("Insufficient Space for Listbox","Error PliWrap",
								  MB_ICONSTOP);
					     break;
			         default:
                    break;
                 }
              }
			   }
           break;
      case W_OTHER:
		     if (strcmp(fparse->word,"/*")==NULL)
            {
             strcpy(xlastword,fparse->lastword);
             strcpy(xlastlastword,fparse->lastlastword);
             // wenn Kommentarzeichen, dann lese bis Kommentarendezeichen
			    comm=1;
			    xtype = fparse->get_next_word_simple();
			    while (xtype != W_EOF && comm)
			     {
			      if (strcmp(fparse->word,"/*")==NULL) comm++;
				   if (strcmp(fparse->word,"*/")==NULL) comm--;
				   if (comm) xtype = fparse->get_next_word_simple();
  			     }
             strcpy(fparse->word,xlastword);
             strcpy(fparse->lastword,xlastlastword);
            }
			  break;
      default:
           // wenn keine Definition vorhanden
			  break;
     }
	}

  if (fparse) delete fparse;
}

void TSelectLab::HandleListBox ()
{
/*  WPARAM wParam;
  LPARAM lParam;
  LRESULT frIndex;

  frIndex = SendDlgItemMessage(IDC_LISTBOX1, LB_GETCARETINDEX, 0,0L);

  if (frIndex)
	 {
	  wParam = (WPARAM) (BOOL) TRUE;
	  lParam = MAKELPARAM (frIndex,0);
	  SendDlgItemMessage(IDC_LISTBOX1, LB_SETSEL, wParam, lParam);
	 }*/

}




//########################################################################
// Inhalt:  Implementierung der Methoden der Klasse FileParse
// Author:  Helmuth C. Bahr
// Datum:   23.06.98
// C-Datum: 18.08.98
// Klasse: Allgemeiner Parser fr Dateien, eine Datei entspricht einem Labekt
//########################################################################

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//Konstruktor
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FileParse::FileParse(char *ifile)
 {
		// Sichern der Dateinamen
		strcpy(filename,ifile);

		// ffnen der Dateien, Setzen der File Status
		fp =  fopen(filename, "r");

		if (fp)
		 {filestatus = F_OPEN_SUCCESS;}
		else
		 {filestatus = F_OPEN_ERROR;}


		// Intialisierung der Variablen
		strcpy (line,"");
		strcpy (lastline,"");
		strcpy (word,"");
		linestatus=0;wordstatus=0;
		linenr=0;wordnr=0,wrlinenr=0;
 }

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//Destruktor
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FileParse::~FileParse()
 {
  // Schliessen der Datei
  if (fp) fclose(fp);
 }

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//lese nchste Zeile
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
int FileParse::get_next_line ()
 {
  int len;
  int stop;

  strcpy(lastline,line);

  stop=0;

  while (!stop)
  {
   if (!fgets(line, sizeof(line), fp))
	 {
	  linestatus=L_READ_ERROR;
	  return linestatus;
	 }

   len = strlen(line);

   if (len && line[0]!='*')
   {
    // berschreibe Zeilenumbruch '\n' mit String-Ende-Zeichen/NULL
    stop=1;
    line[len-1]='\0';
    wordnr=0;
    charnr=0;
    linestatus=L_READ_SUCCESS;
   }
   linenr++;
  }
  return linestatus;
 }

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//lese nchstes Wort von Datei
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
int FileParse::get_next_word ()
 {
  int i,c,ct,loop,cend,xz,apo;
  char capo;
  char X_PREPRO='#';

  // setze Status zurck
  lastlasttype = lasttype;
  lasttype=wordstatus;
  strcpy(lastlastword,lastword);
  strcpy(lastword,word);
  strcpy(word,"");
  wordstatus=0;
  errornr=0;

  loop=0;

  // berprfe linestatus
  if (linestatus==L_READ_ERROR) return W_EOF;
  if (!linestatus)
   {
	 if (get_next_line()==L_READ_ERROR)
     {
		return W_EOF;
     }
	}

  // Wenn Ende der Zeile erreicht, dann neue Zeile lesen
  if (charnr >= strlen(line))
	{
	 if (get_next_line()==L_READ_ERROR)
	  {
		loop=1;
	  }
	}

  // gehe zu nchstem Zeichen ungleich Space,Tab...
  while ((!loop) && (get_char_type(line[charnr])==C_SPACE))
	{
	 charnr++;
	 // Wenn Ende der Zeile erreicht, dann neue Zeile lesen
	 if (charnr >= strlen(line))
	  {
		if (get_next_line()==L_READ_ERROR)
		 {
		  loop=1;
		 }
	  }
	}
  // Wenn Ende/Fehler beim Zeilen-Lesen, dann Rckgabewert EOF
  if (loop) return W_EOF;

  // hole Zeichentyp
  ct = get_char_type (line[charnr]);

  c = line[charnr];
  // Werte Zeichentyp aus
  switch(ct)
	{
	 case C_ALPHA:
			word[0]=line[charnr];
         i=1;charnr++;
  			// lese Zeichen in Word bis ungleich ALPHA oder NUM
			while (charnr < strlen(line) && i < MAX_WORD &&
					 (get_char_type(line[charnr])==C_ALPHA ||
					  get_char_type(line[charnr])==C_NUM))
   		 {
			  word[i]=line[charnr];
			  i++;
           charnr++;
   		 }
         word[i]='\0';
         // wenn prepro
         if (word[0]==X_PREPRO)
          {
           wordstatus=W_PREPRO;
          }
         else
          {
			  wordstatus=W_WORD;
          }

         // wenn Tabellenberlauf
         if (i>=MAX_WORD)
          {
			  wordstatus=W_FATAL;
          }
			break;
    case C_NUM:
         word[0]=line[charnr];
         i=1;charnr++;
  			// lese Zeichen in Word bis ungleich NUM
			while (charnr < strlen(line) && i < MAX_WORD &&
					 get_char_type(line[charnr])==C_NUM)
			 {
           word[i]=line[charnr];
			  i++;
			  charnr++;
   		 }
         word[i]='\0';
         wordstatus=W_NUM;
			// wenn Tabellenberlauf
         if (i>=MAX_WORD)
          {
           wordstatus=W_FATAL;
          }
         break;
	 default:
         switch (c)
          {
           case '"':
           case 39:
					 wordstatus=W_APOS;
					 cend=c;
					 break;
			  case '(':
					 wordstatus=W_BRAC_R;
					 cend=')';
                break;
           case '[':
                wordstatus=W_BRAC_S;
					 cend=']';
					 break;
           default:
					 break;
			 }
			// Wenn Apostroph,Klammer, dann sichere bis Klammer-Ende
			if (c=='"' || c==39 || c=='(' || c=='[')
			 {
			  i=0;

			  word[i]=line[charnr];
     charnr++;
					i++;

			  loop=0;
			  xz=1;
			  apo=0;


			  // lese Zeichen in Word bis ungleich NUM
			  while (!loop && xz)
				{
				 if (i < MAX_WORD)
				  {
					word[i]=line[charnr];
				  }

				 if (line[charnr]=='\\')
				  {
					// lese das nchste Zeichen ein
					charnr++;
					if (i < MAX_WORD)
					 {
					  i++;
					 }
					if (i < MAX_WORD)
					 {
					  word[i]=line[charnr];
					 }
				  }
				 else
				 if (c=='(')
				  {
					if (apo)
					 {
					  if (line[charnr]==capo) apo=0;
					 }
					else
					if ((line[charnr]=='"' || line[charnr]==39))
					 {
						 apo=1;capo=line[charnr];
					 }
					else
					 {
					  // berprfe Anfangs/Ende-Zeichen und sezte Zhler
					  if (line[charnr]==c && c!=cend) xz++;
					  if (line[charnr]==cend) xz--;
					 }
				  }
				 else
				  {
					// berprfe Anfangs/Ende-Zeichen und sezte Zhler
					if (line[charnr]==c && c!=cend) xz++;
					if (line[charnr]==cend) xz--;
				  }

				 if (i < MAX_WORD)
				  {
					i++;
				  }
				 charnr++;

				 // Wenn Ende der Zeile erreicht, dann neue Zeile lesen
// 				 if (charnr >= strlen(line) && xz) loop=1;
  				 if (charnr >= strlen(line) && xz)
				 {
  					if (get_next_line()==L_READ_ERROR) loop=1;
				 }
                 if (i >= MAX_WORD) loop=1;
				}
//           if (i) i--;
			  word[i]='\0';
/*			  // wenn Tabellenberlauf
			  if (i>=MAX_WORD)
				{
				 errornr=ERR_TABLE_OVERFLOW_WORD;
				 wordstatus=W_FATAL;
				}*/
			 }
			else
			// Wenn Sonderzeichen, dann lese bis ungleich Sonderzeichen
			// oder Semikolon, oder Klammer auf oder " und '..
			 {
			  // wenn backslash, dann lese die nchsten zwei Zeichen
			  if (line[charnr]=='\\')
				{
				 i=0;
				 word[0]=line[charnr];
				 i++;charnr++;
				 word[i]=line[charnr];
				 i++;charnr++;
				}
			  else
			  if ((line[charnr]=='/' && line[charnr+1]=='*') ||
					(line[charnr]=='*' && line[charnr+1]=='/') ||
					(line[charnr]=='/' && line[charnr+1]=='/'))
				{
				 i=0;
				 word[0]=line[charnr];
				 i++;charnr++;
				 word[i]=line[charnr];
				 i++;charnr++;
				}
			  else
				{
				 word[0]=line[charnr];
				 i=1;charnr++;
				 // lese Zeichen in Word bis ungleich C_OTHER..
				 while (charnr < strlen(line) && i < MAX_WORD &&
						 get_char_type(line[charnr])==C_OTHER
						 && line[charnr]!='\\'
						 && line[charnr]!='{' && line[charnr]!='}' && line[charnr]!=';'
						 && line[charnr]!='"' && line[charnr]!=39  && line[charnr]!='['
						 && line[charnr]!=']' && (line[charnr]!='*' && line[charnr+1]!='/')
						 && (line[charnr]!='/' && line[charnr+1]!='*') && line[charnr]!='('
                   && line[charnr]!=')')
				  {
					word[i]=line[charnr];
					i++;
					charnr++;
				  }
				}
			  word[i]='\0';
			  wordstatus=W_OTHER;
			  // wenn Tabellenberlauf
			  if (i>=MAX_WORD)
				{
				 wordstatus=W_FATAL;
				}
			 }
			break;
	}
  wordnr++;
  return wordstatus;
 }


//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//lese nchstes Wort von Datei, simple, fr c-kommentarzeilen
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
int FileParse::get_next_word_simple ()
 {
  int i,c,ct,loop,xz,apo;
//  int cend;
  char capo;

  // setze Status zurck
  strcpy(lastword,word);
  strcpy(word,"");
  wordstatus=0;
  errornr=0;

  loop=0;

  // berprfe linestatus
  if (linestatus==L_READ_ERROR) return W_EOF;
  if (!linestatus)
	{
	 if (get_next_line()==L_READ_ERROR)
	  {
		return W_EOF;
     }
	}

  // Wenn Ende der Zeile erreicht, dann neue Zeile lesen
  if (charnr >= strlen(line))
   {
    if (get_next_line()==L_READ_ERROR)
     {
      loop=1;
	  }
	}

  // gehe zu nchstem Zeichen ungleich Space,Tab...
  while ((!loop) && (get_char_type(line[charnr])==C_SPACE))
	{
    charnr++;
 	 // Wenn Ende der Zeile erreicht, dann neue Zeile lesen
	 if (charnr >= strlen(line))
	  {
		if (get_next_line()==L_READ_ERROR)
		 {
        loop=1;
		 }
	  }
   }
  // Wenn Ende/Fehler beim Zeilen-Lesen, dann Rckgabewert EOF
  if (loop) return W_EOF;

  // hole Zeichentyp
  ct = get_char_type (line[charnr]);

  c = line[charnr];
  // Werte Zeichentyp aus
  switch(ct)
	{
	 case C_ALPHA:
			word[0]=line[charnr];
         i=1;charnr++;
			// lese Zeichen in Word bis ungleich ALPHA oder NUM
			while (charnr < strlen(line) && i < MAX_WORD &&
					 (get_char_type(line[charnr])==C_ALPHA ||
					  get_char_type(line[charnr])==C_NUM))
   		 {
			  word[i]=line[charnr];
			  i++;
           charnr++;
   		 }
         word[i]='\0';
         wordstatus=W_WORD;
         // wenn Tabellenberlauf
         if (i>=MAX_WORD)
			 {
           wordstatus=W_FATAL;
			 }
			break;
    case C_NUM:
         word[0]=line[charnr];
         i=1;charnr++;
			// lese Zeichen in Word bis ungleich NUM
			while (charnr < strlen(line) && i < MAX_WORD &&
					 get_char_type(line[charnr])==C_NUM)
			 {
           word[i]=line[charnr];
			  i++;
			  charnr++;
   		 }
         word[i]='\0';
         wordstatus=W_NUM;
         // wenn Tabellenberlauf
         if (i>=MAX_WORD)
          {
			  wordstatus=W_FATAL;
			 }
			break;
	 default:
			switch (c)
			 {
			  case '"':
			  case 39:
					 wordstatus=W_APOS;
//					 cend=c;
					 break;
			  case '(':
					 wordstatus=W_BRAC_R;
//					 cend=')';
					 break;
			  case '[':
					 wordstatus=W_BRAC_S;
//					 cend=']';
					 break;
			  default:
					 break;
			 }
			// Wenn Apostroph,Klammer, dann weiter
			if (c=='"' || c==39 || c=='(' || c=='[')
			 {
			  word[0]=line[charnr];
			  i=1;charnr++;
			  word[i]='\0';
			 }
			else
			// Wenn Sonderzeichen, dann lese bis ungleich Sonderzeichen
			// oder Semikolon, oder Klammer auf oder " und '..
			 {
			  if ((line[charnr]=='/' && line[charnr+1]=='*') ||
					(line[charnr]=='*' && line[charnr+1]=='/') ||
					(line[charnr]=='/' && line[charnr+1]=='/'))
				{
				 i=0;
				 word[0]=line[charnr];
				 i++;charnr++;
				 word[i]=line[charnr];
				 i++;charnr++;
				}
			  else
				{
				 word[0]=line[charnr];
				 i=1;charnr++;
				 // lese Zeichen in Word bis ungleich C_OTHER..
				 while (charnr < strlen(line) && i < MAX_WORD &&
						 get_char_type(line[charnr])==C_OTHER
						 && line[charnr]!='\\'
						 && line[charnr]!='{' && line[charnr]!='}' && line[charnr]!=';'
						 && line[charnr]!='"' && line[charnr]!=39  && line[charnr]!='['
						 && line[charnr]!=']' && (line[charnr]!='*' && line[charnr+1]!='/')
						 && (line[charnr]!='/' && line[charnr+1]!='*'))
				  {
					word[i]=line[charnr];
					i++;
					charnr++;
				  }
				}
			  word[i]='\0';
			  wordstatus=W_OTHER;
			  // wenn Tabellenberlauf
			  if (i>=MAX_WORD)
				{
				 wordstatus=W_FATAL;
				}
			 }
			break;
	}
  wordnr++;
  return wordstatus;
 }


//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// gebe Zeichentyp zurck
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
int FileParse::get_char_type (char c)
 {
  if (c=='_' || c=='$' || c== '#')
	{
	 return C_ALPHA;
	}
  if (isalpha(c))
	{
	 return C_ALPHA;
	}
  if (isdigit(c))
	{
	 return C_NUM;
	}
  if (isspace(c))
	{
	 return C_SPACE;
   }
  if (!isgraph(c))
   {
    return C_SPACE;
	}
  return C_OTHER;
 }

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// berprft ob Line leer
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
int FileParse::xisspace()
 {
  int i;

  i=0;
  while (i < strlen(line) && i < MAX_WORD && line[i]==' ')
	{
	 i++;
	}
  if (i < strlen(line) && i < MAX_WORD)
	{
	 return 0;
	}
  return 1;
 }










