/*  Projekt pliwrap
	 SES GmbH
	 Copyright  1999 Alle Rechte vorbehalten.

	 SYSTEM:       pliwrap.exe Application
	 DATEI:        selobj.cpp
	 AUTOR:        Helmuth C. Bahr


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von pliwrapAboutDlg (TDialog).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "selobj.h"
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <stdio.h>
#include "plwrpapp.h"
#include <windows.h>
#include <string.h>
#include "fparse.h"

DEFINE_RESPONSE_TABLE1(TSelectObj, TDialog)
  EV_COMMAND (IDOK, HandleOk),
  EV_COMMAND (IDCANCEL, HandleCC),
//  EV_CHILD_NOTIFY (IDC_LISTBOX1, LBN_SETFOCUS, HandleListBox),
END_RESPONSE_TABLE;


//{{TSelectObj Implementation}}
TSelectObj::TSelectObj (TWindow* parent, LPSTR inputDir, LPSTR fileName, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
  strcpy (inputdir, inputDir);
  strcpy (filename, fileName);
}

TSelectObj::~TSelectObj()
{
	 Destroy();
	 // INSERT>> Your destructor code here.
}

void TSelectObj::HandleOk ()
{
 WPARAM wParam;
 LPARAM lParam;

 char fname[MAX_PATH];
 char buf[MAX_BUF+1];
 char fbuf[MAX_BUF+1];

 DWORD items;
 DWORD index;
 FILE *fp;

 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);

 strcpy (objname, theApp->objname);
 items = SendDlgItemMessage(IDC_LISTBOX1, LB_GETCOUNT, 0, 0);
 if (items)
  {
	sprintf(fname,"%s\\%s.obj",inputdir,objname);

	if ((fp = fopen(fname,  "w+")) == NULL) return;

	for (index=0;index<items;index++)
	 {
	  wParam = (WPARAM) index;
	  if (SendDlgItemMessage(IDC_LISTBOX1, LB_GETSEL, index, 0))
		{
		 wParam = (WPARAM) index;
		 SendDlgItemMessage(IDC_LISTBOX1,LB_GETTEXT, wParam, (LPARAM) ((LPSTR) buf));
		 sprintf(fbuf,"%s\n",buf);
		 fputs(fbuf, fp);
		}
	 }
	fclose (fp);
	theApp->select=1;
  }
 CloseWindow ();
}


void TSelectObj::HandleCC ()
{
 CloseWindow ();
}

void TSelectObj::SetupWindow ()
{
// parse data attributes
  int xtype;
  int wtype;
  int ltype;
  int comm;
  int stop;
  char *c;
  FileParse *fparse;
  char xlastword[MAX_WORD+MAX_ZUSATZ];
  char xlastlastword[MAX_WORD+MAX_ZUSATZ];

 // Fill List with DataDivison of Pliol Source

  DWORD dwIndex;

  int i,j;
  struct dostime_t t;
  char init[8];
  char buf[MAX_BUF+1];

  char *sz;
  char title[MAX_BUF];
  sz = strrchr (filename, 92);
  sz++;
  sprintf(title,"FILE Selection [%s]", sz);
  SetCaption (title);

  TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);


  fparse = new FileParse(filename);

  xtype=W_OTHER;


  while (xtype!=W_EOF)
	{
	 xtype = fparse->get_next_word();

	 switch (xtype)
	  {
		case W_WORD:
           if (strcmp(fparse->word,"FILE") == NULL)
            {
             if (strcmp(fparse->lastword,"OPEN") !=NULL &&
                 strcmp(fparse->lastword,"CLOSE") !=NULL &&
                 strcmp(fparse->lastword,"REWRITE") !=NULL &&
                 strcmp(fparse->lastword,"WRITE") !=NULL &&
                 strcmp(fparse->lastword,"READ") !=NULL &&
                 strcmp(fparse->lastword,"PUT") !=NULL &&
                 strcmp(fparse->lastword,"GET") !=NULL)
              {
                if (fparse-> lasttype == W_BRAC_R)
                 {
                  strcpy(buf,fparse->lastlastword);
                 }
                else
                 {
                  strcpy(buf,fparse->lastword);
                 }

                dwIndex = SendDlgItemMessage(IDC_LISTBOX1,
					       LB_ADDSTRING, 0, (LPARAM) ((LPSTR) buf));
			       switch (dwIndex)
			        {
			         case LB_ERR:
					     MessageBox("Error in Listbox","Error PliWrap",MB_ICONSTOP);
					     break;
			         case LB_ERRSPACE:
					     MessageBox("Insufficient Space for Listbox","Error PliWrap",
								  MB_ICONSTOP);
					     break;
			         default:
                    break;
                 }
              }
			   }
           break;
      case W_OTHER:
		     if (strcmp(fparse->word,"/*")==NULL)
            {
             strcpy(xlastword,fparse->lastword);
             strcpy(xlastlastword,fparse->lastlastword);
             // wenn Kommentarzeichen, dann lese bis Kommentarendezeichen
			    comm=1;
			    xtype = fparse->get_next_word_simple();
			    while (xtype != W_EOF && comm)
			     {
			      if (strcmp(fparse->word,"/*")==NULL) comm++;
				   if (strcmp(fparse->word,"*/")==NULL) comm--;
				   if (comm) xtype = fparse->get_next_word_simple();
  			     }
             strcpy(fparse->word,xlastword);
             strcpy(fparse->lastword,xlastlastword);
            }
			  break;
      default:
           // wenn keine Definition vorhanden
			  break;
     }
	}

  if (fparse) delete fparse;
}

void TSelectObj::HandleListBox ()
{
/*  WPARAM wParam;
  LPARAM lParam;
  LRESULT frIndex;

  frIndex = SendDlgItemMessage(IDC_LISTBOX1, LB_GETCARETINDEX, 0,0L);

  if (frIndex)
	 {
	  wParam = (WPARAM) (BOOL) TRUE;
	  lParam = MAKELPARAM (frIndex,0);
	  SendDlgItemMessage(IDC_LISTBOX1, LB_SETSEL, wParam, lParam);
	 }*/

}














