//----------------------------------------------------------------------------
//  Project Pliwrap
//  BahrData / SES GmbH
//  Copyright  1997. All Rights Reserved.
//
//  SUBSYSTEM:    Pliwrap Application
//  FILE:         plwrmdic.h
//  AUTHOR:       Helmuth C. Bahr
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TPliwrapMDIClient (TMDIClient).
//
//----------------------------------------------------------------------------
#if !defined(plwrmdic_h)              // Sentry, use file only if it's not already included.
#define plwrmdic_h

#include "plwrpapp.rh"            // Definition of all resources.


//{{TMDIClient = TPliwrapMDIClient}}
class TPliwrapMDIClient : public TMDIClient {
  public:
	 char execini[MAX_PATH];

/*	 char progname[MAX_PATH];
	 char progfile[MAX_PATH];*/

	 char editor[MAX_PATH];
	 char version[MAX_PATH];
	 char mode[MAX_PATH];
	 char type[MAX_PATH];

	 char inputdir[MAX_PATH];
	 char outputdir[MAX_PATH];
	 char workdir[MAX_PATH];
	 char copy1[MAX_PATH];
	 char copy2[MAX_PATH];
	 char copy3[MAX_PATH];
	 char copy4[MAX_PATH];
	 char copy5[MAX_PATH];
	 char modulpath[MAX_PATH];
	 char progfile[MAX_PATH];
	 char progname[MAX_PATH];
	 char objfile[MAX_PATH];

    int      ChildCount;                 // Number of child window created.

    TPliwrapMDIClient(TModule* module = 0);
    virtual ~TPliwrapMDIClient();

	 void CmEditor ();
	 void CmAddDir ();
	 void CmAddCopy();
	 void CmView();
	 void CmPara();
	 void CmProgram();
	 void CmProcedure();
	 void CmTransaction();
	 void CmModule();
	 void GetName(char *, char *);

	 void GetIni   ();
	 void WriteIni ();
    void GetExtensions ();
	 int  GetExecIni   ();
	 int  WriteExecIni ();

//{{TPliwrapMDIClientVIRTUAL_BEGIN}}
  protected:
    virtual void SetupWindow();
//{{TPliwrapMDIClientVIRTUAL_END}}

//{{TPliwrapMDIClientRSP_TBL_BEGIN}}
  protected:
    void CmFileOpen();
//{{TPliwrapMDIClientRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TPliwrapMDIClient);
};    //{{TPliwrapMDIClient}}


#endif  // plwrmdic_h sentry.
