//----------------------------------------------------------------------------
//  Project Pliwrap
//  BahrData / SES GmbH
//  Copyright  1997. All Rights Reserved.
//
//  SUBSYSTEM:    Pliwrap Application
//  FILE:         plwrpapp.h
//  AUTHOR:       Helmuth C. Bahr
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TPliwrapApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(plwrpapp_h)              // Sentry, use file only if it's not already included.
#define plwrpapp_h

#include <owl/controlb.h>
#include <owl/docking.h>
#include <owl/opensave.h>

#include "plwrmdic.h"

#include "plwrpapp.rh"            // Definition of all resources.


//{{TApplication = TPliwrapApp}}
class TPliwrapApp : public TApplication {
  private:
    bool            HelpState;                          // Has the help engine been used.
    bool            ContextHelp;                        // SHIFT-F1 state(context sensitive HELP)
    TCursor*        HelpCursor;                         // Context sensitive help cursor.

    void SetupSpeedBar(TDecoratedMDIFrame* frame);

  public:
    TPliwrapApp();
    virtual ~TPliwrapApp();

    TOpenSaveDialog::TData  FileData;                   // Data to control open/saveas standard dialog.

    TPliwrapMDIClient*  MdiClient;

    THarbor*        ApxHarbor;

	 char execini[MAX_PATH];
	 char extensions[100][10];
    int  max_extensions;
	 int  select; //ok button in dialogs->true
	 char title[80];
	 char tcopy1[MAX_PATH];
	 char tcopy2[MAX_PATH];
	 char tcopy3[MAX_PATH];
	 char tcopy4[MAX_PATH];
	 char tcopy5[MAX_PATH];

	 char worklib[MAX_PATH];
	 char datout[MAX_PATH];
	 char objname[MAX_PATH];

    int xversion,xmode,xtype;
    char xeditor[MAX_PATH];

    //{{TPliwrapAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual bool CanClose();
    virtual bool ProcessAppMsg(MSG& msg);
//{{TPliwrapAppVIRTUAL_END}}

//{{TPliwrapAppRSP_TBL_BEGIN}}
  protected:
    void CmHelpContents();
    void CmHelpUsing();
    void CmHelpAbout();
//{{TPliwrapAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TPliwrapApp);
};    //{{TPliwrapApp}}


#endif  // plwrpapp_h sentry.
