/*  Projekt pliwrap
	 SES GmbH
	 Copyright  1999 Alle Rechte vorbehalten.

	 SYSTEM:       pliwrap.exe Application
	 DATEI:        selpli.cpp
	 AUTOR:        Helmuth C. Bahr


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von redocAboutDlg (TDialog).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "selpli.h"
#include "stdio.h"
#include "plwrpapp.h"
#include <windows.h>

DEFINE_RESPONSE_TABLE1(TSelectPli, TDialog)
  EV_LBN_SELCHANGE(IDC_LISTBOX1, HandleListBox),
  EV_COMMAND (IDOK, HandleOk),
END_RESPONSE_TABLE;

//{{TSelectPli Implementation}}
TSelectPli::TSelectPli (TWindow* parent, LPSTR TPath, LPSTR inputdir,
								TResId resId, TModule* module):
								TDialog(parent, resId, module)
{

	 // INSERT>> Your constructor code here.
	 strcpy (path, TPath);
	 ptrTPath = TPath;
	 strcpy (input, inputdir);

}


TSelectPli::~TSelectPli()
{
	 Destroy();

	 // INSERT>> Your destructor code here.

}

void TSelectPli::HandleOk ()
{

 GetDlgItemText (IDC_EDIT1, path, MAX_PATH);
 strcpy (ptrTPath, path);
 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);
 theApp->select=1;
 CloseWindow ();
}


void TSelectPli::HandleListBox ()
{
 DlgDirSelectEx(HWindow, path, sizeof(path), IDC_LISTBOX1);
 SetDlgItemText (IDC_EDIT1, path);
}

void TSelectPli::SetupWindow ()
{
 char xpath[MAX_PATH];
 int i;

 TPliwrapApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), TPliwrapApp);
 SetCaption (theApp->title);

 if (theApp->max_extensions > 0)
  {
	i=0;
	while (i < theApp->max_extensions)
	 {
	  sprintf(xpath,"%s\\*.%s",input,theApp->extensions[i]);
	  SendDlgItemMessage(IDC_LISTBOX1, LB_DIR, DDL_READWRITE,(LPARAM) xpath);
	  i++;
	 }
  }
 else
  {
	  sprintf(xpath,"%s\\*.*",input);
	  SendDlgItemMessage(IDC_LISTBOX1, LB_DIR, DDL_READWRITE,(LPARAM) xpath);
  }
}

