       IDENTIFICATION DIVISION.
       PROGRAM-ID. LIEFERN.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.
           DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT LIEFERPOSTEN ASSIGN TO DYNAMIC INPUT-FILE
                  ORGANIZATION IS LINE SEQUENTIAL
                  ACCESS IS SEQUENTIAL
                  FILE STATUS IS INPUT-STAT.
           SELECT LIEFERANTEN ASSIGN TO 'DATLIXS'
                  ORGANIZATION IS INDEXED ACCESS IS DYNAMIC
                  RECORD KEY IS LIEFERANT-KEY
                  FILE STATUS IS IXL-FSTS.
           SELECT LIEFERPREISE ASSIGN TO 'DATPIXS'
                  ORGANIZATION IS INDEXED ACCESS IS SEQUENTIAL
                  RECORD KEY IS LIEFPREIS-KEY
                  FILE STATUS IS IXP-FSTS.
           SELECT LIEFERAUFTRAG  ASSIGN TO 'Liefauft.txt'
                  ORGANIZATION IS LINE SEQUENTIAL
                  ACCESS IS SEQUENTIAL
                  FILE STATUS IS OUTPUT-STAT.
      *
      ******************************************************************
      *
       DATA DIVISION.
       FILE SECTION.
      *                                    Rechnungsposten
       FD  LIEFERPOSTEN
           RECORD CONTAINS 48 CHARACTERS
           DATA RECORD IS LIEFERPOST.
       01  LIEFERPOST.
           05  LIEFERANTNR            PIC 9(8).
           05  ARTIKELNR              PIC 9(8).
           05  ARTIKELNAME            PIC X(20).
           05  ARTIKELMENGE           PIC 9999.
      *
      *                                    Lieferantendaten
       FD  LIEFERANTEN
           RECORD CONTAINS 164 CHARACTERS
           DATA RECORD IS LIEFERANTENSATZ.
       01  LIEFERANTENSATZ.
           02 LIEFERANT-KEY.
              03 LIEFERANTNR          PIC 9(8).
           02 LIEFERANTDATEN.
              03 LIEFERANTNAME        PIC X(20).
              03 LIEFERBONITAET       PIC 9.
              03 LIEFERANSCRIFT.
                 04  PERSONNAME       PIC X(40).
                 04  STRASSE          PIC X(40).
                 04  POSTLEITZAHL     PIC X(5).
                 04  ORT              PIC X(20).
                 04  LAND             PIC X(20).
      *
      *                                    Lieferantenpreise
      *
       FD  LIEFERPREISE
           RECORD CONTAINS 24 CHARACTERS
           DATA RECORD IS LIEFERPREIS.
       01  LIEFERPREIS.
           02 LIEFPREIS-KEY.
              03 LIEFERANT-NR         PIC 9(8).
              03 ARTIKEL-NR           PIC 9(8).
           02 ARTIKEL-PREIS           PIC 99999V99.
      *
      *                                    Rechnungsliste
       FD  LIEFERAUFTRAG
           RECORD CONTAINS 72 CHARACTERS
           DATA RECORD IS LIEFERZEILE.
       01  LIEFERZEILE             PIC X(72).
      *
      **************************************************************
       WORKING-STORAGE SECTION.
      *                                    Interface for DB-ACCESS
       77  INPUT-FILE                 PIC X(80).
       77  INPUT-STAT                 PIC XX.
           88 INPUT-OK                    VALUE '00'.
           88 INPUT-EOF                   VALUE '09'.
       77  OUTPUT-STAT                PIC XX.
       77  IXL-FSTS                   PIC XX.
           88 IXL-FSTS-OK                 VALUE '00'.
           88 IXL-FSTS-NOK                VALUE '02'.
           88 IXL-FSTS-EOF                VALUE '09'.
       77  IXL-EOF                    PIC 9.
       77  IXP-FSTS                   PIC XX.
           88 IXP-FSTS-OK                 VALUE '00'.
           88 IXP-FSTS-NOK                VALUE '02'.
           88 IXP-FSTS-EOF                VALUE '09'.
       77  IXP-EOF                    PIC 9.
       77  STOP-KEY                   PIC X.
       01  INDEXES.
           05  POSTEN-NR              PIC 999 BINARY.
           05  I                      PIC 999 BINARY.
           05  J                      PIC 999 BINARY.
           05  K                      PIC 999 BINARY.
       01  ARBEITSFELDER.
           05  LAST-LIEFERANT         PIC 9(8).
           05  NIEDRIG-LIEFERANT      PIC 9(8).
           05  NIEDRIG-PREIS          PIC 99999V99.
           05  LIEFERBETRAG           PIC 99999V99.
           05  GESAMTBETRAG           PIC 99999V99.
           05  ENDBETRAG              PIC 99999V99.
           05  MEHRWERTSTEUER         PIC 99999V99.
           05  MEHRWERTSTEUERSATZ     PIC 99V99.
           05  LIEFERTERMIN.
               10  LIEFERTAG          PIC 99.
               10  FILLER             PIC X VALUE '.'.
               10  LIEFERMONAT        PIC 99.
               10  FILLER             PIC X VALUE '.'.
               10  LIEFERJAHR         PIC 99.
       01  HEUTIGER-DATUM.
           05  JAHR                   PIC 99.
           05  MONAT                  PIC 99.
           05  TAG                    PIC 99.
       01  LIEFER-TAB.
           05  LIEFER-ENTRY           OCCURS 50 TIMES.
               10  ARTIKEL            PIC 9(8).
               10  LIEFERANT          PIC 9(8).
               10  ARTNAME            PIC X(20).
               10  ARTMENGE           PIC 9(4).
               10  ARTPREIS           PIC 99999V99.
      ****************************************************************
      *    Versandliste                                              *
      ****************************************************************
       01  SEP-LINE.
           05  FILLER                 PIC X     VALUE '+'.
           05  FILLER                 PIC X(70) VALUE ALL '-'.
           05  FILLER                 PIC X     VALUE '+'.
      *****************************************************************
       01  BLANK-LINE.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(70) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-1.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(10) VALUE SPACES.
           05  FILLER                 PIC X(50) VALUE
              '       Sneedies Versandhaus                       '.
           05  FILLER                 PIC X(10) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-2.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(22) VALUE
              '  Lieferauftrag von   '.
           05  FILLER                 PIC X(20) VALUE
              '              Datum:'.
           05  DATUM-AUS              PIC X(8).
           05  FILLER                 PIC X(15) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-3.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Lieferantenname:  '.
           05  LIEFERANTNAME-AUS      PIC X(40).
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-4.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Lieferantenstr:   '.
           05  STRASSE-AUS            PIC X(40).
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-5.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Lieferantenort:   '.
           05  POSTLEITZAHL-AUS       PIC X(6).
           05  ORT-AUS                PIC X(20).
           05  FILLER                 PIC X(19) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-6.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Lieferantenland:  '.
           05  LAND-AUS               PIC X(20).
           05  FILLER                 PIC X(25) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-7.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Liefertermin:     '.
           05  TERMIN-AUS             PIC X(20).
           05  FILLER                 PIC X(25) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-8.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(50) VALUE
              'Auftragnr Artikelnr Artikelname       Stueckpreis '.
           05  FILLER                 PIC X(14) VALUE
              ' Menge Betrag'.
           05  FILLER                 PIC X     VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  DATA-LINE.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  AUFTRAGNR-AUS          PIC 9(8).
           05  FILLER                 PIC XX    VALUE SPACES.
           05  ARTIKELNR-AUS          PIC 9(8).
           05  FILLER                 PIC XX    VALUE SPACES.
           05  ARTIKELNAME-AUS        PIC X(20).
           05  ARTIKELPREIS-AUS       PIC ZZZZ9,99.
           05  FILLER                 PIC XXX   VALUE SPACES.
           05  MENGE-AUS              PIC 9999.
           05  BETRAG-AUS             PIC ZZZZ9,99.
           05  FILLER                 PIC XX    VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  FOOT-LINE-1.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(40) VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '    Gesamtbetrag:   '.
           05  GESAMTBETRAG-AUS       PIC ZZZZ9,99.
           05  FILLER                 PIC XX    VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  FOOT-LINE-2.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(34) VALUE
              '                 Mehrwertsteuer:  '.
           05  MWST-AUS               PIC ZZZZ9,99.
           05  FILLER                 PIC X(18) VALUE
              '     Endbetrag:   '.
           05  ENDBETRAG-AUS          PIC ZZZZ9,99.
           05  FILLER                 PIC XX    VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
TEST  *LINKAGE SECTION.
       01 LIEFER-PARAMS.
           05 P-AUFTRAGSNR            PIC 9(8).
           05 P-LIEFERNR              PIC 9(8).
           05 P-ARTIKELNR             PIC 9(8).
           05 P-DATUM                 PIC 9(8).
           05 P-MWST-SATZ             PIC 99.
           05 P-FILENAME              PIC X(80).
       77 LIEFER-RETCODE              PIC 99.
      ******************************************************************
      *PROCEDURE DIVISION USING LIEFER-PARAMS, LIEFER-RETCODE.
TEST   PROCEDURE DIVISION.
      ******************************************************************
       MAIN SECTION.
       RECEIVE-PARAMS.
      *                                        Accept Parameters
TEST  *    DISPLAY 'Submit Auftragsnummer:'
TEST  *    ACCEPT  P-AUFTRAGSNR.
TEST  *    DISPLAY 'Submit Artikelnummer: '
TEST  *    ACCEPT  P-ARTIKELNR
TEST  *    DISPLAY 'Submit Lieferdatum:'
TEST  *    ACCEPT  P-DATUM
TEST  *    DISPLAY 'Mehrwertsteuersatz: '
TEST  *    ACCEPT  P-MWST-SATZ
TEST  *    DISPLAY 'Submit Lieferposten File Name:'
TEST  *    ACCEPT  P-FILENAME.
           MOVE ZERO TO P-ARTIKELNR.
      *
       OPEN-LIEFERPOSTEN.
      *                                      Open Lieferpostendatei
           MOVE P-FILENAME TO INPUT-FILE.
           MOVE ZEROS TO INPUT-STAT.
           OPEN INPUT LIEFERPOSTEN
           IF INPUT-STAT NOT = ZEROES
              DISPLAY 'Lieferposten Datei nicht gefunden !!'
              DISPLAY 'Press Enter to Terminate '
              ACCEPT STOP-KEY
              MOVE 5 TO LIEFER-RETCODE
              GOBACK
           END-IF.
      *
       READ-LIEFERPOSTEN.
      *                                      Lese Lieferposten
           MOVE ZEROS TO INPUT-STAT.
           MOVE ZERO TO POSTEN-NR
           PERFORM UNTIL INPUT-STAT NOT = ZEROES
              READ LIEFERPOSTEN
              AT END
                 MOVE '09' TO INPUT-STAT
              NOT AT END
                 ADD 1 TO POSTEN-NR
                 MOVE ZEROES TO LIEFER-ENTRY (POSTEN-NR)
                 MOVE ARTIKELNR IN LIEFERPOSTEN TO ARTIKEL (POSTEN-NR)
                 MOVE ARTIKELNAME IN LIEFERPOSTEN
                   TO ARTNAME (POSTEN-NR)
                 MOVE ARTIKELMENGE IN LIEFERPOSTEN
                   TO ARTMENGE(POSTEN-NR)
                 PERFORM SELECT-LIEFERANT
                 MOVE NIEDRIG-LIEFERANT TO LIEFERANT (POSTEN-NR)
                 MOVE NIEDRIG-PREIS TO ARTPREIS (POSTEN-NR)
              END-READ
           END-PERFORM.
TEST  *    DISPLAY 'Number of Posten read = ' POSTEN-NR
TEST  *    ACCEPT STOP-KEY.
           CLOSE LIEFERPOSTEN.
      *
       OPEN-LIEFERAUFTRAG.
      *                                      Open Lieferauftragliste
           MOVE ZEROS TO OUTPUT-STAT.
           OPEN OUTPUT LIEFERAUFTRAG.
      *
       OPEN-LIEFERANTEN.
      *                                      Open Lieferantendatei
           MOVE ZEROS TO IXL-FSTS.
           OPEN INPUT LIEFERANTEN
           IF IXL-FSTS NOT = ZEROES
              DISPLAY 'Lieferantdatei konnte nicht eroeffnet werden !!'
              DISPLAY 'Press Enter to Terminate '
              ACCEPT STOP-KEY
              MOVE 6 TO LIEFER-RETCODE
              GOBACK
           END-IF.
      *
       PROCESS-LIEFERPOSTEN.
      *                                        Lese Lieferposten
           MOVE ZEROS TO LAST-LIEFERANT
           MOVE 1 TO I
           PERFORM UNTIL I > POSTEN-NR OR > 50
              MOVE ZERO TO LIEFER-RETCODE
              IF LIEFERANT (I) NOT = ZEROS
      *                                        Wechsele Lieferant
                 MOVE LIEFERANT (I) TO LAST-LIEFERANT
                 ADD 1 TO P-AUFTRAGSNR
                 IF P-AUFTRAGSNR > 1
                    PERFORM BERECHNE-ENDBETRAG
                    PERFORM WRITE-FUSS
                 END-IF
                 MOVE LAST-LIEFERANT TO LIEFERANTNR IN LIEFERANTENSATZ
                 READ LIEFERANTEN
                 INVALID KEY
                    DISPLAY 'Lieferant wurde nicht gefunden !!'
                    DISPLAY 'Lieferantennr:' NIEDRIG-LIEFERANT
                    DISPLAY 'Press Enter to Continue  '
                    ACCEPT STOP-KEY
                    MOVE 7 TO LIEFER-RETCODE
                 END-READ
                 PERFORM COMPUTE-LIEFERTERMIN
                 PERFORM WRITE-KOPF
                 MOVE I TO K
                 PERFORM WRITE-LIEFERPOST
                 PERFORM SUM-GESAMTBETRAG
                 MOVE ZEROES TO LIEFERANT (I)
      *                                        Finde weitere Posten
                 COMPUTE J = I + 1
                 PERFORM UNTIL J > POSTEN-NR OR > 50
                    IF LAST-LIEFERANT = LIEFERANT (J)
                       MOVE J TO K
                       PERFORM WRITE-LIEFERPOST
                       PERFORM SUM-GESAMTBETRAG
                       MOVE ZEROES TO LIEFERANT (J)
                    END-IF
                    ADD 1 TO J
                 END-PERFORM
              END-IF
              ADD 1 TO I
           END-PERFORM.
      *
       CLOSE-LIEFERAUFTRAG.
      *                                        Close Lieferposten
           PERFORM BERECHNE-ENDBETRAG
           PERFORM WRITE-FUSS.
           CLOSE LIEFERANTEN.
           CLOSE LIEFERAUFTRAG.
      *    DISPLAY ' Lieferposten sind bearbeitet '.
      *    DISPLAY ' Lieferauftraege = ' P-AUFTRAGSNR
      *    DISPLAY ' Press Enter to Terminate !'
      *    ACCEPT STOP-KEY
           GOBACK.
      ******************************************************************
       RECHNUNG-AUSGABE SECTION.
      ******************************************************************
      **                                          Liefertermin
       COMPUTE-LIEFERTERMIN.
           ACCEPT HEUTIGER-DATUM FROM DATE.
           MOVE TAG   TO LIEFERTAG.
           MOVE MONAT TO LIEFERMONAT.
           MOVE JAHR  TO LIEFERJAHR.
           ADD 30 TO LIEFERTAG.
           IF LIEFERMONAT = 2
              IF LIEFERTAG > 28
                  COMPUTE LIEFERTAG = LIEFERTAG - 28
                  ADD 1 TO LIEFERMONAT
              END-IF
           ELSE
              IF LIEFERMONAT = 4 OR 6 OR 9 OR 11
                 IF LIEFERTAG > 30
                    COMPUTE LIEFERTAG = LIEFERTAG - 30
                    ADD 1 TO LIEFERMONAT
                 END-IF
              ELSE
                 IF LIEFERTAG > 31
                    COMPUTE LIEFERTAG = LIEFERTAG - 31
                    ADD 1 TO LIEFERMONAT
                 END-IF
              END-IF
           END-IF.
           MOVE LIEFERTERMIN TO TERMIN-AUS.
      **                                          Schreibe Kopfzeilen
       WRITE-KOPF.
           ADD 1 TO P-AUFTRAGSNR.
           MOVE '/' TO LIEFERZEILE.
           WRITE LIEFERZEILE AFTER PAGE.
           MOVE SEP-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE BLANK-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE HEAD-LINE-1 TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE BLANK-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE P-DATUM TO DATUM-AUS
           MOVE HEAD-LINE-2 TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE BLANK-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE LIEFERANTNAME TO LIEFERANTNAME-AUS
           MOVE HEAD-LINE-3 TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE STRASSE TO STRASSE-AUS
           MOVE HEAD-LINE-4 TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE POSTLEITZAHL TO POSTLEITZAHL-AUS.
           MOVE ORT TO ORT-AUS.
           MOVE HEAD-LINE-5 TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE LAND TO LAND-AUS.
           MOVE HEAD-LINE-6 TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE LIEFERTERMIN TO TERMIN-AUS.
           MOVE HEAD-LINE-7 TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE BLANK-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE HEAD-LINE-8 TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE SEP-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
      **                                          Schreibe Lieferzeile
       WRITE-LIEFERPOST.
           MOVE BLANK-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE LAST-LIEFERANT TO AUFTRAGNR-AUS
           MOVE ARTIKEL  (K)   TO ARTIKELNR-AUS
           MOVE ARTNAME  (K)   TO ARTIKELNAME-AUS
           MOVE ARTMENGE (K)   TO MENGE-AUS
           MOVE ARTPREIS (K)   TO ARTIKELPREIS-AUS
           COMPUTE LIEFERBETRAG = ARTPREIS (K)  * ARTMENGE (K)
           MOVE LIEFERBETRAG TO BETRAG-AUS.
           MOVE DATA-LINE TO LIEFERZEILE
           WRITE LIEFERZEILE.
      **                                          Sum Gesamtbetrag
       SUM-GESAMTBETRAG.
           ADD LIEFERBETRAG TO GESAMTBETRAG.
      **                                          Sum Endbetrag
       BERECHNE-ENDBETRAG.
           COMPUTE MEHRWERTSTEUERSATZ = P-MWST-SATZ * 0,01
           COMPUTE MEHRWERTSTEUER = GESAMTBETRAG * MEHRWERTSTEUERSATZ
           COMPUTE ENDBETRAG = GESAMTBETRAG + MEHRWERTSTEUER
           MOVE GESAMTBETRAG TO GESAMTBETRAG-AUS
           MOVE MEHRWERTSTEUER TO MWST-AUS
           MOVE ENDBETRAG TO ENDBETRAG-AUS.
      **                                          Schreibe Fusszeile-1
       WRITE-FUSS.
           MOVE BLANK-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE SEP-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE FOOT-LINE-1 TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE SEP-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
      **                                          Schreibe Fusszeile-2
           MOVE BLANK-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE FOOT-LINE-2 TO LIEFERZEILE.
           WRITE LIEFERZEILE.
           MOVE SEP-LINE TO LIEFERZEILE.
           WRITE LIEFERZEILE.
      ******************************************************************
       SELECT-LIEFERANT SECTION.
      **                                      Finde billigster Preis
      ******************************************************************
       OPEN-LIEFERPREISE.
      *                                      Open Lieferpreisdatei
           MOVE ZEROS TO IXP-FSTS.
           OPEN INPUT LIEFERPREISE
           IF IXP-FSTS NOT = ZEROES
              DISPLAY 'Lieferpreise konnte nicht eroeffnet werden !!'
              DISPLAY 'Press Enter to Terminate '
              ACCEPT STOP-KEY
              MOVE 8 TO LIEFER-RETCODE
              GOBACK
           END-IF.
      *
       SUCHE-BILLIGSTER-LIEFERANT.
      *                                        Lese erste lieferant
           MOVE ZEROS TO LIEFPREIS-KEY.
           MOVE ZEROS TO IXP-FSTS.
           MOVE ZEROS TO NIEDRIG-LIEFERANT
           MOVE 9999,99 TO NIEDRIG-PREIS
           PERFORM UNTIL IXP-FSTS-EOF
              READ LIEFERPREISE
                AT END
                   MOVE '09' TO IXP-FSTS
                NOT AT END
                   IF ARTIKELNR IN LIEFERPOST = ARTIKEL-NR
                      IF ARTIKEL-PREIS < NIEDRIG-PREIS
                         MOVE ARTIKEL-PREIS TO NIEDRIG-PREIS
                         MOVE LIEFERANT-NR  TO NIEDRIG-LIEFERANT
                      END-IF
                   END-IF
              END-READ
           END-PERFORM.
      *
       CLOSE-LIEFERPREISE.
      *                                     Close Lieferpreisdatei
TEST  *    DISPLAY 'Niedrig Preis:' NIEDRIG-PREIS
TEST  *    DISPLAY 'Niedrig Lieferant' NIEDRIG-LIEFERANT
TEST  *    ACCEPT STOP-KEY.
           CLOSE LIEFERPREISE.
      *****************************************************************
