       IDENTIFICATION DIVISION.
       PROGRAM-ID. RECHNUNG.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.
           DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT RECHNUNGSPOSTEN ASSIGN TO DYNAMIC INPUT-FILE
                  ORGANIZATION IS LINE SEQUENTIAL
                  ACCESS IS SEQUENTIAL
                  FILE STATUS IS INPUT-STAT.
           SELECT KUNDEN ASSIGN TO 'DATAIXS'
                  ORGANIZATION IS INDEXED ACCESS IS DYNAMIC
                  RECORD KEY IS KUNDEN-KEY
                  FILE STATUS IS IXS-FSTS.
           SELECT RECHNUNGSLISTE  ASSIGN TO 'Rechnung.txt'
                  ORGANIZATION IS LINE SEQUENTIAL
                  ACCESS IS SEQUENTIAL
                  FILE STATUS IS OUTPUT-STAT.
      *
      ******************************************************************
      *
       DATA DIVISION.
       FILE SECTION.
      *                                    Rechnungsposten
       FD  RECHNUNGSPOSTEN
           RECORD CONTAINS 48 CHARACTERS
           DATA RECORD IS RECHNUNGSPOST.
       01  RECHNUNGSPOST.
           05  AUFTRAGSNR             PIC 9(8).
           05  KUNDENNR               PIC 9(8).
           05  ARTIKELNR              PIC 9(8).
           05  ARTIKELNAME            PIC X(20).
           05  BESTELLMENGE           PIC 9(4).
           05  ARTIKELPREISE.
               10  ARTIKELPREIS-1     PIC 999.
               10  ARTIKEL-DECIMAL    PIC X.
               10  ARTIKELPREIS-2     PIC 99.
      *                                    Kundendaten
       FD  KUNDEN
           RECORD CONTAINS 164 CHARACTERS
           DATA RECORD IS KUNDENSATZ.
       01  KUNDENSATZ.
           02 KUNDEN-KEY.
              03 KUNDENNR             PIC 9(8).
           02 KUNDENDATEN.
              03 KUNDENNAME           PIC X(20).
              03 KUNDENBONITAET       PIC 9.
              03 KUNDENANSCRIFT.
                 04  PERSONNAME       PIC X(40).
                 04  STRASSE          PIC X(40).
                 04  POSTLEITZAHL     PIC X(5).
                 04  ORT              PIC X(20).
                 04  LAND             PIC X(20).
      *                                    Rechnungsliste
       FD  RECHNUNGSLISTE
           RECORD CONTAINS 72 CHARACTERS
           DATA RECORD IS RECHNUNGSZEILE.
       01  RECHNUNGSZEILE             PIC X(72).
      *
      **************************************************************
       WORKING-STORAGE SECTION.
      *                                    Interface for DB-ACCESS
       77  INPUT-FILE                 PIC X(80).
       77  INPUT-STAT                 PIC XX.
           88 INPUT-OK                    VALUE '00'.
           88 INPUT-EOF                   VALUE '09'.
       77  OUTPUT-STAT                PIC XX.
       77  IXS-FSTS                   PIC XX.
           88 IXS-FSTS-OK                 VALUE '00'.
           88 IXS-FSTS-NOK                VALUE '02'.
           88 IXS-FSTS-EOF                VALUE '09'.
       77  IXS-EOF                    PIC 9.
       77  STOP-KEY                   PIC X.
       01  ARBEITSFELDER.
           05  ART-PREIS.
               10 ART-PREIS-1         PIC 999.
               10 ART-PREIS-2         PIC 99.
           05  ARTIKELPREIS           REDEFINES ART-PREIS
                                      PIC 999V99.
           05  MEHRWERTSTEUERSATZ     PIC 9V99.
           05  MEHRWERTSTEUER         PIC 9999V99.
           05  POSTENPREIS            PIC 9999V99.
           05  GESAMTPREIS            PIC 9999V99.
           05  ENDPREIS               PIC 9999V99.
           05  ZAHLUNGSTERMIN.
               10  ZAHLUNGSTAG        PIC 99.
               10  FILLER             PIC X VALUE '.'.
               10  ZAHLUNGSMONAT      PIC 99.
               10  FILLER             PIC X VALUE '.'.
               10  ZAHLUNGSJAHR       PIC 99.
       01  HEUTIGER-DATUM.
           05  JAHR                   PIC 99.
           05  MONAT                  PIC 99.
           05  TAG                    PIC 99.
      ****************************************************************
      *    Versandliste                                              *
      ****************************************************************
       01  SEP-LINE.
           05  FILLER                 PIC X     VALUE '+'.
           05  FILLER                 PIC X(70) VALUE ALL '-'.
           05  FILLER                 PIC X     VALUE '+'.
      *****************************************************************
       01  BLANK-LINE.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(70) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-1.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(10) VALUE SPACES.
           05  FILLER                 PIC X(50) VALUE
              '       Sneedies Versandhaus                       '.
           05  FILLER                 PIC X(10) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-2.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(22) VALUE
              '  Rechnung von        '.
           05  FILLER                 PIC X(20) VALUE
              '              Datum:'.
           05  DATUM-AUS              PIC X(8).
           05  FILLER                 PIC X(15) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-3.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Kundenname:       '.
           05  KUNDENNAME-AUS         PIC X(40).
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-4.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Kundenstrasse:    '.
           05  STRASSE-AUS            PIC X(40).
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-5.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Kundenortschaft:  '.
           05  POSTLEITZAHL-AUS       PIC X(6).
           05  ORT-AUS                PIC X(20).
           05  FILLER                 PIC X(19) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-6.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Kundenland:       '.
           05  LAND-AUS               PIC X(20).
           05  FILLER                 PIC X(25) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-7.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Zahlungstermin:   '.
           05  TERMIN-AUS             PIC X(20).
           05  FILLER                 PIC X(25) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-8.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(50) VALUE
              'Auftragnr Artikelnr Artikelname       Artikelpreis'.
           05  FILLER                 PIC X(13) VALUE
              ' Menge Preis'.
           05  FILLER                 PIC XX    VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  DATA-LINE.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  KUNDENNR-AUS           PIC 9(8).
           05  FILLER                 PIC XX    VALUE SPACES.
           05  ARTIKELNR-AUS          PIC 9(8).
           05  FILLER                 PIC XX    VALUE SPACES.
           05  ARTIKELNAME-AUS        PIC X(20).
           05  FILLER                 PIC X     VALUE SPACES.
           05  ARTIKELPREIS-AUS       PIC ZZ9,99.
           05  FILLER                 PIC XXXX  VALUE SPACES.
           05  MENGE-AUS              PIC 9999.
           05  FILLER                 PIC X     VALUE SPACES.
           05  POSTENPREIS-AUS        PIC ZZZ9,99.
           05  FILLER                 PIC XX    VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  FOOT-LINE-1.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(40) VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '    Gesamtpreis:    '.
           05  GESAMTPREIS-AUS        PIC ZZZZ9,99.
           05  FILLER                 PIC XX    VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  FOOT-LINE-2.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(34) VALUE
              '                 Mehrwertsteuer:  '.
           05  MWST-AUS               PIC ZZZZ9,99.
           05  FILLER                 PIC X(18) VALUE
              '     Endpreis:    '.
           05  ENDPREIS-AUS           PIC ZZZZ9,99.
           05  FILLER                 PIC XX    VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
TEST  *LINKAGE SECTION.
       01 RECHNUNG-PARAMS.
           05 P-AUFTRAGSNR            PIC 9(8).
           05 P-KUNDENNR              PIC 9(8).
           05 P-RECHNUNGSNR           PIC 9(8).
           05 P-DATUM                 PIC 9(8).
           05 P-MWST-SATZ             PIC 99.
           05 P-FILENAME              PIC X(80).
       77 RECHNUNG-RETCODE            PIC 99.
      ******************************************************************
      *PROCEDURE DIVISION USING RECHNUNG-PARAMS, RECHNUNG-RETCODE.
TEST   PROCEDURE DIVISION.
      ******************************************************************
       MAIN SECTION.
       RECEIVE-PARAMS.
      *                                        Accept Parameters
TEST       DISPLAY 'Submit Auftragsnummer:'
TEST       ACCEPT  P-AUFTRAGSNR.
TEST       DISPLAY 'Submit Kundennummer:'
TEST       ACCEPT  P-KUNDENNR.
TEST       DISPLAY 'Submit Rechnungsnummer: '
TEST       ACCEPT  P-RECHNUNGSNR
TEST       DISPLAY 'Submit Rechnungsdatum:'
TEST       ACCEPT  P-DATUM
TEST       DISPLAY 'Mehrwertsteuersatz: '
TEST       ACCEPT  P-MWST-SATZ
TEST       DISPLAY 'Submit Rechnungsposten File Name:'
TEST       ACCEPT  P-FILENAME.
           MOVE ZERO TO P-RECHNUNGSNR.
      *
       OPEN-RECHNUNGSPOSTEN.
      *                                      Open Rechnungspostendatei
           MOVE P-FILENAME TO INPUT-FILE.
           MOVE ZEROS TO INPUT-STAT.
           OPEN INPUT RECHNUNGSPOSTEN
           IF INPUT-STAT NOT = ZEROES
      *       DISPLAY 'Rechnungsposten Datei nicht gefunden !!'
      *       DISPLAY 'Press Enter to Terminate '
      *       ACCEPT STOP-KEY
              MOVE 5 TO RECHNUNG-RETCODE
              GOBACK
           END-IF.
       OPEN-KUNDEN.
      *                                      Open Kundendatei
           MOVE ZEROS TO IXS-FSTS.
           OPEN INPUT KUNDEN.
           IF IXS-FSTS NOT = ZEROES
      *       DISPLAY 'Kundendatei konnte nicht eroeffnet werden !!'
      *       DISPLAY 'Press Enter to Terminate '
      *       ACCEPT STOP-KEY
              MOVE 6 TO RECHNUNG-RETCODE
              GOBACK
           END-IF.
       FIND-FIRST-KUNDE.
      *                                        Lese erste Kunde
           MOVE P-KUNDENNR TO KUNDENNR IN KUNDENSATZ.
           READ KUNDEN
           INVALID KEY
              DISPLAY 'Kunde konnte nicht gefunden werden !!'
              DISPLAY 'Kundennummer: ' P-KUNDENNR
              DISPLAY 'Press Enter to Terminate '
              ACCEPT STOP-KEY
              MOVE 7 TO RECHNUNG-RETCODE
              GOBACK
           END-READ.
       OPEN-RECHNUNGSLISTE.
      *                                        Open Rechnungsliste
           MOVE ZEROS TO OUTPUT-STAT.
           OPEN OUTPUT RECHNUNGSLISTE.
      *
       INIT-RECHNUNGSPOSTEN.
      *                                        Lese Rechnungsposten
           MOVE ZEROES TO INPUT-STAT.
           PERFORM UNTIL INPUT-STAT NOT = ZEROES
                      OR KUNDENNR IN RECHNUNGSPOST =
                         KUNDENNR IN KUNDENSATZ
              READ RECHNUNGSPOSTEN
              AT END
                 MOVE '09' TO INPUT-STAT
              NOT AT END
                 MOVE ZERO TO RECHNUNG-RETCODE
              END-READ
           END-PERFORM.
           IF KUNDENNR IN RECHNUNGSPOST =
              KUNDENNR IN KUNDENSATZ
              PERFORM COMPUTE-ZAHLUNGSTERMIN
              PERFORM WRITE-KOPF
              PERFORM WRITE-RECHNUNGSPOST
              PERFORM SUM-GESAMTPREIS
              ADD 1 TO P-RECHNUNGSNR
           END-IF.
      *
       PROCESS-RECHNUNGSPOSTEN.
      *                                        Lese Rechnungsposten
           MOVE ZEROES TO INPUT-STAT.
           PERFORM UNTIL INPUT-STAT NOT = ZEROES
              READ RECHNUNGSPOSTEN
              AT END
                 MOVE '09' TO INPUT-STAT
              NOT AT END
                 MOVE ZERO TO RECHNUNG-RETCODE
                 IF KUNDENNR IN RECHNUNGSPOST NOT =
                    KUNDENNR IN KUNDENSATZ
      *                                        Wechsele Kunden
                    PERFORM BERECHNE-ENDPREIS
                    PERFORM WRITE-FUSS
                    MOVE KUNDENNR IN RECHNUNGSPOST TO
                         KUNDENNR IN KUNDENSATZ
                    READ KUNDEN
                    INVALID KEY
                       DISPLAY 'Kunde konnte nicht gefunden werden !!'
                       DISPLAY 'Kundennummer: ' KUNDENNR IN KUNDENSATZ
                       DISPLAY 'Press Enter to Continue  '
                       ACCEPT STOP-KEY
                       MOVE 7 TO RECHNUNG-RETCODE
                    END-READ
                    PERFORM COMPUTE-ZAHLUNGSTERMIN
                    PERFORM WRITE-KOPF
                 END-IF
                 PERFORM WRITE-RECHNUNGSPOST
                 PERFORM SUM-GESAMTPREIS
                 ADD 1 TO P-RECHNUNGSNR
              END-READ
           END-PERFORM.
      *
       CLOSE-RECHNUNGSAUSSTELLUNG.
      *                                        Close Rechnungsposten
           PERFORM WRITE-FUSS.
           CLOSE KUNDEN.
           CLOSE RECHNUNGSPOSTEN.
           DISPLAY ' Rechnungsposten sind bearbeitet '.
           DISPLAY ' Rechnungsposten = ' P-RECHNUNGSNR
           DISPLAY ' Press Enter to Terminate !'
           ACCEPT STOP-KEY
           GOBACK.
      ******************************************************************
       RECHNUNG-AUSGABE SECTION.
      **                                          Zahlungstermin
       COMPUTE-ZAHLUNGSTERMIN.
           ACCEPT HEUTIGER-DATUM FROM DATE.
           MOVE TAG   TO ZAHLUNGSTAG.
           MOVE MONAT TO ZAHLUNGSMONAT.
           MOVE JAHR  TO ZAHLUNGSJAHR.
           ADD 7 TO ZAHLUNGSTAG.
           IF ZAHLUNGSMONAT = 2
              IF ZAHLUNGSTAG > 28
                  COMPUTE ZAHLUNGSTAG = ZAHLUNGSTAG - 28
                  ADD 1 TO ZAHLUNGSMONAT
              END-IF
           ELSE
              IF ZAHLUNGSMONAT = 4 OR 6 OR 9 OR 11
                 IF ZAHLUNGSTAG > 30
                    COMPUTE ZAHLUNGSTAG = ZAHLUNGSTAG - 30
                    ADD 1 TO ZAHLUNGSMONAT
                 END-IF
              ELSE
                 IF ZAHLUNGSTAG > 31
                    COMPUTE ZAHLUNGSTAG = ZAHLUNGSTAG - 31
                    ADD 1 TO ZAHLUNGSMONAT
                 END-IF
              END-IF
           END-IF.
           MOVE ZAHLUNGSTERMIN TO TERMIN-AUS.
      **                                          Schreibe Kopfzeilen
       WRITE-KOPF.
           MOVE '/' TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE AFTER PAGE.
           MOVE SEP-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE BLANK-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE HEAD-LINE-1 TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE BLANK-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE P-DATUM TO DATUM-AUS
           MOVE HEAD-LINE-2 TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE BLANK-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE KUNDENNAME TO KUNDENNAME-AUS
           MOVE HEAD-LINE-3 TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE STRASSE TO STRASSE-AUS
           MOVE HEAD-LINE-4 TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE POSTLEITZAHL TO POSTLEITZAHL-AUS.
           MOVE ORT TO ORT-AUS.
           MOVE HEAD-LINE-5 TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE LAND TO LAND-AUS.
           MOVE HEAD-LINE-6 TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE BLANK-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE ZAHLUNGSTERMIN TO TERMIN-AUS.
           MOVE HEAD-LINE-7 TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE HEAD-LINE-8 TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE SEP-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
      **                                          Schreibe Versandzeile
       WRITE-RECHNUNGSPOST.
           MOVE BLANK-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE KUNDENNR     IN RECHNUNGSPOST TO KUNDENNR-AUS
           MOVE ARTIKELNR    IN RECHNUNGSPOST TO ARTIKELNR-AUS
           MOVE ARTIKELNAME  IN RECHNUNGSPOST TO ARTIKELNAME-AUS
           MOVE ZERO TO ARTIKELPREIS
           MOVE ARTIKELPREIS-1 TO ART-PREIS-1
           MOVE ARTIKELPREIS-2 TO ART-PREIS-2
           MOVE ARTIKELPREIS TO ARTIKELPREIS-AUS
           MOVE BESTELLMENGE TO MENGE-AUS
           COMPUTE POSTENPREIS = ARTIKELPREIS * BESTELLMENGE
           MOVE POSTENPREIS TO POSTENPREIS-AUS.
           MOVE DATA-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
      **                                          Sum Gesamtpreis
       SUM-GESAMTPREIS.
           ADD POSTENPREIS TO GESAMTPREIS.
      **                                          Sum Endpreis
       BERECHNE-ENDPREIS.
           COMPUTE MEHRWERTSTEUERSATZ = P-MWST-SATZ * 0,01
           COMPUTE MEHRWERTSTEUER = GESAMTPREIS * MEHRWERTSTEUERSATZ
           COMPUTE ENDPREIS = GESAMTPREIS + MEHRWERTSTEUER
           MOVE GESAMTPREIS TO GESAMTPREIS-AUS
           MOVE MEHRWERTSTEUER TO MWST-AUS
           MOVE ENDPREIS TO ENDPREIS-AUS.
      **                                          Schreibe Fusszeile-1
       WRITE-FUSS.
           MOVE BLANK-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE SEP-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE FOOT-LINE-1 TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE SEP-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
      **                                          Schreibe Fusszeile-2
           MOVE BLANK-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE FOOT-LINE-2 TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
           MOVE SEP-LINE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSZEILE.
