       IDENTIFICATION DIVISION.
       PROGRAM-ID. VERSAND.
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES.
           DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT VERSANDPOSTEN ASSIGN TO DYNAMIC INPUT-FILE
                  ORGANIZATION IS LINE SEQUENTIAL
                  ACCESS IS SEQUENTIAL
                  FILE STATUS IS INPUT-STAT.
           SELECT KUNDEN ASSIGN TO 'DATAIXS'
                  ORGANIZATION IS INDEXED ACCESS IS DYNAMIC
                  RECORD KEY IS KUNDEN-KEY
                  FILE STATUS IS IXS-FSTS.
           SELECT VERSANDLISTE  ASSIGN TO 'Verslist.txt'
                  ORGANIZATION IS LINE SEQUENTIAL
                  ACCESS IS SEQUENTIAL
                  FILE STATUS IS OUTPUT-STAT.
      *
      ******************************************************************
      *
       DATA DIVISION.
       FILE SECTION.
      *                                    Versandposten
       FD  VERSANDPOSTEN
           RECORD CONTAINS 48 CHARACTERS
           DATA RECORD IS VERSANDPOST.
       01  VERSANDPOST.
           05  AUFTRAGSNR             PIC 9(8).
           05  KUNDENNR               PIC 9(8).
           05  ARTIKELNR              PIC 9(8).
           05  ARTIKELNAME            PIC X(20).
           05  BESTELLMENGE           PIC 9(4).
      *                                    Kundendaten
       FD  KUNDEN
           RECORD CONTAINS 164 CHARACTERS
           DATA RECORD IS KUNDENSATZ.
       01  KUNDENSATZ.
           02 KUNDEN-KEY.
              03 KUNDENNR             PIC 9(8).
           02 KUNDENDATEN.
              03 KUNDENNAME           PIC X(20).
              03 KUNDENBONITAET       PIC 9.
              03 KUNDENANSCRIFT.
                 04  PERSONNAME       PIC X(40).
                 04  STRASSE          PIC X(40).
                 04  POSTLEITZAHL     PIC X(5).
                 04  ORT              PIC X(20).
                 04  LAND             PIC X(20).
      *                                    Versandliste
       FD  VERSANDLISTE
           RECORD CONTAINS 72 CHARACTERS
           DATA RECORD IS VERSANDZEILE.
       01  VERSANDZEILE               PIC X(72).
      *
      **************************************************************
       WORKING-STORAGE SECTION.
      *                                    Interface for DB-ACCESS
       77  INPUT-FILE                 PIC X(80).
       77  INPUT-STAT                 PIC XX.
           88 INPUT-OK                    VALUE '00'.
           88 INPUT-EOF                   VALUE '09'.
       77  OUTPUT-STAT                PIC XX.
       77  IXS-FSTS                   PIC XX.
           88 IXS-FSTS-OK                 VALUE '00'.
           88 IXS-FSTS-NOK                VALUE '02'.
           88 IXS-FSTS-EOF                VALUE '09'.
       77  IXS-EOF                    PIC 9.
       77  STOP-KEY                   PIC X.
      ****************************************************************
      *    Versandliste                                              *
      ****************************************************************
       01  SEP-LINE.
           05  FILLER                 PIC X     VALUE '+'.
           05  FILLER                 PIC X(70) VALUE ALL '-'.
           05  FILLER                 PIC X     VALUE '+'.
      *****************************************************************
       01  BLANK-LINE.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(70) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-1.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(10) VALUE SPACES.
           05  FILLER                 PIC X(50) VALUE
              '       Sneedies Versandhaus Versandliste          '.
           05  FILLER                 PIC X(10) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-2.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(22) VALUE
              '  Versandliste        '.
           05  FILLER                 PIC X(20) VALUE
              '              Datum:'.
           05  DATUM-AUS              PIC X(8).
           05  FILLER                 PIC X(15) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-3.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Kundenname:       '.
           05  KUNDENNAME-AUS         PIC X(40).
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-4.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Kundenstrasse:    '.
           05  STRASSE-AUS            PIC X(40).
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-5.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Kundenortschaft:  '.
           05  POSTLEITZAHL-AUS       PIC X(6).
           05  ORT-AUS                PIC X(20).
           05  FILLER                 PIC X(19) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-6.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(20) VALUE
              '  Kundenland:       '.
           05  LAND-AUS               PIC X(20).
           05  FILLER                 PIC X(25) VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  HEAD-LINE-7.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  FILLER                 PIC X(50) VALUE
              'Kundennr Auftragsnr Artikelnr    Artikelname      '.
           05  FILLER                 PIC X(12) VALUE
              'Bestellmenge'.
           05  FILLER                 PIC X(3)  VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  DATA-LINE.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(5)  VALUE SPACES.
           05  KUNDENNR-AUS           PIC 9(8).
           05  FILLER                 PIC XX    VALUE SPACES.
           05  AUFTRAGSNR-AUS         PIC 9(8).
           05  FILLER                 PIC XX    VALUE SPACES.
           05  ARTIKELNR-AUS          PIC 9(8).
           05  FILLER                 PIC XX    VALUE SPACES.
           05  ARTIKELNAME-AUS        PIC X(20).
           05  FILLER                 PIC XX    VALUE SPACES.
           05  BESTELLMENGE-AUS       PIC 9(5).
           05  FILLER                 PIC X(8)  VALUE SPACES.
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
       01  FOOT-LINE.
           05  FILLER                 PIC X     VALUE '|'.
           05  FILLER                 PIC X(20) VALUE
              '  Versandweg:       '.
           05  VERSANDWEG-AUS         PIC X(50).
           05  FILLER                 PIC X     VALUE '|'.
      *****************************************************************
TEST   LINKAGE SECTION.
       01 VERSAND-PARAMS.
           05 P-AUFTRAGSNR            PIC 9(8).
           05 P-KUNDENNR              PIC 9(8).
           05 P-VERSANDNR             PIC 9(8).
           05 P-DATUM                 PIC 9(8).
           05 P-VERSANDWEG            PIC X(40).
           05 P-FILENAME              PIC X(80).
       77 VERSAND-RETCODE             PIC 99.
      ******************************************************************
       PROCEDURE DIVISION USING VERSAND-PARAMS, VERSAND-RETCODE.
TEST  *PROCEDURE DIVISION.
      ******************************************************************
       MAIN SECTION.
       RECEIVE-PARAMS.
      *                                        Accept Parameters
TEST  *    DISPLAY 'Submit Auftragsnummer:'
TEST  *    ACCEPT  P-AUFTRAGSNR.
TEST  *    DISPLAY 'Submit Kundennummer:'
TEST  *    ACCEPT  P-KUNDENNR.
TEST  *    DISPLAY 'Submit Versanddatum:'
TEST  *    ACCEPT  P-DATUM
TEST  *    DISPLAY 'Submit Versandweg: '
TEST  *    ACCEPT  P-VERSANDWEG
TEST  *    DISPLAY 'Submit Versandposten File Name:'
TEST  *    ACCEPT  P-FILENAME.
           MOVE ZERO TO P-VERSANDNR.
       OPEN-VERSANDPOSTEN.
      *                                        Open Versanddatei
           MOVE P-FILENAME TO INPUT-FILE.
           MOVE ZEROS TO INPUT-STAT.
           OPEN INPUT VERSANDPOSTEN.
           IF INPUT-STAT NOT = ZEROES
      *       DISPLAY 'Versandposten Datei nicht gefunden !!'
      *       DISPLAY 'Press Enter to Terminate '
      *       ACCEPT STOP-KEY
              MOVE 5 TO VERSAND-RETCODE
              GOBACK
           END-IF.
       OPEN-KUNDEN.
      *                                        Open Versanddatei
           MOVE ZEROS TO IXS-FSTS.
           OPEN INPUT KUNDEN.
           IF IXS-FSTS NOT = ZEROES
      *       DISPLAY 'Kundendatei konnte nicht eroeffnet werden !!'
      *       DISPLAY 'Press Enter to Terminate '
      *       ACCEPT STOP-KEY
              MOVE 6 TO VERSAND-RETCODE
              GOBACK
           END-IF.
       FIND-FIRST-KUNDE.
      *                                        Lese erste Kunde
           MOVE P-KUNDENNR TO KUNDENNR IN KUNDENSATZ.
           READ KUNDEN
           INVALID KEY
      *       DISPLAY 'Kunde konnte nicht gefunden werden !!'
      *       DISPLAY 'Kundennummer: ' P-KUNDENNR
      *       DISPLAY 'Press Enter to Terminate '
      *       ACCEPT STOP-KEY
              MOVE 7 TO VERSAND-RETCODE
              GOBACK
           END-READ.
       OPEN-VERSAND-LISTE.
      *                                        Open Versandliste
           MOVE ZEROS TO OUTPUT-STAT.
           OPEN OUTPUT VERSANDLISTE.
      *
       INIT-VERSANDPOSTEN.
      *                                        Lese Versandposten
           MOVE ZEROES TO INPUT-STAT.
           PERFORM UNTIL INPUT-STAT NOT = ZEROES
                      OR KUNDENNR IN VERSANDPOST =
                         KUNDENNR IN KUNDENSATZ
              READ VERSANDPOSTEN
              AT END
                 MOVE '09' TO INPUT-STAT
              NOT AT END
                 MOVE ZERO TO VERSAND-RETCODE
              END-READ
           END-PERFORM.
           IF KUNDENNR IN VERSANDPOST =
              KUNDENNR IN KUNDENSATZ
              PERFORM WRITE-KOPF
           END-IF.
      *
       PROCESS-VERSANDPOSTEN.
      *                                        Lese Versandposten
           MOVE ZEROES TO INPUT-STAT.
           PERFORM UNTIL INPUT-STAT NOT = ZEROES
              READ VERSANDPOSTEN
              AT END
                 MOVE '09' TO INPUT-STAT
              NOT AT END
                 MOVE ZERO TO VERSAND-RETCODE
                 IF KUNDENNR IN VERSANDPOST NOT =
                    KUNDENNR IN KUNDENSATZ
      *                                        Wechsele Kunden
                    PERFORM WRITE-FUSS
                    MOVE KUNDENNR IN VERSANDPOST TO
                         KUNDENNR IN KUNDENSATZ
                    READ KUNDEN
                    INVALID KEY
      *                DISPLAY 'Kunde konnte nicht gefunden werden !!'
      *                DISPLAY 'Kundennummer: ' KUNDENNR IN KUNDENSATZ
      *                DISPLAY 'Press Enter to Continue  '
      *                ACCEPT STOP-KEY
                       MOVE 7 TO VERSAND-RETCODE
                    END-READ
                    PERFORM WRITE-KOPF
                 END-IF
                 PERFORM WRITE-VERSANDPOST
                 ADD 1 TO P-VERSANDNR
              END-READ
           END-PERFORM.
       CLOSE-VERSANDBEARBEITUNG.
      *                                        Lese Versandposten
           PERFORM WRITE-FUSS.
           CLOSE KUNDEN.
           CLOSE VERSANDPOSTEN.
      *    DISPLAY ' Versandauftraege sind bearbeitet '.
      *    DISPLAY ' Versandauftraege = ' P-VERSANDNR
      *    DISPLAY ' Press Enter to Terminate !'
      *    ACCEPT STOP-KEY
           GOBACK.
      ******************************************************************
       VERSANDLISTE-AUSGABE SECTION.
      **                                          Schreibe Kopfzeilen
       WRITE-KOPF.
           MOVE '/' TO VERSANDZEILE.
           WRITE VERSANDZEILE AFTER PAGE.
           MOVE SEP-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE BLANK-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE HEAD-LINE-1 TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE BLANK-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE P-DATUM TO DATUM-AUS
           MOVE HEAD-LINE-2 TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE BLANK-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE KUNDENNAME TO KUNDENNAME-AUS
           MOVE HEAD-LINE-3 TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE STRASSE TO STRASSE-AUS
           MOVE HEAD-LINE-4 TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE POSTLEITZAHL TO POSTLEITZAHL-AUS.
           MOVE ORT TO ORT-AUS.
           MOVE HEAD-LINE-5 TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE LAND TO LAND-AUS.
           MOVE HEAD-LINE-6 TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE BLANK-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE HEAD-LINE-7 TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE SEP-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
      **                                          Schreibe Versandzeile
       WRITE-VERSANDPOST.
           MOVE BLANK-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE AUFTRAGSNR   IN VERSANDPOST TO  AUFTRAGSNR-AUS
           MOVE KUNDENNR     IN VERSANDPOST TO  KUNDENNR-AUS
           MOVE ARTIKELNR    IN VERSANDPOST TO  ARTIKELNR-AUS
           MOVE ARTIKELNAME  IN VERSANDPOST TO  ARTIKELNAME-AUS
           MOVE BESTELLMENGE IN VERSANDPOST TO  BESTELLMENGE-AUS
           MOVE DATA-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
      **                                          Schreibe Fusszeile
       WRITE-FUSS.
           MOVE BLANK-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE SEP-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE P-VERSANDWEG TO VERSANDWEG-AUS.
           MOVE FOOT-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
           MOVE SEP-LINE TO VERSANDZEILE.
           WRITE VERSANDZEILE.
