      $SET ANS85
       IDENTIFICATION DIVISION.
       PROGRAM-ID. RECHNUNG.
      ******************************************************************
      *  PROGRAM NAME: RECHNUNG                                        *
      *  SYSTEM  NAME: AUFTRAG = AUFTRAGBEARBEITUNG                    *
      *  PURPOSE:      subprogram for producing the invoice            *
      *  VERSION:      1.1 (07.96)                                     *
      *  LANGUAGE:     MICROSOFT (R) COBOL OPTIMIZIG COMPILER          *
      *                VERSION 3.00A ("MICROFOCUS COBOL")              *
      ******************************************************************
      *  PROGRAM FUNCTIONS:                                            *
      *    - init Rechnungen                                           *
      *    - open Rechnungsposten                                      *
      *    - Do for each Rechnungsposten                               *
      *      - If neuer Kunde                                          *
      *        - write Rechnungsfuss                                   *
      *      - If Kundenende                                           *
      *        - write Rechnungskopf                                   *
      *      - write Rechnungsposten                                   *
      *    - Enddo                                                     *
      *    - close Rechnungen                                          *
      ******************************************************************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. IBM-PC.
       OBJECT-COMPUTER. IBM-PC.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *   Datei der Rechnungsposten
          SELECT RECHNUNGSPOSTENDATEI ASSIGN TO 'RECHPOST.dat'
                 ORGANIZATION IS LINE SEQUENTIAL.
      *   Liste der Rechnungen
          SELECT RECHNUNGSDATEI ASSIGN TO 'BILLING.txt'
                 ORGANIZATION IS LINE SEQUENTIAL.
      ******************************************************************
      *
       DATA DIVISION.
      *
      ******************************************************************
      *
       FILE SECTION.
      *
      ******************************************************************
      *
      *   Datei der Rechnungsposten
       FD  RECHNUNGSPOSTENDATEI
           DATA RECORDS ARE RECHNUNGSKOPF,
                            RECHNUNGSPOSTEN,
                            RECHNUNGSFUSS.
WRAP   01  RECHNUNGSKOPF-REC    PIC X(80).
WRAP  * ****  Record removed ****
WRAP   01  RECHNUNGSPOSTEN-REC    PIC X(80).
WRAP  * ****  Record removed ****
WRAP   01  RECHNUNGSFUSS-REC    PIC X(80).
WRAP  * ****  Record removed ****
       FD  RECHNUNGSDATEI
           DATA RECORD IS RECHNUNGSSATZ.
       01  RECHNUNGSSATZ.
           05  RECHNUNGSZEILE                PIC X(72).
      *
      ******************************************************************
      *
       WORKING-STORAGE SECTION.
      *
      ******************************************************************
      *
       77  RECHNUNGSPOSTEN-STATUS            PIC XX.
           88  OK-RECNUNGSPOSTEN             VALUE ZERO.
           88  EOF-RECHNUNGSPOSTEN           VALUE '09'.
       77  CONTINUE-KEY                      PIC XX.
       01  LISTENKONSTANTEN.
           05  ZEILEN-MAX                    PIC 99  VALUE 72.
           05  SEITEN-MAX                    PIC 99  VALUE 99.
       01  LISTENVARIABELN.
           05  TAGESDATUM.
               10  JAHR                      PIC 99.
               10  MONAT                     PIC 99.
               10  TAG                       PIC 99.
           05  LISTENDATUM.
               10  LISTENTAG                 PIC 99.
               10  FILLER                    PIC X   VALUE '/'.
               10  LISTENMONAT               PIC 99.
               10  FILLER                    PIC X   VALUE '/'.
               10  LISTENJAHR                PIC 99.
           05  SEITENNR                      PIC 999 VALUE 1.
           05  ZEILENANZAHL                  PIC 99  VALUE 73.
           05  LETZTE-AUFTRAGNR              PIC 9(6) VALUE ZEROES.
           05  LETZTE-KUNDENNR               PIC 9(6) VALUE ZEROES.
       01  RECHNUNGSKONSTANTEN.
           05  ZAHLUNGSMODUS-1               PIC X(30) VALUE
              'Zahlung durch Ueberweisung'.
           05  ZAHLUNGSMODUS-2               PIC X(30) VALUE
              'Zahlung durch Scheck      '.
           05  ZAHLUNGSMODUS-3               PIC X(30) VALUE
              'Zahlung durch Bar         '.
           05  ZAHLUNGSMODUS-4               PIC X(30) VALUE
              'Zahlung im Voraus         '.
           05  RECHNUNGSPROGRAM              PIC X(10) VALUE 'Rechnung'.
           05  MWST-SATZ                     PIC 9V99    VALUE 0.16.
       01  RECHNUNGSKOPFE.
           05  KOPFZEILE-1.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  KOPFZEILE-2.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(70) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  KOPFZEILE-3.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(2)  VALUE SPACES.
               10  FILLER                    PIC X(8) VALUE 'TITEL:  '.
               10  KOPFZEILE-TITEL           PIC X(42).
               10  FILLER                    PIC X(8) VALUE 'SEITE:  '.
               10  KOPFZEILE-SEITE           PIC 9(4).
               10  FILLER                    PIC X(6) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  KOPFZEILE-4.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(2)  VALUE SPACES.
               10  FILLER                    PIC X(8) VALUE 'QUELLE: '.
               10  KOPFZEILE-PROGRAM         PIC X(42).
               10  KOPFZEILE-4-4             PIC X(8) VALUE 'DATUM:  '.
               10  KOPFZEILE-DATUM           PIC X(8).
               10  FILLER                    PIC X(2) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  TITELZEILE-7                  PIC X(72).
           05  TITELZEILE-8.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  FUSSZEILE-1.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  FUSSZEILE-2                   PIC X(72).
           05  FUSSZEILE-3                   PIC X(72).
           05  FUSSZEILE-4                   PIC X(72).
       01  RECHNUNGSVARIABELN.
           05  RECH-NR                       PIC 9(4) VALUE ZERO.
           05  RECH-POSTEN-NR                PIC 99 VALUE ZERO.
           05  MWST                          PIC 9999V99.
           05  GESAMTBETRAG                  PIC 999999V99.
           05  RECHENWERTE.
               10  STUECKPREIS               PIC 999V99 VALUE ZERO.
               10  GESAMTPREIS               PIC 99999V99 VALUE ZERO.
               10  RECHNUNGSBETRAG           PIC 9999999V99 VALUE ZERO.
               10  RECHNUNGSANZAHL           PIC 999 VALUE ZERO.
               10  BESTELLUNGEN              PIC 999 VALUE ZERO.
               10  GESAMT-RECHNUNGSBETRAG    PIC 9999999V99 VALUE ZERO.
       01  RECHNUNGSTITEL.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(70) VALUE
           '  Rechnung der Universitt Regensburg              '.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSKOPF-1.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(14) VALUE
                                            'Rechnungsnr:  '.
           05  RECHNUNGSKOPF-RECHNR          PIC X(8).
           05  FILLER                        PIC X(14) VALUE
                                            '  Auftragsnr: '.
           05  RECHNUNGSKOPF-AUFTRAGNR       PIC X(8).
           05  FILLER                        PIC X(14) VALUE
                                            '  Kundenkz:   '.
           05  RECHNUNGSKOPF-KUNDENKZ        PIC ZZZZZZ99.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSKOPF-2.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(6)  VALUE SPACES.
           05  FILLER                        PIC X(14) VALUE
                                            'Kundenname:   '.
           05  RECHNUNGSKOPF-KUNDENNAME      PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSKOPF-3.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE
                                            'Kundenanschrift:  '.
           05  RECHNUNGSKOPF-STRASSE         PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSKOPF-4.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE SPACES.
           05  RECHNUNGSKOPF-LAND            PIC X(4).
           05  RECHNUNGSKOPF-PLZ             PIC X(6).
           05  RECHNUNGSKOPF-ORT             PIC X(30).
           05  FILLER                        PIC X(10) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSKOPF-5.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE
                                            'Zahlungsmodus:    '.
           05  RECHNUNGSKOPF-ZAHLUNGSMODUS   PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSPOSTENTITEL.
           05  FILLER                        PIC X    VALUE '|'.
           05  FILLER                        PIC X(9) VALUE 'Bestellnr'.
           05  FILLER                        PIC X    VALUE SPACES.
           05  FILLER                        PIC X(9) VALUE 'Artikelnr'.
           05  FILLER                        PIC X    VALUE SPACES.
           05  FILLER                        PIC X(20) VALUE
              ' Artikelbezeichnung '.
           05  FILLER                        PIC X(7) VALUE SPACES.
           05  FILLER                        PIC X(5) VALUE 'Menge'.
           05  FILLER                        PIC XX   VALUE SPACES.
           05  FILLER                        PIC X(5) VALUE 'Preis'.
           05  FILLER                        PIC XXX  VALUE SPACES.
           05  FILLER                        PIC X(5) VALUE 'Summe'.
           05  FILLER                        PIC XXX  VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSPOSTENZEILE.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  RECHNUNGSZEILE-BESTELLNR      PIC X(6).
           05  FILLER                        PIC X(2) VALUE SPACES.
           05  RECHNUNGSZEILE-ARTIKELNR      PIC X(6).
           05  FILLER                        PIC X(2) VALUE SPACES.
           05  RECHNUNGSZEILE-ARTIKELNAME    PIC X(20).
           05  FILLER                        PIC X(6) VALUE SPACES.
           05  RECHNUNGSZEILE-BESTELLMENGE   PIC ZZZZZ9.
           05  FILLER                        PIC X(2) VALUE SPACES.
           05  RECHNUNGSZEILE-STUECKPREIS    PIC ZZZ9.99.
           05  FILLER                        PIC X(2) VALUE SPACES.
           05  RECHNUNGSZEILE-GESAMTPREIS    PIC Z,ZZ9.99.
           05  FILLER                        PIC X    VALUE SPACE.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSFUSS-1.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(14) VALUE
                                            'Rechnungszahl:'.
           05  RECHNUNGSFUSS-RECHNUNGEN      PIC ZZZ9.
           05  FILLER                        PIC X     VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE
                                            'Bestellungsanzahl:'.
           05  RECHNUNGSFUSS-BESTELLUNGEN    PIC ZZZ9.
           05  FILLER                        PIC X     VALUE SPACES.
           05  FILLER                        PIC X(16) VALUE
                                            'Rechnungsbetrag:'.
           05  RECHNUNGSFUSS-GESAMTBETRAG    PIC ZZ,ZZ9.99.
           05  FILLER                        PIC X     VALUE SPACE.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSFUSS-2.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(20) VALUE
                                            'Mehrwertsteuersatz: '.
           05  RECHNUNGSFUSS-MWST-SATZ       PIC Z.99.
           05  FILLER                        PIC X     VALUE '%'.
           05  FILLER                        PIC X(17) VALUE SPACES.
           05  FILLER                        PIC X(16) VALUE
                                            'Mehrwertsteuer: '.
           05  RECHNUNGSFUSS-MWST            PIC ZZ,ZZ9.99.
           05  FILLER                        PIC X     VALUE SPACE.
           05  FILLER                        PIC X     VALUE '|'.
       01  RECHNUNGSFUSS-3.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(52) VALUE
               'Folgender Betrag ist innerhalb 30 Tage zu bezahlen: '.
           05  FILLER                        PIC X(5)  VALUE SPACES.
           05  RECHNUNGSFUSS-GESAMT          PIC ZZZ,ZZ9.99.
           05  FILLER                        PIC X     VALUE SPACE.
           05  FILLER                        PIC X     VALUE '|'.
       01  FEHLERZEILE.
           05  FILLER                        PIC X     VALUE '|'.
           05  FEHLERMELDUNG                 PIC X(70).
           05  FILLER                        PIC X     VALUE '|'.
       01  FEHLERMELDUNGEN.
           05  FM-1                          PIC X(50) VALUE
              '   Rechnungsdaten sind fehlerhaft               '.
           05  FM-2                          PIC X(50) VALUE
              '   Anzahl Rechnungsposten stimmt nicht ueberein '.
           05  FM-3                          PIC X(50) VALUE
              '   Rechnung muss per Hand erstellt werden       '.
      ************************************************************
      ************************************************************
      *********** COBWRAP XML  parameters ***********************
XMLINS 01 XML-PARAMS.
          05  XML-FUNCODE              PIC XX.
          05  XML-RETCODE              PIC 99.
          05  XML-FILNAME              PIC X(8).
COBINS 01 X-COBOL-PARAMS.
          05  X-REC-LNG                PIC 999.
          05  X-MAP-LNG                PIC 999.
          05  X-ACCEPT-LNG             PIC 999.
          05  X-DISPLAY-LNG            PIC 999.
          05  X-ACCEPT-TEXT            PIC X(80).
          05  X-DISPLAY-TEXT           PIC X(80).
      ***********************************************************
WRAP       COPY RECHNUNG.cpy.
       PROCEDURE DIVISION.
      *****************************************************
       RECHNUNGSSTEUERUNG SECTION.
      *****************************************************
       INIT-RECHNUNG.
           MOVE 'Auftragsrechnung ' TO KOPFZEILE-TITEL.
           MOVE 'Auftragsbearbeitung ' TO KOPFZEILE-PROGRAM.
           MOVE RECHNUNGSTITEL TO TITELZEILE-7.
           PERFORM OPEN-LISTE.
           EXIT.
      *****************************************************
       OPEN-RECHNUNGSPOSTEN.
           MOVE ZEROES TO RECHNUNGSPOSTEN-STATUS.
WRAP  *    OPEN INPUT RECHNUNGSPOSTENDATEI.
           IF RECHNUNGSPOSTEN-STATUS NOT = ZEROES
              DISPLAY 'RECHNUNGSPOSTENDATEI not found'
              DISPLAY 'Press Enter to terminate !'
              ACCEPT  CONTINUE-KEY
              GOBACK
           END-IF.
      *****************************************************
       READ-RECHNUNGSPOSTEN.
           MOVE ZEROES TO RECHNUNGSPOSTEN-STATUS.
           PERFORM UNTIL EOF-RECHNUNGSPOSTEN
WRAP  *       READ RECHNUNGSPOSTENDATEI
WRAP  *       AT END MOVE '09' TO RECHNUNGSPOSTEN-STATUS
WRAP       MOVE 'RD' TO XML-FUNCODE
WRAP       MOVE ZEROES TO XML-RETCODE
WRAP       MOVE 'RECHNUNG' TO XML-FILNAME
WRAP       MOVE 2048 TO X-REC-LNG
WRAP       CALL 'RECHNUNG' USING XML-FUNCODE, XML-RETCODE, XML-FILNAME,
WRAP                             RECHNUNGSKOPF,
WRAP                             X-REC-LNG
WRAP       IF XML-RETCODE NOT = ZEROES
                     MOVE '09' TO RECHNUNGSPOSTEN-STATUS
              ELSE
                  EVALUATE SATZKZ
                     WHEN 'RK'
                        PERFORM DRUCKE-RECHNUNGSKOPF
                     WHEN 'RP'
                        PERFORM DRUCKE-RECHNUNGSPOSTEN
                     WHEN 'RF'
                        PERFORM DRUCKE-RECHNUNGSFUSS
                     WHEN OTHER
                        DISPLAY 'Ungltige Rechnungssatzart=' SATZKZ
                        DISPLAY 'Press Enter to acknowledge!'
                        ACCEPT  CONTINUE-KEY
                  END-EVALUATE
WRAP       END-IF
              MOVE AUFTRAGNR TO LETZTE-AUFTRAGNR
              MOVE KUNDENNR  TO LETZTE-KUNDENNR
           END-PERFORM.
           EXIT.
      *****************************************************
       CLOSE-RECHNUNGSPOSTEN.
WRAP  *    CLOSE RECHNUNGSPOSTENDATEI
           GOBACK.
      *****************************************************************
      *****************************************************************
       RECHNUNGSAUSGABE   SECTION.
      *****************************************************
       DRUCKE-RECHNUNGSKOPF.
           ADD  1 TO RECH-NR
           MOVE RECH-NR TO RECHNUNGSKOPF-RECHNR
           MOVE AUFTRAGNR TO RECHNUNGSKOPF-AUFTRAGNR
           MOVE KUNDENNR TO RECHNUNGSKOPF-KUNDENKZ
           MOVE KUNDENNAME TO  RECHNUNGSKOPF-KUNDENNAME
           MOVE KUNDEN-PLZ TO  RECHNUNGSKOPF-PLZ
           MOVE KUNDEN-ORT TO  RECHNUNGSKOPF-ORT
           MOVE KUNDEN-STRASSE TO  RECHNUNGSKOPF-STRASSE
           MOVE KUNDEN-LAND TO  RECHNUNGSKOPF-LAND
           EVALUATE KUNDENBONITAET
               WHEN 3
                   MOVE ZAHLUNGSMODUS-1 TO RECHNUNGSKOPF-ZAHLUNGSMODUS
               WHEN 2
                   MOVE ZAHLUNGSMODUS-2 TO RECHNUNGSKOPF-ZAHLUNGSMODUS
               WHEN 1
                   MOVE ZAHLUNGSMODUS-3 TO RECHNUNGSKOPF-ZAHLUNGSMODUS
               WHEN OTHER
                   MOVE ZAHLUNGSMODUS-4 TO RECHNUNGSKOPF-ZAHLUNGSMODUS
           END-EVALUATE
           PERFORM PRINT-HEADER
           MOVE ZEROES TO RECHENWERTE
           MOVE ZERO TO RECH-POSTEN-NR.
      *****************************************************
       DRUCKE-RECHNUNGSPOSTEN.
           IF  AUFTRAGNR = LETZTE-AUFTRAGNR
           AND KUNDENNR = LETZTE-KUNDENNR
              ADD 1 TO RECH-POSTEN-NR
              MOVE BESTELLNR TO RECHNUNGSZEILE-BESTELLNR
              MOVE ARTIKELNR TO RECHNUNGSZEILE-ARTIKELNR
              MOVE ARTIKELNAME TO RECHNUNGSZEILE-ARTIKELNAME
              MOVE ARTIKELPREIS TO STUECKPREIS
              MOVE BESTELLMENGE TO RECHNUNGSZEILE-BESTELLMENGE
              COMPUTE GESAMTPREIS = BESTELLMENGE
                                  * STUECKPREIS
              MOVE STUECKPREIS TO RECHNUNGSZEILE-STUECKPREIS
              MOVE GESAMTPREIS TO RECHNUNGSZEILE-GESAMTPREIS
              ADD  GESAMTPREIS TO RECHNUNGSBETRAG
              MOVE RECHNUNGSPOSTENZEILE TO RECHNUNGSZEILE
              PERFORM PRINT-LINE
           END-IF.
      *****************************************************
       DRUCKE-RECHNUNGSFUSS.
           IF RECH-POSTEN-NR = RECHPOST-RF
              ADD 1 TO RECHNUNGSANZAHL
              ADD RECH-POSTEN-NR TO BESTELLUNGEN
              ADD RECHNUNGSBETRAG TO GESAMT-RECHNUNGSBETRAG
              MOVE RECHNUNGSANZAHL TO RECHNUNGSFUSS-RECHNUNGEN
              MOVE BESTELLUNGEN    TO RECHNUNGSFUSS-BESTELLUNGEN
              MOVE GESAMT-RECHNUNGSBETRAG TO RECHNUNGSFUSS-GESAMTBETRAG
              MOVE MWST-SATZ TO RECHNUNGSFUSS-MWST-SATZ
              COMPUTE MWST = RECHNUNGSBETRAG * MWST-SATZ
              MOVE MWST TO RECHNUNGSFUSS-MWST
              COMPUTE GESAMTBETRAG = RECHNUNGSBETRAG + MWST
              MOVE GESAMTBETRAG TO RECHNUNGSFUSS-GESAMT
              MOVE RECHNUNGSFUSS-1 TO FUSSZEILE-2
              MOVE RECHNUNGSFUSS-2 TO FUSSZEILE-3
              MOVE RECHNUNGSFUSS-3 TO FUSSZEILE-4
           ELSE
              MOVE FM-1 TO FEHLERMELDUNG
              MOVE FEHLERZEILE TO FUSSZEILE-2
              MOVE FM-2 TO FEHLERMELDUNG
              MOVE FEHLERZEILE TO FUSSZEILE-3
              MOVE FM-3 TO FEHLERMELDUNG
              MOVE FEHLERZEILE TO FUSSZEILE-4
           END-IF.
           PERFORM PRINT-FOOTING
           PERFORM PAGE-CHANGE.
           EXIT.
      *****************************************************************
      *****************************************************************
       SUBROUTINES SECTION.
      *****************************************************
       OPEN-LISTE.
           OPEN OUTPUT RECHNUNGSDATEI.
           ACCEPT TAGESDATUM FROM DATE.
           MOVE TAG TO LISTENTAG.
           MOVE MONAT TO LISTENMONAT.
           MOVE JAHR TO LISTENJAHR.
           MOVE LISTENDATUM TO KOPFZEILE-DATUM.
           MOVE SEITENNR TO KOPFZEILE-SEITE.
           MOVE RECHNUNGSPROGRAM TO KOPFZEILE-PROGRAM
           MOVE RECHNUNGSTITEL TO TITELZEILE-7
           EXIT.
      *****************************************************
       PRINT-HEADER.
           MOVE SEITENNR TO KOPFZEILE-SEITE
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-1
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-2
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-3
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-4
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-2
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-1
           WRITE RECHNUNGSSATZ FROM TITELZEILE-7
           WRITE RECHNUNGSSATZ FROM TITELZEILE-8
           WRITE RECHNUNGSSATZ FROM RECHNUNGSKOPF-1
           WRITE RECHNUNGSSATZ FROM RECHNUNGSKOPF-2
           WRITE RECHNUNGSSATZ FROM RECHNUNGSKOPF-3
           WRITE RECHNUNGSSATZ FROM RECHNUNGSKOPF-4
           WRITE RECHNUNGSSATZ FROM RECHNUNGSKOPF-5
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-1
           WRITE RECHNUNGSSATZ FROM RECHNUNGSPOSTENTITEL
           WRITE RECHNUNGSSATZ FROM KOPFZEILE-1
           MOVE 16 TO ZEILENANZAHL
           ADD 1 TO SEITENNR.
           EXIT.
      *****************************************************
       PRINT-LINE.
           MOVE RECHNUNGSPOSTENZEILE TO RECHNUNGSZEILE.
           WRITE RECHNUNGSSATZ.
           ADD 1 TO ZEILENANZAHL
           EXIT.
      *****************************************************
       PRINT-FOOTING.
           WRITE RECHNUNGSSATZ FROM FUSSZEILE-1
           WRITE RECHNUNGSSATZ FROM FUSSZEILE-2
           WRITE RECHNUNGSSATZ FROM FUSSZEILE-3
           WRITE RECHNUNGSSATZ FROM FUSSZEILE-4
           WRITE RECHNUNGSSATZ FROM FUSSZEILE-1
           ADD 5 TO ZEILENANZAHL
           EXIT.
      *****************************************************
       PAGE-CHANGE.
           MOVE SPACES TO RECHNUNGSSATZ
           MOVE  '/' TO RECHNUNGSSATZ
           WRITE RECHNUNGSSATZ AFTER PAGE.
           EXIT.
      * end of source
      ******************************************************************
