      $SET ANS85
       IDENTIFICATION DIVISION.
       PROGRAM-ID. VERSAND.
      ******************************************************************
      *  PROGRAM NAME: VERSAND                                         *
      *  SYSTEM  NAME: AUFTRAG = AUFTRAGBEARBEITUNG                    *
      *  PURPOSE:      subprogram for producing the dispath notices    *
      *  VERSION:      1.1 (07.96)                                     *
      *  LANGUAGE:     MICROSOFT (R) COBOL OPTIMIZIG COMPILER          *
      *                VERSION 3.00A ("MICROFOCUS COBOL")              *
      *  PROGRAM FUNCTIONS:                                            *
      ******************************************************************
      *    - init  Versandauftraege                                    *
      *    - open  Versandposten                                       *
      *    - Do for each Versandposten                                 *
      *      - read Versandposten                                      *
      *      - if Kundenende                                           *
      *           - write Versandfuss                                  *
      *      - if neuer Kunde                                          *
      *           - write Versandkopf                                  *
      *      - write Versandposten                                     *
      *    - Enddo                                                     *
      *    - close Versandposten                                       *
      *    - close Versandauftraege                                    *
      ******************************************************************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. IBM-PC.
       OBJECT-COMPUTER. IBM-PC.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *   Datei der Versandposten
          SELECT VERSANDPOSTENDATEI ASSIGN TO 'VERSAND.dat'
                 ORGANIZATION IS LINE SEQUENTIAL.
      *   Liste der Versandauftraege
          SELECT VERSANDDATEI ASSIGN TO 'DISPATCH.txt'
                 ORGANIZATION IS LINE SEQUENTIAL.
      ******************************************************************
      *
       DATA DIVISION.
      *
      ******************************************************************
      *
       FILE SECTION.
      *
      ******************************************************************
      *
      *   Datei der Versandposten
       FD  VERSANDPOSTENDATEI
           RECORD CONTAINS 80 CHARACTERS
           DATA RECORDS ARE VERSANDKOPF,
                            VERSANDPOSTEN,
                            VERSANDFUSS.
       01  VERSANDKOPF.
           05  SATZKZ                        PIC XX.
           05  AUFTRAGNR                     PIC 9(6).
           05  KUNDENNR                      PIC 9(6).
           05  KUNDENVERSAND                 PIC 99.
               88  LUFT                      VALUE 3.
               88  BAHN                      VALUE 2.
               88  SCHIFF                    VALUE 1.
               88  LKW                       VALUE 0.
           05  KUNDENDATEN.
               10  KUNDENNAME                PIC X(30).
               10  KUNDENANSCHRIFT.
                   15  KUNDEN-LAND           PIC XXXX.
                   15  KUNDEN-PLZ            PIC 9(5).
                   15  KUNDEN-ORT            PIC X(20).
                   15  KUNDEN-STRASSE        PIC X(20).
       01  VERSANDPOSTEN.
           05  SATZKZ-VP                     PIC XX.
           05  AUFTRAGNR-VP                  PIC 9(6).
           05  KUNDENNR-VP                   PIC 9(6).
           05  BESTELLNR                     PIC 99.
           05  ARTIKELNR                     PIC 9(6).
           05  ARTIKELNAME                   PIC X(20).
           05  BESTELLMENGE                  PIC 9999.
       01  VERSANDFUSS.
           05  SATZKZ-VF                     PIC XX.
           05  AUFTRAGNR-VF                  PIC 9(6).
           05  KUNDENNR-VF                   PIC 9(6).
           05  VERSANDPOST-VF                PIC 99.
      *
      *   Liste der Versandauftraege
       FD  VERSANDDATEI
           RECORD CONTAINS 72 CHARACTERS
           DATA RECORD IS VERSANDSATZ.
       01  VERSANDSATZ.
           05  VERSANDZEILE                  PIC X(72).
      *
      ******************************************************************
      *
       WORKING-STORAGE SECTION.
      *
      ******************************************************************
      *
       77  VERSANDPOSTEN-STATUS              PIC XX.
           88  OK-VERSANDPOSTEN              VALUE ZERO.
           88  EOF-VERSANDPOSTEN             VALUE '09'.
       77  CONTINUE-KEY                      PIC XX.
       01  LISTENKONSTANTEN.
           05  ZEILEN-MAX                    PIC 99  VALUE 72.
           05  SEITEN-MAX                    PIC 99  VALUE 99.
       01  LISTENVARIABELN.
           05  TAGESDATUM.
               10  JAHR                      PIC 99.
               10  MONAT                     PIC 99.
               10  TAG                       PIC 99.
           05  LISTENDATUM.
               10  LISTENTAG                 PIC 99.
               10  FILLER                    PIC X   VALUE '/'.
               10  LISTENMONAT               PIC 99.
               10  FILLER                    PIC X   VALUE '/'.
               10  LISTENJAHR                PIC 99.
           05  SEITENNR                      PIC 999 VALUE 1.
           05  ZEILENANZAHL                  PIC 99  VALUE 73.
           05  LETZTE-AUFTRAGNR              PIC 9(6) VALUE ZEROES.
           05  LETZTE-KUNDENNR               PIC 9(6) VALUE ZEROES.
       01  VERSANDKONSTANTEN.
           05  VERSANDMODUS-1                PIC X(30) VALUE
              'Lufttransport             '.
           05  VERSANDMODUS-2                PIC X(30) VALUE
              'Bahntransport             '.
           05  VERSANDMODUS-3                PIC X(30) VALUE
              'Schifftransport           '.
           05  VERSANDMODUS-4                PIC X(30) VALUE
              'LKW-Transport             '.
           05  VERSANDPROGRAM              PIC X(10) VALUE 'Versand '.
       01  VERSANDKOPFZEILEN.
           05  KOPFZEILE-1.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  KOPFZEILE-2.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(70) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  KOPFZEILE-3.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(2)  VALUE SPACES.
               10  FILLER                    PIC X(8) VALUE 'TITEL:  '.
               10  KOPFZEILE-TITEL           PIC X(42).
               10  FILLER                    PIC X(8) VALUE 'SEITE:  '.
               10  KOPFZEILE-SEITE           PIC 9(4).
               10  FILLER                    PIC X(6) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  KOPFZEILE-4.
               10  FILLER                    PIC X     VALUE '|'.
               10  FILLER                    PIC X(2)  VALUE SPACES.
               10  FILLER                    PIC X(8) VALUE 'QUELLE: '.
               10  KOPFZEILE-PROGRAM         PIC X(42).
               10  KOPFZEILE-4-4             PIC X(8) VALUE 'DATUM:  '.
               10  KOPFZEILE-DATUM           PIC X(8).
               10  FILLER                    PIC X(2) VALUE SPACES.
               10  FILLER                    PIC X     VALUE '|'.
           05  TITELZEILE-7                  PIC X(72).
           05  TITELZEILE-8.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  FUSSZEILE-1.
               10  FILLER                    PIC X     VALUE '+'.
               10  FILLER                    PIC X(70) VALUE ALL '-'.
               10  FILLER                    PIC X     VALUE '+'.
           05  FUSSZEILE-2                   PIC X(72).
           05  FUSSZEILE-3                   PIC X(72).
           05  FUSSZEILE-4                   PIC X(72).
       01  VERSANDVARIABELN.
           05  GESAMTMENGE                   PIC 9(5) VALUE ZERO.
           05  VERSAND-NR                    PIC 9(4) VALUE ZERO.
           05  VERSAND-POSTEN-NR             PIC 99 VALUE ZERO.
       01  VERSANDTITEL.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(70) VALUE
           '  Versandauftrag der Universitt Regensburg        '.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDKOPF-1.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(14) VALUE
                                            'Versandauftnr:'.
           05  VERSANDKOPF-RECHNR            PIC X(8).
           05  FILLER                        PIC X(14) VALUE
                                            '  Auftragsnr: '.
           05  VERSANDKOPF-AUFTRAGNR         PIC X(8).
           05  FILLER                        PIC X(14) VALUE
                                            '  Kundenkz:   '.
           05  VERSANDKOPF-KUNDENKZ          PIC ZZZZZZ99.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDKOPF-2.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(6)  VALUE SPACES.
           05  FILLER                        PIC X(14) VALUE
                                            'Kundenname:   '.
           05  VERSANDKOPF-KUNDENNAME        PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDKOPF-3.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE
                                            'Kundenanschrift:  '.
           05  VERSANDKOPF-STRASSE           PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDKOPF-4.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE SPACES.
           05  VERSANDKOPF-LAND              PIC X(4).
           05  VERSANDKOPF-PLZ               PIC X(6).
           05  VERSANDKOPF-ORT               PIC X(30).
           05  FILLER                        PIC X(10) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDKOPF-5.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(18) VALUE
                                            'Versandmodus:     '.
           05  VERSANDKOPF-VERSANDMODUS      PIC X(30).
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDPOSTENTITEL.
           05  FILLER                        PIC X    VALUE '|'.
           05  FILLER                        PIC X(9) VALUE 'Bestellnr'.
           05  FILLER                        PIC X    VALUE SPACES.
           05  FILLER                        PIC X(9) VALUE 'Artikelnr'.
           05  FILLER                        PIC X    VALUE SPACES.
           05  FILLER                        PIC X(20) VALUE
              ' Artikelbezeichnung '.
           05  FILLER                        PIC X(7)  VALUE SPACES.
           05  FILLER                        PIC X(5)  VALUE 'Menge'.
           05  FILLER                        PIC X(18) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDPOSTENZEILE.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  VERSANDZEILE-BESTELLNR        PIC X(6).
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  VERSANDZEILE-ARTIKELNR        PIC X(6).
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  VERSANDZEILE-ARTIKELNAME      PIC X(20).
           05  FILLER                        PIC X(6)  VALUE SPACES.
           05  VERSANDZEILE-BESTELLMENGE     PIC ZZZZZ9.
           05  FILLER                        PIC X(20) VALUE SPACES.
           05  FILLER                        PIC X     VALUE '|'.
       01  VERSANDFUSS-1.
           05  FILLER                        PIC X     VALUE '|'.
           05  FILLER                        PIC X(2)  VALUE SPACES.
           05  FILLER                        PIC X(42) VALUE
               'Summe der zu lieferenden Artikel:         '.
           05  VERSANDFUSS-MENGE             PIC ZZZ999.
           05  FILLER                        PIC X(20) VALUE SPACE.
           05  FILLER                        PIC X     VALUE '|'.
       01  FEHLERZEILE.
           05  FILLER                        PIC X     VALUE '|'.
           05  FEHLERMELDUNG                 PIC X(70).
           05  FILLER                        PIC X     VALUE '|'.
       01  FEHLERMELDUNGEN.
           05  FM-1                          PIC X(50) VALUE
              '   Lieferungsdaten sind fehlerhaft              '.
           05  FM-2                          PIC X(50) VALUE
              '   Anzahl Lieferposten stimmt nicht ueberein    '.
           05  FM-3                          PIC X(50) VALUE
              '   Lieferung darf nicht erfolgen !!!            '.
      ************************************************************
      ************************************************************
       PROCEDURE DIVISION.
      *****************************************************
       VERSANDSTEUERUNG SECTION.
      *****************************************************
       INIT-VERSAND.
           MOVE 'Versandauftrag   ' TO KOPFZEILE-TITEL.
           MOVE 'Auftragsbearbeitung ' TO KOPFZEILE-PROGRAM.
           MOVE VERSANDTITEL TO TITELZEILE-7.
           PERFORM OPEN-LISTE.
           EXIT.
      *****************************************************
       OPEN-VERSANDPOSTEN.
           MOVE ZEROES TO VERSANDPOSTEN-STATUS.
           OPEN INPUT VERSANDPOSTENDATEI.
           IF VERSANDPOSTEN-STATUS NOT = ZEROES
              DISPLAY 'VERSANDPOSTENDATEI not found'
              DISPLAY 'Press Enter to terminate !'
              ACCEPT  CONTINUE-KEY
              STOP RUN
           END-IF.
      *****************************************************
       READ-VERSANDPOSTEN.
           MOVE ZEROES TO VERSANDPOSTEN-STATUS.
           PERFORM UNTIL EOF-VERSANDPOSTEN
              READ VERSANDPOSTENDATEI
              AT END MOVE '09' TO VERSANDPOSTEN-STATUS
              NOT AT END
                  EVALUATE SATZKZ
                     WHEN 'VK'
                        PERFORM DRUCKE-VERSANDKOPF
                     WHEN 'VP'
                        PERFORM DRUCKE-VERSANDPOSTEN
                     WHEN 'VF'
                        PERFORM DRUCKE-VERSANDFUSS
                     WHEN OTHER
                        DISPLAY 'Ungltige Versandsatzart=' SATZKZ
                        DISPLAY 'Press Enter to acknowledge!'
                        ACCEPT  CONTINUE-KEY
                  END-EVALUATE
              END-READ
              MOVE AUFTRAGNR TO LETZTE-AUFTRAGNR
              MOVE KUNDENNR  TO LETZTE-KUNDENNR
           END-PERFORM.
           EXIT.
      *****************************************************
       CLOSE-VERSANDPOSTEN.
           CLOSE VERSANDPOSTENDATEI
           STOP RUN.
      *****************************************************************
      *****************************************************************
       VERSANDAUSGABE   SECTION.
      *****************************************************
       DRUCKE-VERSANDKOPF.
           ADD  1 TO VERSAND-NR
           MOVE VERSAND-NR TO VERSANDKOPF-RECHNR
           MOVE AUFTRAGNR TO VERSANDKOPF-AUFTRAGNR
           MOVE KUNDENNR TO VERSANDKOPF-KUNDENKZ
           MOVE KUNDENNAME TO  VERSANDKOPF-KUNDENNAME
           MOVE KUNDEN-PLZ TO  VERSANDKOPF-PLZ
           MOVE KUNDEN-ORT TO  VERSANDKOPF-ORT
           MOVE KUNDEN-STRASSE TO  VERSANDKOPF-STRASSE
           MOVE KUNDEN-LAND TO  VERSANDKOPF-LAND
           EVALUATE KUNDENVERSAND
               WHEN 3
                   MOVE VERSANDMODUS-1 TO VERSANDKOPF-VERSANDMODUS
               WHEN 2
                   MOVE VERSANDMODUS-2 TO VERSANDKOPF-VERSANDMODUS
               WHEN 1
                   MOVE VERSANDMODUS-3 TO VERSANDKOPF-VERSANDMODUS
               WHEN OTHER
                   MOVE VERSANDMODUS-4 TO VERSANDKOPF-VERSANDMODUS
           END-EVALUATE
           PERFORM PRINT-HEADER
           MOVE ZERO TO GESAMTMENGE
           MOVE ZERO TO VERSAND-POSTEN-NR.
      *****************************************************
       DRUCKE-VERSANDPOSTEN.
           IF  AUFTRAGNR = LETZTE-AUFTRAGNR
           AND KUNDENNR = LETZTE-KUNDENNR
              ADD 1 TO VERSAND-POSTEN-NR
              ADD BESTELLMENGE TO GESAMTMENGE
              MOVE BESTELLNR TO VERSANDZEILE-BESTELLNR
              MOVE ARTIKELNR TO VERSANDZEILE-ARTIKELNR
              MOVE ARTIKELNAME TO VERSANDZEILE-ARTIKELNAME
              MOVE BESTELLMENGE TO VERSANDZEILE-BESTELLMENGE
              MOVE VERSANDPOSTENZEILE TO VERSANDZEILE
              PERFORM PRINT-LINE
           END-IF.
      *****************************************************
       DRUCKE-VERSANDFUSS.
           IF VERSAND-POSTEN-NR = VERSANDPOST-VF
              MOVE GESAMTMENGE TO VERSANDFUSS-MENGE
              MOVE VERSANDFUSS-1 TO FUSSZEILE-2
           ELSE
              MOVE FM-1 TO FEHLERMELDUNG
              MOVE FEHLERZEILE TO FUSSZEILE-2
           END-IF.
           PERFORM PRINT-FOOTING
           PERFORM PAGE-CHANGE.
           EXIT.
      *****************************************************************
      *****************************************************************
       SUBROUTINES SECTION.
      *****************************************************
       OPEN-LISTE.
           OPEN OUTPUT VERSANDDATEI.
           ACCEPT TAGESDATUM FROM DATE.
           MOVE TAG TO LISTENTAG.
           MOVE MONAT TO LISTENMONAT.
           MOVE JAHR TO LISTENJAHR.
           MOVE LISTENDATUM TO KOPFZEILE-DATUM.
           MOVE SEITENNR TO KOPFZEILE-SEITE.
           MOVE VERSANDPROGRAM TO KOPFZEILE-PROGRAM
           MOVE VERSANDTITEL TO TITELZEILE-7
           EXIT.
      *****************************************************
       PRINT-HEADER.
           MOVE SEITENNR TO KOPFZEILE-SEITE
           WRITE VERSANDSATZ FROM KOPFZEILE-1
           WRITE VERSANDSATZ FROM KOPFZEILE-2
           WRITE VERSANDSATZ FROM KOPFZEILE-3
           WRITE VERSANDSATZ FROM KOPFZEILE-4
           WRITE VERSANDSATZ FROM KOPFZEILE-2
           WRITE VERSANDSATZ FROM KOPFZEILE-1
           WRITE VERSANDSATZ FROM TITELZEILE-7
           WRITE VERSANDSATZ FROM TITELZEILE-8
           WRITE VERSANDSATZ FROM VERSANDKOPF-1
           WRITE VERSANDSATZ FROM VERSANDKOPF-2
           WRITE VERSANDSATZ FROM VERSANDKOPF-3
           WRITE VERSANDSATZ FROM VERSANDKOPF-4
           WRITE VERSANDSATZ FROM VERSANDKOPF-5
           WRITE VERSANDSATZ FROM KOPFZEILE-1
           WRITE VERSANDSATZ FROM VERSANDPOSTENTITEL
           WRITE VERSANDSATZ FROM KOPFZEILE-1
           MOVE 16 TO ZEILENANZAHL
           ADD 1 TO SEITENNR.
           EXIT.
      *****************************************************
       PRINT-LINE.
           MOVE VERSANDPOSTENZEILE TO VERSANDZEILE.
           WRITE VERSANDSATZ.
           ADD 1 TO ZEILENANZAHL
           EXIT.
      *****************************************************
       PRINT-FOOTING.
           WRITE VERSANDSATZ FROM FUSSZEILE-1
           WRITE VERSANDSATZ FROM FUSSZEILE-2
           WRITE VERSANDSATZ FROM FUSSZEILE-1
           ADD 3 TO ZEILENANZAHL
           EXIT.
      *****************************************************
       PAGE-CHANGE.
           MOVE SPACES TO VERSANDSATZ
           MOVE  '/' TO VERSANDSATZ
           WRITE VERSANDSATZ AFTER PAGE.
           EXIT.
      * end of source
      ******************************************************************
