       IDENTIFICATION DIVISION.
       PROGRAM-ID. XM059.
      ****************************************************************
      *  XM059   EWIGER KALENDER 1901 - 1999
      *  PARAMETER
      *  ---------
      *        P1: DATUM TT,MM,JJ            8 BYTES  AN
      *
      *        P2: SPRACHCODE 1,2,3
      *           WENN UNGUELTIG = 1         1 BYTE   AN
      *
      *        P3: ALINIERUNG L (LINKS)
      *                       R (RECHTS)
      *             WENN UGUELTIG = L        1 BYTE   AN
      *        P4: WOCHENTAG OUTPUT     10 BYTES  AN
      *
      *        WENN P1 NICH PLAUSIBEL, WIRD P4 MIT '?' GEFUELLT
      *
      *        DIESER KALENDER BERUHT AUF DER TATSACHE, DASS AM
      *        1. JANUAR 1901   D I E N S T A G   WAR.
      ****************************************************************
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
      ***************************************************************
       01  DDMMYY.
           02 DD        PIC 99.
           02 MM        PIC 99.
SNEED      02 CE        PIC 99.
           02 YY        PIC 99.
       01  P16          PIC X.
       01  DATUM-NUMBERS.
           02 DDP       PIC 999 COMP-3.
           02 MMP       PIC 999 COMP-3.
           02 YYP       PIC 999 COMP-3.
           02 DDB       PIC S9999 COMP.
           02 MMB       PIC S9999 COMP.
           02 YYB       PIC S9999 COMP.
       01  WORK-DATA-1.
           02 SPC       PIC 9.
           02 LRS       PIC X.
           02 DOPP      PIC S9(15) COMP-3 VALUE 0.
           02 YTT       PIC S9(8) COMP VALUE -1.
           02 STT       PIC S9(8) COMP VALUE 0.
           02 MTT       PIC S9(8) COMP VALUE 0.
           02 TTT       PIC S9(8) COMP VALUE 0.
       01  WW.
           02 W1        OCCURS 10 TIMES PIC X.
      *
      ***************************************************************
      *
       01  WOTAB.
           02 FILLER PIC X(30) VALUE 'DIENSTAG  MARDI     MARTEDI   '.
           02 FILLER PIC X(30) VALUE 'MITTWOCH  MERCREDI  MERCOLEDI '.
           02 FILLER PIC X(30) VALUE 'DONNERSTAGJEUDI     GIOVEDI   '.
           02 FILLER PIC X(30) VALUE 'FREITAG   VENDREDI  VENERDI   '.
           02 FILLER PIC X(30) VALUE 'SAMSTAG   SAMEDI    SABATO    '.
           02 FILLER PIC X(30) VALUE 'SONNTAG   DIMANCHE  DOMENICA  '.
           02 FILLER PIC X(30) VALUE 'MONTAG    LUNDI     LUNEDI    '.
       01  WOTAB-REDEF  REDEFINES WOTAB.
           02 DAYS-3    OCCURS 7 TIMES.
              03 LANG-1 PIC X(10).
              03 LANG-2 PIC X(10).
              03 LANG-3 PIC X(10).
       01  TATAB.
           02 FILLER       PIC S9999 COMP VALUE 0.
      *  DC    H'31'
1          02 FILLER    PIC S9999 COMP VALUE 31.
      *  DC    H'59'
2          02 FILLER    PIC S9999 COMP VALUE 59.
      *  DC    H'90'
3          02 FILLER    PIC S9999 COMP VALUE 90.
      *  DC    H'120'
4          02 FILLER    PIC S9999 COMP VALUE 120.
      *  DC    H'151'
5          02 FILLER    PIC S9999 COMP VALUE 151.
      *  DC    H'181'
6          02 FILLER    PIC S9999 COMP VALUE 181.
      *  DC    H'212'
7          02 FILLER    PIC S9999 COMP VALUE 212.
      *  DC    H'243'
8          02 FILLER    PIC S9999 COMP VALUE 243.
      *  DC    H'273'
9          02 FILLER    PIC S9999 COMP VALUE 273.
      *  DC    H'304'
10         02 FILLER    PIC S9999 COMP VALUE 304.
      *  DC    H'334'
11         02 FILLER    PIC S9999 COMP VALUE 334.
      *  DC    X'FF'
       01  TATAB-RED    REDEFINES TATAB.
           02 TATAB-1   OCCURS 12 TIMES PIC S9999 COMP.
       01  WORK-DATA-2.
           02 R1        PIC S9(8) COMP.
           02 R9        PIC S9(8) COMP.
           02 R8        PIC S9(8) COMP.
           02 TAB-I     PIC S9(4) COMP.
           02 W-I       PIC S9(4) COMP.
      *
WRAP  *LINKAGE SECTION.
WRAP   01  xm059-PARAMS.
       02  P1.
           03 P1-TT     PIC 99.
           03 P1-MM     PIC 99.
SNEED      03 P1-CE     PIC 99.
           03 P1-JJ     PIC 99.
       02  P2.
           03 LANG-CODE PIC 9.
       02  P3.
           03 DIRECTION PIC X.
       02  P4.
           03 DAY-NAME  PIC X(10).
      *********** COBWRAP XML  parameters ***********************
XMLINS 01 XML-PARAMS.
          05  XML-FUNCODE              PIC XX.
          05  XML-RETCODE              PIC 99.
          05  XML-FILNAME              PIC X(8).
COBINS 01 X-COBOL-PARAMS.
          05  X-REC-LNG                PIC 999.
          05  X-MAP-LNG                PIC 999.
          05  X-ACCEPT-LNG             PIC 999.
          05  X-DISPLAY-LNG            PIC 999.
          05  X-ACCEPT-TEXT            PIC X(80).
          05  X-DISPLAY-TEXT           PIC X(80).
      ***********************************************************
WRAP  *PROCEDURE DIVISION USING P1 P2 P3 P4.
WRAP   PROCEDURE DIVISION.
WRAP   xm059-WRAPPED-ENTRY.
WRAP       MOVE 'RD' TO XML-FUNCODE
WRAP       MOVE ZEROES TO XML-RETCODE
WRAP       MOVE 'xm059I' TO XML-FILNAME
WRAP       MOVE 2048 TO X-REC-LNG
WRAP       CALL 'xm059I  ' USING XML-FUNCODE, XML-RETCODE, XML-FILNAME,
WRAP                             xm059-PARAMS,
WRAP                             X-REC-LNG.
       XM059-A.
           MOVE P1-TT TO DD
           MOVE P1-MM TO MM
           MOVE P1-JJ TO YY
           MOVE LANG-CODE TO SPC
           MOVE DIRECTION TO LRS
           MOVE '0' TO P16
           IF P16 NOT = '0'
             MOVE ALL '?' TO DAY-NAME
WRAP       MOVE 'WR' TO XML-FUNCODE
WRAP       MOVE ZEROES TO XML-RETCODE
WRAP       MOVE 'xm059O' TO XML-FILNAME
WRAP       MOVE 2048 TO X-REC-LNG
WRAP       CALL 'xm059O  ' USING XML-FUNCODE, XML-RETCODE, XML-FILNAME,
WRAP                             xm059-PARAMS,
WRAP                             X-REC-LNG
             GOBACK
           END-IF.
           IF SPC = 1
           OR SPC = 2
           OR SPC = 3
             CONTINUE
           ELSE
             MOVE 1 TO SPC
           END-IF
           IF LRS = 'L'
           OR LRS = 'R'
             CONTINUE
           ELSE
             MOVE 'L' TO LRS
           END-IF
           MOVE DD TO DDP
           MOVE MM TO MMP
           MOVE YY TO YYP
           MOVE DDP TO DDB
           MOVE MMP TO MMB
           MOVE YYP TO YYB.
       XM059-B.
           COMPUTE YTT = ( YYB - 1 ) * 365
           MOVE YYB TO R9 R8
           COMPUTE R9 = R9 / 4
           COMPUTE R8 = R8 - 4 * R9
           IF R8 = 0 AND MMB <= 2
             SUBTRACT 1 FROM R9
           END-IF
           MOVE R9 TO STT
TEST       MOVE MMB TO TAB-I
T          IF TAB-I < 1 OR TAB-I > 12
T            DISPLAY 'ERROR IN XM059, TATAB INDEX: ' TAB-I '  ERDOES'
T            MOVE ALL 'X' TO DAY-NAME
WRAP       MOVE 'WR' TO XML-FUNCODE
WRAP       MOVE ZEROES TO XML-RETCODE
WRAP       MOVE 'xm059O' TO XML-FILNAME
WRAP       MOVE 2048 TO X-REC-LNG
WRAP       CALL 'xm059O  ' USING XML-FUNCODE, XML-RETCODE, XML-FILNAME,
WRAP                             xm059-PARAMS,
WRAP                             X-REC-LNG
T            GOBACK
           END-IF
           MOVE TATAB-1 (TAB-I) TO MTT
           COMPUTE R9 = YTT + STT + MTT + DDB
           COMPUTE R1 = R9 / 7
           COMPUTE R8 = 7 * R1
           COMPUTE TAB-I = R9 - R8
           IF TAB-I = 0
             MOVE 7 TO TAB-I
TEST       END-IF
T          IF TAB-I < 1 OR TAB-I > 7
T            DISPLAY 'ERROR IN XM059, WOTAB INDEX: ' TAB-I '  ERDOES'
T            MOVE ALL 'X' TO DAY-NAME
WRAP       MOVE 'WR' TO XML-FUNCODE
WRAP       MOVE ZEROES TO XML-RETCODE
WRAP       MOVE 'xm059O' TO XML-FILNAME
WRAP       MOVE 2048 TO X-REC-LNG
WRAP       CALL 'xm059O  ' USING XML-FUNCODE, XML-RETCODE, XML-FILNAME,
WRAP                             xm059-PARAMS,
WRAP                             X-REC-LNG
T            GOBACK
T          END-IF.
       XM059-C.
           EVALUATE TRUE
             WHEN SPC = 1
               MOVE LANG-1 (TAB-I) TO DAY-NAME
             WHEN SPC = 2
               MOVE LANG-2 (TAB-I) TO DAY-NAME
             WHEN SPC = 3
               MOVE LANG-3 (TAB-I) TO DAY-NAME
           END-EVALUATE
           IF LRS = 'L'
             CONTINUE
           ELSE
             MOVE DAY-NAME TO WW
             MOVE 10 TO TAB-I
             PERFORM WITH TEST BEFORE UNTIL W1 (TAB-I) NOT = SPACE
               SUBTRACT 1 FROM TAB-I
             END-PERFORM
             PERFORM WITH TEST BEFORE VARYING W-I FROM 10 BY -1
                                      UNTIL TAB-I = 0 OR TAB-I = 10
               MOVE W1 (TAB-I) TO W1 (W-I)
               MOVE SPACE TO W1 (TAB-I)
               SUBTRACT 1 FROM TAB-I
             END-PERFORM
             MOVE WW TO DAY-NAME
           END-IF.
WRAP       MOVE 'WR' TO XML-FUNCODE
WRAP       MOVE ZEROES TO XML-RETCODE
WRAP       MOVE 'xm059O' TO XML-FILNAME
WRAP       MOVE 2048 TO X-REC-LNG
WRAP       CALL 'xm059O  ' USING XML-FUNCODE, XML-RETCODE, XML-FILNAME,
WRAP                             xm059-PARAMS,
WRAP                             X-REC-LNG
           GOBACK.
