       IDENTIFICATION DIVISION.
       PROGRAM-ID. DRIVER.
      ****************************************************************
      *  XM059   EWIGER KALENDER 1901 - 1999
      *  PARAMETER
      *  ---------
      *        P1: DATUM TT,MM,JJ            8 BYTES  AN
      *
      *        P2: SPRACHCODE 1,2,3
      *           WENN UNGUELTIG = 1         1 BYTE   AN
      *
      *        P3: ALINIERUNG L (LINKS)
      *                       R (RECHTS)
      *             WENN UGUELTIG = L        1 BYTE   AN
      *        P4: WOCHENTAG OUTPUT     10 BYTES  AN
      *
      *        WENN P1 NICH PLAUSIBEL, WIRD P4 MIT '?' GEFUELLT
      *
      *        DIESER KALENDER BERUHT AUF DER TATSACHE, DASS AM
      *        1. JANUAR 1901   D I E N S T A G   WAR.
      ****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *
           SELECT COBOL-INPUT-FILE
           ASSIGN TO DYNAMIC INPUT-FILE
           ORGANIZATION IS LINE SEQUENTIAL
           ACCESS IS SEQUENTIAL
           FILE STATUS IS INPUT-STATUS.
      *
           SELECT COBOL-OUTPUT-FILE
           ASSIGN TO DYNAMIC OUTPUT-FILE
           ORGANIZATION IS LINE SEQUENTIAL
           ACCESS IS SEQUENTIAL
           FILE STATUS IS OUTPUT-STATUS.
      *
       DATA DIVISION.
      *
       FILE SECTION.
       FD  COBOL-INPUT-FILE
           RECORD CONTAINS 72 CHARACTERS
           DATA RECORD IS COBOL-INPUT-REC.
      *
       01  COBOL-INPUT-REC.
           05  TESTFALL               PIC 99.
           05  FILLER                 PIC X.
           05  DATUM.
               10  TT                 PIC 99.
               10  FILLER             PIC X.
               10  MM                 PIC 99.
               10  FILLER             PIC X.
               10  JH                 PIC 99.
               10  FILLER             PIC X.
               10  JJ                 PIC 99.
           05  FILLER                 PIC X.
           05  SPRACHE                PIC 9.
           05  FILLER                 PIC X.
           05  AUSRICHTUNG            PIC X.
           05  FILLER                 PIC X.
           05  WOCHENTAG              PIC X(10).
           05  FILLER                 PIC X(43).
      *
       FD  COBOL-OUTPUT-FILE
           RECORD CONTAINS 72 CHARACTERS
           DATA RECORD IS COBOL-OUTPUT-REC.
      *
       01  COBOL-OUTPUT-REC.
           05  TESTFALL-OUT           PIC 99.
           05  FILLER                 PIC X.
           05  MELDUNG                PIC X(40).
           05  FILLER                 PIC X(29).
      ***************************************************************
       WORKING-STORAGE SECTION.
      ***************************************************************
       77  INPUT-FILE                        PIC X(60).
       77  OUTPUT-FILE                       PIC X(60).
       77  INPUT-STATUS                      PIC XX.
           88 INPUT-CLOSED                   VALUE '00'.
           88 INPUT-OPEN                     VALUE '01'.
           88 INPUT-EOF                      VALUE '09'.
       77  OUTPUT-STATUS                     PIC XX.
           88 OUTPUT-CLOSED                  VALUE '00'.
           88 OUTPUT-OPEN                    VALUE '01'.
           88 OUTPUT-EOF                     VALUE '09'.
       77  STOP-KEY                          PIC XX.
       77  TESTFALL-NR                       PIC 9999 VALUE ZERO.
       77  CORRECT-NR                        PIC 9999 VALUE ZERO.
       77  ERROR-NR                          PIC 9999 VALUE ZERO.
      *
      ***********************************************************
TEST***LINKAGE SECTION.
      ***********************************************************
       01  P1.
           02 P1-TT     PIC 99.
           02 FILLER    PIC X.
           02 P1-MM     PIC 99.
           02 FILLER    PIC X.
SNEED      02 P1-JH     PIC 99.
           02 FILLER    PIC X.
           02 P1-JJ     PIC 99.
       01  P2.
           02 LANG-CODE PIC 9.
       01  P3.
           02 DIRECTION PIC X.
       01  P4.
           02 DAY-NAME  PIC X(10).
      ***************************************************************
       PROCEDURE DIVISION.
      ***************************************************************
       TEST-INIT.
           DISPLAY ' Submit Input  File Name '
           ACCEPT  INPUT-FILE.
           DISPLAY ' Submit Output File Name '
           ACCEPT  OUTPUT-FILE.
           MOVE ZEROES TO INPUT-STATUS
           OPEN INPUT COBOL-INPUT-FILE
           IF INPUT-STATUS NOT = ZEROES
              DISPLAY 'Input File not found !! '
              DISPLAY 'Press Enter to Terminate'
              ACCEPT  STOP-KEY
              GOBACK
           ELSE
              MOVE '01' TO INPUT-STATUS
           END-IF.
           MOVE ZEROES TO OUTPUT-STATUS
           OPEN OUTPUT COBOL-OUTPUT-FILE.
           MOVE '01' TO OUTPUT-STATUS.
      ***************************************************************
       TEST-LOOP.
TEST       DISPLAY 'Start Test '
TEST       ACCEPT STOP-KEY.
           PERFORM UNTIL INPUT-EOF
              READ COBOL-INPUT-FILE
              AT END
                 MOVE '09' TO INPUT-STATUS
              NOT AT END
                 ADD 1 TO TESTFALL-NR
                 MOVE TT TO P1-TT
                 MOVE MM TO P1-MM
                 MOVE JH TO P1-JH
                 MOVE JJ TO P1-JJ
                 MOVE SPRACHE TO LANG-CODE
                 MOVE AUSRICHTUNG TO DIRECTION
                 MOVE SPACES TO DAY-NAME
      ***
                 DISPLAY 'Call Testobject, Testfall = ' TESTFALL
                 ACCEPT STOP-KEY
                 CALL 'XM059' USING P1, P2, P3, P4
      ***
                 MOVE TESTFALL TO TESTFALL-OUT
                 IF DAY-NAME = WOCHENTAG
                    MOVE ' Output ok ' TO MELDUNG
                    ADD 1 TO CORRECT-NR
                 ELSE
                    MOVE DAY-NAME TO MELDUNG
                    ADD 1 TO ERROR-NR
                 END-IF
                 WRITE COBOL-OUTPUT-REC
              END-READ
           END-PERFORM.
      ***************************************************************
       TEST-ENDE.
           CLOSE COBOL-OUTPUT-FILE.
           MOVE '00' TO OUTPUT-STATUS.
           CLOSE COBOL-INPUT-FILE.
           MOVE '00' TO INPUT-STATUS.
           DISPLAY 'Test Ended '
           DISPLAY 'Cases tested  = ' TESTFALL-NR
           DISPLAY 'Correct Cases = ' CORRECT-NR
           DISPLAY 'Error   Cases = ' ERROR-NR
           DISPLAY 'Press Enter to terminate!!'
           ACCEPT STOP-KEY.
           STOP RUN.
      ************************ End of Driver *************************
