       IDENTIFICATION DIVISION.
       PROGRAM-ID. XCOBINIT.
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      ***************************************************************
      *
      *    ON THE MAINFRAME THIS PROGRAM SHOULD RUN AT THE END OF
      *                THE JCL OF 'DEFINE CLUSTER'
      *
      *    ON THE PC THIS PROGRAM SHOULD RUN ONCE TO CREATE A NEW
      *               'XCOBMESS.DAT' INDEXED FILE
      ***************************************************************
      *
      *     Indexed File with one record per module tested
      *
           SELECT COBMESS-FILE ASSIGN TO 'XCOBMESS.dat'
                  ORGANIZATION IS INDEXED
                  ACCESS IS SEQUENTIAL
                  RECORD KEY IS COBMESS-KEY
                  FILE STATUS IS COBMESS-STAT.
      *
      ******************************************************************
      *
       DATA DIVISION.
      *
       FILE SECTION.
      *
      ******************************************************************
      *
       FD  COBMESS-FILE
           RECORD CONTAINS 4012 CHARACTERS
           DATA RECORD IS COBMESS-REC.
      *
       01  COBMESS-REC.
           05  COBMESS-KEY              PIC X(8).
           05  COBMESS-NODE-NR          PIC 9999.
           05  COBMESS-NODES            PIC X(4000).
      *
      ******************************************************************
      *
       WORKING-STORAGE SECTION.
      *
       77  CONTINUE-KEY                 PIC X.
       01  FILE-STATUS-VARS.
           05 COBMESS-STAT              PIC XX.
              88 COBMESS-OK             VALUE '00'.
      *
      ******************************************************************
      *
       PROCEDURE DIVISION.
      *
      ******************************************************************
      *
       COBINIT-MAIN SECTION.
       COBINIT-CONTROL.
           OPEN OUTPUT COBMESS-FILE
           IF COBMESS-OK
             INITIALIZE COBMESS-REC
             WRITE COBMESS-REC
               INVALID KEY
                 DISPLAY 'Write Error on COBMESS File ' COBMESS-STAT
                 DISPLAY 'Initialization of COBMESS File failed !!'
                 STOP RUN
             END-WRITE
             CLOSE COBMESS-FILE
           ELSE
             DISPLAY 'Open Error on COBMESS File ' COBMESS-STAT
             DISPLAY 'Initialization of COBMESS File failed !!'
             STOP RUN
           END-IF
           DISPLAY 'COBMESS File initialized '
           STOP RUN.
      *
      ******************************************************************
      *               End  of   Source
      ******************************************************************
