 XPLIMESS : PROCEDURE (XPLIINST_DATA);
 /******************************************************************/
 /*            Data Structure for  PLI  Program Instrumentation    */
 /*                                                                */
 /*       %INCLUDE = XPLIDATA in the instrumented program must be  */
 /*              the argument to the parameter XPLIINST_DATA       */
 /******************************************************************/
 /*INST */   DCL  1 XPLIINST_DATA,
 /*INST */          2 XMESS_IO             CHAR(2),
 /*INST */          2 XMESS_TAB,
 /*INST */            3 XTEST_OBJECT       CHAR(8),
 /*INST */            3 XNODE_NR           PIC '9999',
 /*INST */            3 XNODE_TAB,
 /*INST */              4 XNODE (1000)     PIC '999B';
 /*INST */   DCL  1 IO_CODES               STATIC,
 /*INST */          2 XMESS_READ           CHAR(2) INIT( 'RD'),
 /*INST */          2 XMESS_WRITE          CHAR(2) INIT( 'WR');
 /*INST ***********************************************************/
     /*
      *     LINE SEQUENTIAL FILE FOR MODULE TEST
      */
       DECLARE MESSDAT FILE STREAM ENV( RECSIZE (80) );
       DECLARE PLIMESS_REC         CHAR (80);
       DECLARE MESSDAT_NAME        CHAR (72) STATIC;
       DECLARE MESSDAT_OUT         CHAR (80) STATIC;
     /***********************************************************/
     /*     OUTPUT FILE FOR COVERAGE REPORT                     */
     /*                                                         */
       DECLARE TSREPO FILE STREAM OUTPUT ENV( RECSIZE(80));
       DECLARE TSREPO_NAME         CHAR (72);
       DECLARE TSEXPO FILE STREAM OUTPUT ENV( RECSIZE(80));
       DECLARE EXPORT_REC          CHAR (72);
       DECLARE TSEXPO_NAME         CHAR (72);
     /***********************************************************/
       DECLARE 1  XNODE_LINES      BASED(Q),
                  2 XNODE_LINE(50) CHAR(80);
       DECLARE Q  POINTER STATIC;
       DECLARE 1  OLD_XNODE_TAB,
                  2 PLIMESS_NODE(1000)  CHAR(4);
                                                                  /**/
       DECLARE 1  CONSTANTS             STATIC,
                  5 LINE_MAX            FIXED BIN (15) INIT (72),
                  5 NODE_MAX            FIXED BIN (15) INIT (1000);
                                                                  /**/
       DECLARE 1  VARIABLES             STATIC,
                  5 LINE_NR             FIXED BIN (15),
                  5 NODE_NR             FIXED BIN (15),
                  5 NR_HITS             FIXED BIN (15),
                  5 NR_MISSES           FIXED BIN (15),
                  5 NODE_SUM            FIXED BIN (31),
                  5 HIT_RATIO           FIXED DEC (5,2),
                  5 RET_CODE            PIC '99' INIT (0),
                  5  TODAYS_DATE        CHAR (6);
       DECLARE 1  CURRENT_DATUM         DEFINED TODAYS_DATE,
                  2 CURRENT_YEAR        PIC '99',
                  2 CURRENT_MONTH       PIC '99',
                  2 CURRENT_DAY         PIC '99';
       DECLARE NOT_EOF BIT (1);
       DECLARE DATE BUILTIN;
                                                    /*  INDEXES  */
       DECLARE ( I ,
                 J ,
                 L )                    FIXED BIN (15);
       DECLARE K                        FIXED BIN(15) STATIC;
                                                                  /*
      **************************************************************/
       DECLARE 1  COVERAGE_PRINT_LINES  STATIC,
                  5 HYPHEN_LINE,
                    10 FILL             CHAR (1) INIT ('+'),
                    10 FIL70            CHAR (70),
                    10 FILR             CHAR (1) INIT ('+'),
                  5 BLANK_LINE,
                    10 FILL             CHAR (1) INIT ('|'),
                    10 FIL70x           CHAR (70) INIT (' '),
                    10 FILR             CHAR (1) INIT ('|'),
                  5 TEXT_LINE,
                    10 FILL             CHAR (1) INIT ('|'),
                    10 FIL13            CHAR (13) INIT (' '),
                    10 FIL45            CHAR (45) INIT (
                    '  T E S T   C O V E R A G E  R E P O R T    '),
                    10 FIL12            CHAR (12) INIT (' '),
                    10 FILR             CHAR (1) INIT ('|'),
                  5 DATE_LINE,
                    10 FILL             CHAR (1) INIT ('|'),
                    10 FIL9             CHAR (9) INIT (' DATE: '),
                    10 DATUM,
                       20 TAG           PIC '99',
                       20 FIL           CHAR (1) INIT ('.'),
                       20 MONAT         PIC '99',
                       20 FILR          CHAR (1) INIT ('.'),
                       20 JAHR20        PIC '99' INIT(20),
                       20 JAHR          PIC '99',
                    10 FIL40            CHAR (38) INIT (' '),
                    10 FIL6             CHAR (6) INIT ('PAGE: '),
                    10 SEITE            PIC '99' INIT (0),
                    10 FIL5             CHAR (5) INIT (' '),
                    10 FILR             CHAR (1) INIT ('|'),
                  5 OBJECT_LINE,
                    10 FILL             CHAR (1) INIT ('|'),
                    10 FIL9             CHAR (9) INIT (' MODULE: '),
                    10 MODULE_NAME      CHAR (12),
                    10 FIL49            CHAR (49) INIT (' '),
                    10 FILR             CHAR (1) INIT ('|'),
                  5 TITLE_LINE,
                    10 FIL14A      CHAR (14) INIT ( '|     NODE_NR.' ),
                    10 FIL14B      CHAR (14) INIT ( '     PAST TEST' ),
                    10 FIL14C      CHAR (14) INIT ( '     THIS TEST' ),
                    10 FIL14D      CHAR (14) INIT ( '    TOTAL TEST' ),
                    10 FIL14E      CHAR (15) INIT ( '      MISSED  ' ),
                    10 FILR        CHAR (1)  INIT ('|'),
                  5 DATA_LINE,
                    10 FILL        CHAR (1)    INIT ('|'),
                    10 NODE_OUT    PIC 'ZZZZ9' INIT (0),
                    10 FILLE1      CHAR (10)   INIT (' '),
                    10 PAST_OUT    PIC 'ZZZZ9' INIT (0),
                    10 FILLE2      CHAR (10)   INIT (' '),
                    10 THIS_OUT    PIC 'ZZZZ9' INIT (0),
                    10 FILLE3      CHAR (10)   INIT (0),
                    10 SUM_OUT     PIC 'ZZZZ9' INIT (0),
                    10 FILLE4      CHAR (10)   INIT (' '),
                    10 MISSED_OUT  CHAR (1)    INIT ('*'),
                    10 FILLE5      CHAR (9)    INIT (' '),
                    10 FILR        CHAR (1)    INIT ('|'),
                  5 END_LINE_1,
                    10 FILL        CHAR (5)    INIT ('|'),
                    10 FILLE40     CHAR (40)   INIT (
                    'TOTAL NUMBER OF TEST PROBES INSERTED =  '),
                    10 TOTAL_PROBES PIC 'ZZZZ9' INIT (0),
                    10 FILLE21     CHAR (21)  INIT (' '),
                    10 FILR        CHAR (1) INIT ('|'),
                  5 END_LINE_2,
                    10 FILL        CHAR (5) INIT ('|'),
                    10 FILLE40     CHAR (40) INIT (
                    'TOTAL NUMBER OF TEST PROBES EXECUTED =  '),
                    10 TOTAL_HITS  PIC 'ZZZZ9' INIT (0),
                    10 FILLE21     CHAR (21)  INIT (' '),
                    10 FILR        CHAR (1) INIT ('|'),
                  5 END_LINE_3,
                    10 FILL        CHAR (5) INIT ('|'),
                    10 FILLE40     CHAR (40) INIT (
                    'TOTAL NUMBER OF TEST PROBES MISSED   =  '),
                    10 TOTAL_MISSES PIC 'ZZZZ9' INIT (0),
                    10 FILLE21     CHAR (21)  INIT (' '),
                    10 FILR        CHAR (1) INIT ('|'),
                  5 END_LINE_4,
                    10 FILL        CHAR (5) INIT ('|'),
                    10 FILLE40     CHAR (40) INIT (
                    'TEST COVERAGE RATIO FOR THIS MODULE  =  '),
                    10 TEST_RATIO  PIC 'Z9.V99' INIT (0),
                    10 FILLE21     CHAR (21)  INIT (' '),
                    10 FILR        CHAR (1) INIT ('|');
      /*
      ****************************************************************
      */
       DCL 1 METRIK_AUSGABE    STATIC,
             5 ZEILE_1,
               7 TEXT_1        CHAR (12) INIT ('/FILENAME = '),
               7 ZUWEISUNG_1   CHAR (50),
             5 ZEILE_2,
               7 TEXT_2        CHAR (12) INIT ('/USERID   = '),
               7 ZUWEISUNG_2   CHAR (50),
             5 ZEILE_3,
               7 TEXT_3        CHAR (12) INIT ('/DATE     = '),
               7 ZUWEISUNG_3   CHAR (50),
             5 ZEILE_4,
               7 TEXT_4        CHAR (12) INIT ('/FROM     = '),
               7 ZUWEISUNG_4   CHAR (50) INIT ('PLITEST'),
             5 ZEILE_5,
               7 TEXT_5        CHAR (12) INIT ('/TO       = '),
               7 ZUWEISUNG_5   CHAR (50) INIT ('PC_MESS'),
             5 ZEILE_6,
               7 TEXT_6        CHAR (12) INIT ('//ENTITY = '),
               7 ZUWEISUNG_6   CHAR (50) INIT ('TEST; '),
             5 ZEILE_7,
               7 TEXT_7        CHAR (12) INIT ('  ENAME  = '),
               7 ZUWEISUNG_7,
                 10 ZUW_71     CHAR (12),
                 10 FILLER     CHAR (48) INIT (' '),
             5 ZEILE_8,
               7 TEXT_8        CHAR (12) INIT ('  EDATE  = '),
               7 ZUWEISUNG_8,
                 10 ZUW_81     CHAR (10),
                 10 ZUW_82     CHAR  INIT (';'),
                 10 FILLER     CHAR (50) INIT (' '),
             5 ZEILE_9,
               7 TEXT_9        CHAR (12) INIT ('  ETYPE  = '),
               7 ZUWEISUNG_9,
                 10 ZUW_91     CHAR (8),
                 10 FILLER     CHAR (52) INIT (' '),
             5 ZEILE_11,
               7 TEXT_11       CHAR (11) INIT ('  ATTR = ( '),
               7 ZUWEISUNG_11,
                 15  Z_SPALTE1_1   CHAR (8) INIT ('NODES   '),
                 15  Z_SPALTE1_2   CHAR (1) INIT ('='),
                 15  Z_SPALTE1_3   PIC 'ZZZZZ999',
                 15  Z_SPALTE1_4   CHAR (3) INIT (',  '),
                 15  Z_SPALTE1_5   CHAR (8) INIT ('HITS    '),
                 15  Z_SPALTE1_6   CHAR (1) INIT ('='),
                 15  Z_SPALTE1_7   PIC 'ZZZZZ999',
                 15  Z_SPALTE1_8   CHAR (3) INIT (',  '),
                 15  Z_SPALTE1_9   CHAR (8) INIT ('RATIO   '),
                 15  Z_SPALTE1_10  CHAR (1) INIT ('='),
                 15  Z_SPALTE1_11  PIC 'ZZ9.V99',
                 15  Z_SPALTE4_11  CHAR (6) INIT (' );');
       DECLARE REPORT_RECORD       STATIC CHAR(72);
       DECLARE FIRST_CALL BIT (1) STATIC INIT ('1'B);
      /***************************************************************/
      IF FIRST_CALL THEN
        DO;
        TODAYS_DATE = DATE;
        JAHR = CURRENT_YEAR;
        MONAT = CURRENT_MONTH;
        TAG = CURRENT_DAY;
        Q = ADDR (XNODE_TAB);
        K = INDEX (XTEST_OBJECT || ' ' ,  ' ') - 1;
        MESSDAT_NAME = '/' || SUBSTR (XTEST_OBJECT, 1, K) || '.MES';
        MESSDAT_OUT = '/' || SUBSTR (XTEST_OBJECT, 1, K)
                          || '.MES,APPEND(N)';
        FIL70 = REPEAT ('-', 69);
        REPORT_RECORD= '|' || REPEAT( ' ', 69) || '|';
                                         /* Delete the old files */
        TSREPO_NAME = '/' || SUBSTR (XTEST_OBJECT, 1, K)
                          || '.REP,APPEND(N)';
        OPEN FILE (TSREPO) TITLE ( TSREPO_NAME );
        CLOSE FILE (TSREPO);
        OPEN FILE (TSEXPO) TITLE ( '/TSEXPORT,APPEND(N)' );
        CLOSE FILE (TSEXPO);
        END;
       IF XMESS_IO = XMESS_READ THEN
         DO;
         IF FIRST_CALL THEN
           DO;
           FIRST_CALL = '0'B;
           CALL PLIMESS_READ;
           END;
         OLD_XNODE_TAB = XNODE_TAB;
         END;
       ELSE
         IF XMESS_IO = XMESS_WRITE THEN
           DO;
           CALL PLIMESS_WRITE;
           CALL PLIMESS_EXPORT;
           CLOSE FILE (MESSDAT);
           END;
     /*
      ******************************************************************
                           PLIMESS SUBROUTINES
      ******************************************************************
      */
 PLIMESS_READ : PROC;
       NOT_EOF = '1'B;
       ON ENDFILE (MESSDAT) NOT_EOF = '0'B;
       ON UNDEFINEDFILE (MESSDAT) BEGIN;
         XNODE = 0;
         NOT_EOF = '0'B;
         PUT EDIT ( 'Coverage records for ' , XTEST_OBJECT ,
                    ' will be created  ' )
                  ( SKIP, A (21), A ,  A );
       END;
       OPEN FILE (MESSDAT) INPUT TITLE ( MESSDAT_NAME );
       IF NOT_EOF THEN
         GET FILE(MESSDAT) EDIT (XNODE_NR) ( F(4) );
       DO I = 1 BY 1 WHILE (NOT_EOF);
         GET FILE (MESSDAT) EDIT ( XNODE_LINE (I) )( SKIP, A(80));
       END;
       CLOSE FILE (MESSDAT);
    END; /* PLIMESS_READ */
  /***************************************************************
   */
 PLIMESS_WRITE : PROC;
       OPEN FILE (MESSDAT) OUTPUT TITLE ( MESSDAT_OUT );
       PUT FILE(MESSDAT) EDIT (XNODE_NR) ( F(4) );
       I = 1;
       DO J = 1 BY 20 WHILE ( J <= XNODE_NR );
         PUT FILE (MESSDAT) EDIT ( XNODE_LINE (I) )( SKIP, A(80));
         I = I + 1;
       END;
  /*
                  WRITE CURRENT COVERAGE REPORT
   */
       CALL PLIMESS_REPORT;
    END; /* PLIMESS_WRITE */
  /*
   ************************************************************
   */
 PLIMESS_REPORT : PROC;
       TSREPO_NAME = '/' || SUBSTR (XTEST_OBJECT, 1, K) || '.REP';
       OPEN FILE (TSREPO) TITLE ( TSREPO_NAME );
       MODULE_NAME = XTEST_OBJECT;
       SEITE = 0;
       CALL WRITE_PAGE_HEADER;
       NR_HITS = 0;
       NR_MISSES = 0;
       IF XNODE_NR > NODE_MAX THEN
         K = NODE_MAX;
       ELSE
         L = XNODE_NR;
       DO I = 1 BY 1 TO L;
         NODE_OUT = I;
         PAST_OUT = PLIMESS_NODE (I);
         THIS_OUT = XNODE (I);
         NODE_SUM = PLIMESS_NODE (I) + XNODE (I);
         SUM_OUT = NODE_SUM;
         IF NODE_SUM = 0 THEN
           DO;
           MISSED_OUT = '*';
           NR_MISSES = NR_MISSES + 1;
           END;
         ELSE
           DO;
           MISSED_OUT = ' ';
           NR_HITS = NR_HITS + 1;
           END;
         PUT FILE (TSREPO) EDIT ( STRING(DATA_LINE)) (SKIP,A);
         LINE_NR = LINE_NR + 1;
         IF LINE_NR > LINE_MAX THEN
           CALL WRITE_PAGE_HEADER;
       END;
       PUT FILE (TSREPO) EDIT ( REPORT_RECORD ) (SKIP, A);
       PUT FILE (TSREPO) EDIT ( STRING(HYPHEN_LINE)) (SKIP, A);
  /*
                   COMPUTE TEST COVERAGE MEASURES
   */
       TOTAL_PROBES = XNODE_NR;
       TOTAL_HITS = NR_HITS;
       TOTAL_MISSES = NR_MISSES;
       HIT_RATIO = NR_HITS /  XNODE_NR;
       TEST_RATIO = HIT_RATIO;
  /*
                   PRINT OUT TEST COVERAGE MEASURES
   */
       LINE_NR = LINE_NR + 5;
       IF LINE_NR > LINE_MAX THEN
         CALL WRITE_PAGE_HEADER;
       PUT FILE(TSREPO) EDIT ( REPORT_RECORD) (SKIP, A);
       PUT FILE(TSREPO) EDIT ( STRING(END_LINE_1)) (SKIP,A);
       PUT FILE(TSREPO) EDIT ( STRING(END_LINE_2)) (SKIP,A);
       PUT FILE(TSREPO) EDIT ( STRING(END_LINE_3)) (SKIP,A);
       PUT FILE(TSREPO) EDIT ( STRING(END_LINE_4)) (SKIP,A);
       CLOSE FILE (TSREPO);
    END; /* PLIMESS_REPORT */
  /***************************************************************
  */
 WRITE_PAGE_HEADER : PROC;
       SEITE = SEITE + 1;
       PUT FILE (TSREPO) EDIT ( REPORT_RECORD) (SKIP,A);
       PUT FILE (TSREPO) EDIT ( STRING(HYPHEN_LINE)) (SKIP,A);
       PUT FILE (TSREPO) EDIT ( REPORT_RECORD) (SKIP,A);
       PUT FILE (TSREPO) EDIT ( STRING(TEXT_LINE)) (SKIP,A);
       PUT FILE (TSREPO) EDIT ( REPORT_RECORD) (SKIP,A);
       PUT FILE (TSREPO) EDIT ( STRING(DATE_LINE)) (SKIP,A);
       PUT FILE (TSREPO) EDIT ( STRING(OBJECT_LINE)) (SKIP,A);
       PUT FILE (TSREPO) EDIT ( REPORT_RECORD)(SKIP,A);
       PUT FILE (TSREPO) EDIT ( STRING(TITLE_LINE)) (SKIP,A);
       PUT FILE (TSREPO) EDIT ( STRING(HYPHEN_LINE)) (SKIP,A);
       LINE_NR = 10;
    END; /* WRITE_PAGE_HEADER */
      /*****************************************************************
      *      IO ROUTINES FOR EXPORT FILE                               *
      ******************************************************************
                                                                      */
 PLIMESS_EXPORT : PROC;
                                          /* OPEN METRIC FILE */
       OPEN FILE (TSEXPO) TITLE ( '/TSEXPORT' );
                                          /* WRITE METRIC FILE HEADER */
       J = INDEX (XTEST_OBJECT || ' ' , ' ') - 1;
       ZUWEISUNG_1 = 'TEST\' || SUBSTR (XTEST_OBJECT,1,J) || '.PCM';
       PUT FILE (TSEXPO) EDIT ( STRING(ZEILE_1)) (SKIP,A);
       ZUWEISUNG_2 = 'PLIINST';
       PUT FILE (TSEXPO) EDIT ( STRING(ZEILE_2)) (SKIP,A);
       ZUWEISUNG_3 = STRING (DATUM);
       PUT FILE (TSEXPO) EDIT ( STRING(ZEILE_3)) (SKIP,A);
       PUT FILE (TSEXPO) EDIT ( STRING(ZEILE_4)) (SKIP,A);
       PUT FILE (TSEXPO) EDIT ( STRING(ZEILE_5)) (SKIP,A);
                                          /* WRITE METRIC FILE ENTRY  */
       EXPORT_REC = ' ';
       PUT FILE (TSEXPO) EDIT ( STRING(EXPORT_REC)) (SKIP,A);
       PUT FILE (TSEXPO) EDIT ( STRING(ZEILE_6)) (SKIP,A);
       ZUW_71 = SUBSTR (XTEST_OBJECT, 1, J) || ';' ;
       PUT FILE (TSEXPO) EDIT ( STRING(ZEILE_7)) (SKIP,A);
       ZUW_81 = STRING (DATUM);
       PUT FILE (TSEXPO) EDIT ( STRING(ZEILE_8)) (SKIP,A);
       ZUW_91 = 'PLI';
       EXPORT_REC = ' ';
       PUT FILE (TSEXPO) EDIT ( STRING(EXPORT_REC)) (SKIP,A);
       PUT FILE (TSEXPO) EDIT ( STRING(ZEILE_9)) (SKIP,A);
       Z_SPALTE1_3 = XNODE_NR;
       Z_SPALTE1_7 = NR_HITS;
       Z_SPALTE1_11 = HIT_RATIO;
       PUT FILE (TSEXPO) EDIT ( STRING(ZEILE_11)) (SKIP,A);
                                          /* CLOSE METRIC FILE    */
       CLOSE FILE (TSEXPO);
   END; /* PLIMESS_EXPORT */
 END; /* XPLIMESS */
      /***************************************************************
      *               End  of   Source
      ****************************************************************/
